CField = function (papa,threads,gameGroup) {
    this.Papa = papa; //papa is Game
    this.Threads = threads;
    this.gameGroup = gameGroup;
    this.gameTopGroup = this.Papa.GameTopGroup;
    this.ActiveFlag = false;

    this.Buttons = [];
    this.Imgs = [];
    this.Texts = [];

    this.Xc = 0;
    this.Yc = 0;

    this.HandImg = null;

    this.ImgsNum  = 0;
    this.TextsNum = 0;
    this.ButtonsNum = 0;

    this.ShiftX = 0;
    this.ShiftY = 0;

    this.DistCellsMax = 0;

    this.Alpha = 1;
    this.Scale = 1;

    this.Pads = [];

    this.Pushers = [];
    this.PushersNum = 0;
    this.PusherLinesNum = 0;

    this.ChooseTypes = [];

    this.CellsNum = [];
    this.Cells = [];

    this.Flys = [];
    this.FlysNum = 0;
    this.FlysDist = 0;

    this.MatchesTemp = [];
    this.MatchesTempNum = 0;
    this.Matches = [];
    this.MatchesNums = [];
    this.MatchesNum = 0;

    this.HardEasy = [{hard:0.3,easy:0.3},{hard:0.2,easy:0.2},
        {hard:0,easy:0.5},{hard:0.5,easy:0},{hard:0.4,easy:0.2}];
    this.HardEasyIndex = 0;
    this.HardEasyCntr = 0;

    this.FishChooseRange = 6;
    this.FishChooseRangeCurr = this.FishChooseRange;

    this.SpeedUpMax = 150;
    this.SpeedUpFades = [800,400];
    this.SpeedUps = [150,200];

    this.Y_top = 114;
    this.Y_pushtop = 100; // varialbe
    this.Y_end = 725;// - Base.CellDiam/2;
    this.Y_coinmax = 725 - 3*Base.CellDiam/2;
    this.Y_field0 = 115;
    this.Y_field1 = 825;

    this.DangerDist = Base.CellDiam*1.5;

    this.X0 = Base.CellDiam/2;
    this.ColsNum = Base.GameCols;

    this.SpeedDown = 15;
    this.SpeedFlyUp = 1000;
    this.SpeedDownFlag = false;
    this.SpeedUpFlag = false;
    this.Y = 110;
    this.gameGroup.y = this.Y;

    this.Shifts = [];
    this.ShiftsNum = 0;

    this.Shift = 0;
    this.ShiftSpeed = 4;
    this.ShiftingFlag = false;

    this.FishFly = {col:0,img:null,dest:null,type:0};
    this.FishStay = {img:null,type:0};
    this.FishNext = {img:null,type:0};

    this.FlashUpFlag = false;
    this.FlashUpSpeed = 400;
    this.FlashUpDist = 450;

    this.Saves = [];

    this.ScaleFishki = 1;
    this.Fishki = [];
    this.FishkiNum = 0;

    this.FreenzyFlag = false;

    this.MergeAnimCntr = 0;
    this.MergesRowCntr = 0;

    this.HelpTypes = [0,1,0,1,0,0,1,0,2,1,0,2,1];
    this.HelpTypesIndex = 0;
};


CField.prototype.clearFishSaves = function() { // new
    for(var i=0;i<this.Saves.length;i++) {
        if(this.Saves[i].img!==null)
            this.Saves[i].img.visible = false;
        if(this.Saves[i].top!==null)
            this.Saves[i].top.visible = false;
    }
};


CField.prototype.getFishSave = function(type,group) {
     for(var i=0;i<this.Saves.length;i++) {
         if(this.Saves[i].type==type && this.Saves[i].img.visible==false &&
             this.Saves[i].group===group) {
            // console.log("from saved...");
             return this.Saves[i];
         }
     }
    var obj =  this.crateCellObj(type,group);

    this.Saves.push(obj);
    return obj;
};

CField.prototype.crateCellObj = function(type,group) {
    var obj = {img:null,top:null,type:type};
    obj.group = group;

    obj.img = this.Papa.game.make.image(0, 0, 'atlas', Base.FishPads[0]);
    obj.img.anchor.set(0.5);
    group.add(obj.img);

    if(type==1) {
        obj.top = this.Papa.game.add.group();
        group.add(obj.top);
    }
    else {
        obj.top = this.Papa.game.make.image(0, 0, 'atlas', Base.FishNums[0]);
        obj.top.anchor.set(0.5);
        group.add(obj.top);
    }
    return obj;
};

CField.prototype.killFish = function(cell,leaveImg) {
    if(cell.obj===null)  return;
    if(!leaveImg) cell.obj.img.visible = false;
    cell.obj.top.visible = false;
    cell.obj = null;
};

CField.prototype.init = function() {

    // celled once !!!
    for(var i=0;i<Base.GameCols;i++) {
        this.Pads[i] = {x: Base.Lines[i], y: Base.Y_bott,
            x0:Base.Lines[i]-Base.CellDiam/2,x1:Base.Lines[i]+Base.CellDiam/2};
        this.Cells[i] = [];
        this.CellsNum[i] = 0;
    }
    this.Pads[0].x0 = 0;
    this.Pads[Base.GameCols-1].x1 = Base.Width;

    this.FishFly.obj = this.crateCellObj(0,this.gameTopGroup);
    this.FishFly.obj.img.visible = false;
    this.FishFly.obj.top.visible = false;
        //this.Papa.getZeroImg(this.Pads[2].x,this.Pads[2].y,
      //  'atlas',Base.Fishki[0].frame,this.gameTopGroup,0);
 //   this.FishFly.img.visible = false;

    this.FishStay.x = this.Pads[2].x;
    this.FishStay.y = this.Pads[2].y;
    this.FishStay.obj = this.crateCellObj(0,this.gameTopGroup);
    this.FishStay.obj.img.x = this.FishStay.x;
    this.FishStay.obj.img.y = this.FishStay.y;
    this.FishStay.obj.top.x = this.FishStay.x;
    this.FishStay.obj.top.y = this.FishStay.y;
    this.FishStay.obj.img.visible = false;
    this.FishStay.obj.top.visible = false;

    this.FishNext.x = this.Pads[2].x;
    this.FishNext.y = this.Pads[2].y + 108;
    this.FishNext.obj = this.crateCellObj(0,this.gameTopGroup);
    this.FishNext.obj.img.x = this.FishNext.x;
    this.FishNext.obj.img.y = this.FishNext.y;
    this.FishNext.obj.img.scale.set(0.7);
    this.FishNext.obj.top.x = this.FishNext.x;
    this.FishNext.obj.top.y = this.FishNext.y;
    this.FishNext.obj.top.scale.set(0.7);
    this.FishNext.obj.img.visible = false;
    this.FishNext.obj.top.visible = false;

    this.FreenzyFlag = false;
    this.ReplayFlag = false;

    this.ActiveFlag = false;
};

CField.prototype.setHelp = function() {

    if(this.HelpFlag)  return; // new

    this.clearFishSaves(); // new

    if(this.HandImg==null)
        this.HandImg = this.Papa.getZeroImg(Base.Width/2,120,
           'atlas','pointer.png',this.gameGroup,0);
    this.HandImg.anchor.set(9/74,9/69);
    this.HandImg.visible = false;

    this.HelpCycleCntr = 0;
    this.HelpAppearCntr  = 0;
    this.HelpCycleCntr = 0;

    this.Threads.addThread(this,this.updateHand);

    // add fishki
    this.addFishToField(this.getColBottom(0).y,0,1,false);
    this.addFishToField(this.getColBottom(1).y,1,0,false);
    this.addFishToField(this.getColBottom(2).y,2,2,false);
    this.addFishToField(this.getColBottom(2).y,2,0,false);
    this.addFishToField(this.getColBottom(3).y,3,0,false);
    this.addFishToField(this.getColBottom(4).y,4,1,false);

    this.HelpTypesIndex = 0;
    this.setStayFish(this.FishStay,this.HelpTypes[this.HelpTypesIndex],false);
    this.HelpTypesIndex++;
    this.setStayFish(this.FishNext,this.HelpTypes[this.HelpTypesIndex],false);
    this.HelpTypesIndex++;

    this.setHandScaleIn(this.getColBottom(2));

    this.setAllFishScaleIn();

    this.HelpFlag = true;
};


CField.prototype.HelpCycle = function() {

    this.HelpCycleCntr++;

    if(this.HelpAppearCntr>3 && this.AllMatchesCntr>2) {
        this.StopHelp();
        Base.HelpFlag = false; // no more help
        this.Papa.Papa.saveAll();
        this.FishFlyCntr = 10; // to block 64 meanwhile
        return;
    }

    if(this.Y>570) return;

    var index,i;
  /*  if(this.HelpCycleCntr==1) {
        for(var i=1;i<Base.GameCols-1;i++) {
          //  index = i+1; if(index>=Base.GameCols) index -= Base.GameCols;
            if(this.CellsNum[i]==0) {
                this.setHandScaleIn(this.Pushers[i]);
                return;
            }
        }
        return;
    }*/

    //check for match
    for(i=1;i<Base.GameCols-1;i++) {
        //  index = i+1; if(index>=Base.GameCols) index -= Base.GameCols;
        if(this.CellsNum[i]>0 && (this.Cells[i][this.CellsNum[i] - 1].y+this.Y)<500)
            if(this.Cells[i][this.CellsNum[i] - 1].type==this.FishStay.type) {
                this.setHandScaleIn(this.Cells[i][this.CellsNum[i] - 1]);
                return;
            }
    }

    for(i=0;i<Base.GameCols;i++) {
        //  index = i+1; if(index>=Base.GameCols) index -= Base.GameCols;
        if(this.CellsNum[i]>0 && (this.Cells[i][this.CellsNum[i] - 1].y+this.Y)<500)
            if(this.Cells[i][this.CellsNum[i] - 1].type==this.FishStay.type) {
                this.setHandScaleIn(this.Cells[i][this.CellsNum[i] - 1]);
                return;
            }
    }

    // check for left or right case
    for(i=0;i<Base.GameCols;i++) {
        //  index = i+1; if(index>=Base.GameCols) index -= Base.GameCols;
            if((i-1)>=0 && this.CellsNum[i]<this.CellsNum[i-1] &&
            this.Cells[i-1][this.CellsNum[i]].type==this.FishStay.type)  {
                this.setHandScaleIn(this.getColBottom(i));
                return;
            }

        if((i+1)<Base.GameCols && this.CellsNum[i]<this.CellsNum[i+1] &&
            this.Cells[i+1][this.CellsNum[i]].type==this.FishStay.type)  {
            this.setHandScaleIn(this.getColBottom(i));
            return;
        }
    }

    // choose fish more on 1
    for(i=1;i<Base.GameCols-1;i++) {
        //  index = i+1; if(index>=Base.GameCols) index -= Base.GameCols;
        if(this.CellsNum[i]>0 && (this.Cells[i][this.CellsNum[i] - 1].y+this.Y)<500)
            if(this.Cells[i][this.CellsNum[i] - 1].type==(this.FishStay.type+1)) {
                this.setHandScaleIn(this.Cells[i][this.CellsNum[i] - 1]);
                return;
            }
    }

    for(i=0;i<Base.GameCols;i++) {
        //  index = i+1; if(index>=Base.GameCols) index -= Base.GameCols;
        if(this.CellsNum[i]>0 && (this.Cells[i][this.CellsNum[i] - 1].y+this.Y)<500)
            if(this.Cells[i][this.CellsNum[i] - 1].type==(this.FishStay.type+1)) {
                this.setHandScaleIn(this.Cells[i][this.CellsNum[i] - 1]);
                return;
            }
    }

    // choose fish more
    for(i=0;i<Base.GameCols;i++) {
        //  index = i+1; if(index>=Base.GameCols) index -= Base.GameCols;
        if(this.CellsNum[i]>0 && (this.Cells[i][this.CellsNum[i] - 1].y+this.Y)<500)
            if(this.Cells[i][this.CellsNum[i] - 1].type>this.FishStay.type) {
                this.setHandScaleIn(this.Cells[i][this.CellsNum[i] - 1]);
                return;
            }
    }

    //JUST min
    for(i=1;i<Base.GameCols-1;i++) {
        //  index = i+1; if(index>=Base.GameCols) index -= Base.GameCols;
        if(this.CellsNum[i]==0) {
          this.setHandScaleIn(this.Pushers[i]);
          return;
        }
    }

    for(i=0;i<Base.GameCols;i++) {
        //  index = i+1; if(index>=Base.GameCols) index -= Base.GameCols;
        if(this.CellsNum[i]==0) {
            this.setHandScaleIn(this.Pushers[i]);
            return;
        }
    }

    var indexMin = 0;
    for(i=0;i<Base.GameCols;i++) {
        index = i+1; if(index>=Base.GameCols) index -= Base.GameCols;
        if(this.CellsNum[index]<this.CellsNum[indexMin]) {
            indexMin = index;
        }
    }

    if((this.Cells[indexMin][this.CellsNum[indexMin] - 1].y+this.Y)<500) {
        this.setHandScaleIn(this.Cells[indexMin][this.CellsNum[indexMin] - 1]);
    }
};

CField.prototype.setHandScaleIn = function(cel) {
    this.HandScale = 0.1;
    this.HandImg.x = cel.x - 15;
    this.HandImg.y = cel.y + 100;
    this.HandImg.scale.set(this.HandScale);
    this.HandScaleSpeed = 2;
    this.HandImg.visible = true;
    this.HandScaleDownFlag = false;
    this.HandScaleUpFlag = true;
    this.HelpAppearCntr++;
    this.HandFlag = true;
};

CField.prototype.setHandScaleOut = function() {
    if(!this.HandFlag)  return;
    this.HandFlag = false; // now seen
    this.HandScaleDownFlag = true;
};

CField.prototype.updateHand = function() {

    if(this.HandScaleDownFlag) {
        this.HandScale -= 2*Base.RealTimeInt;
        if(this.HandScale<0.1) {
            this.HandImg.visible = false;
            this.HandScaleDownFlag = false;
            return;
        }
        this.HandImg.scale.set(this.HandScale);
        return;
    }

    if(this.HandFlag) {
        if((this.HandImg.y+this.Y)>590) {
            this.setHandScaleOut();
            return;
        }

        this.HandScale += this.HandScaleSpeed*Base.RealTimeInt;
        if((this.HandScale>1.05 && this.HandScaleSpeed>0) ||
            (this.HandScale<0.95 && this.HandScaleSpeed<0)) {
            if(this.HandScaleUpFlag) {

                this.HandScaleSpeed = 0.5; // speed of anim
                this.HandScaleUpFlag = false;
            }
            this.HandScaleSpeed = -this.HandScaleSpeed ;
        }
        this.HandImg.scale.set(this.HandScale);
    }
};

CField.prototype.StopHelp = function() {
    if(!this.HelpFlag) return;

    this.Threads.removeThread(this,this.updateHand);
    this.HandImg.kill();
    this.HandImg = null;
    this.HandFlag = false;
    this.HelpFlag = false;
};

CField.prototype.setBeginParams = function() {

    this.LastType = -1;
  //  this.PushersNum = 0;
    this.FlyFlag = false;
    this.ShiftingFlag = false;
    this.ShiftsNum = 0;
    this.ClickAllowFlag = false;
    this.FlysNum = 0;
    this.FishFlyCntr = 0;
    this.DistCellsMax = 0;
    this.FreezeFlag = false;
    this.FlashUpFlag = false;
    this.ScaleFishkiFlag = false;

    this.SpeedDownFlag = false;
    this.SpeedUpFlag = false;

    this.FreenzyRateCntr = 4;
    this.FreenzyFlag = false;

    this.AllMatchesCntr = 0;
    this.LastType = -1;
    this.MatchesCntr = 0;
    this.CoinsRateCntr = 5;

    this.CoinsRate = 5;
    this.CoinsRateRnd = 3;
    this.CoinsRateCntr = 2;

    this.JokerRateCntr = 5;
    this.JokerRate = 6;
    this.JokerRateRnd = 5;
    this.JokerRateCntr = 10;

    this.HiScoreBeatFlag = false;
    this.MaxFishType = 0;
    this.MaxFishBeatFlag = false;

    this.HardEasyIndex = Math.floor(Math.random()* this.HardEasy.length);
    this.HardEasyCntr = 10;

 //   this.CascadeMatchCntr = 0;
    this.RowMatchCntr = 0;
    this.MergeAnimCntr = 0;

    this.HelpFlag = false;
};

CField.prototype.create = function() {

    if(this.ReplayFlag) {
        this.Replay();return;
    }

   if(this.ActiveFlag) this.Kill();

    for(var i=0;i<Base.GameCols;i++) {
        this.CellsNum[i] = 0;
    }

    this.Y = 115;
    this.gameGroup.y = this.Y;
    this.Y_pushtop = 100;

    this.setBeginParams();

    this.addPushersLine();
    this.makeFishStay();

    if(!this.ActiveFlag)
       this.Threads.addThread(this,this.update);

    this.ReplayFlag = true;
    this.ActiveFlag = true;
};

CField.prototype.Replay = function() {

    if(this.HelpFlag)
        this.StopHelp();

    this.Threads.removeThread(this,this.updateShift);
    this.Threads.removeThread(this,this.updateFish);
    this.Threads.removeThread(this,this.updateFreeze);
    this.Threads.removeThread(this,this.updateWaitBooster);
    this.Threads.removeThread(this,this.updateFlashUp);
    this.Threads.removeThread(this,this.updateScaleFishOut);
    this.Threads.removeThread(this,this.updateScaleFishIn);

    this.setBeginParams();
    this.makeFishStay();

    if(!Base.HelpFlag) this.setFlashUp(0,this.OnReplayStart,this);
    else this.setFlashUp(0,this.setHelp,this);

  /*  if(this.HelpFlag)
       this.StopHelp();

    this.setBeginParams();
    this.makeFishStay();

    if(!Base.HelpFlag) this.setFlashUp(0,null,null);
    else this.setFlashUp(0,this.setHelp,this); */
};

CField.prototype.OnReplayStart = function() {
    this.clearFishSaves();
};

CField.prototype.OnMergeAnimOver = function() {
   // if(!this.MergeAnimGoingFlag )  return;

    this.MergeAnimCntr--;
    if(this.MergeAnimCntr==0) {

        if(!this.setShifting())
        {
            // unreachable
            this.OnShiftingEnd();
        }
    }
    // console.log('每合成一个数字就出广告，适合的广告位')
    

    
    
};

CField.prototype.OffFreenzy = function() {
    if(!this.FreenzyFlag)  return;
   // this.RowMatchCntr = 0;
    this.FreenzyFlag = false;
};

CField.prototype.StopFreenzy = function() {
    if(!this.FreenzyFlag)  return;
    this.Papa.StopFreenzy();
    this.OffFreenzy();
};

CField.prototype.setFreenzy = function() {

  //  this.RowMatchCntr = 0;

   if(this.Papa.setFreenzy()) {
       this.RowMatchCntr = 0;
     //  this.CascadeMatchCntr = 0;
       this.FreenzyFlag = true;
       return true;
   }
    return false;
};

CField.prototype.Continue = function() {
    this.setFlashUp(2,null);
};

CField.prototype.startPlay = function() {
    this.SpeedDownFlag = true;
    this.ClickAllowFlag = true;
};

CField.prototype.OnLoose = function() {

    this.Papa.PlaySnd(Base.SndLoose);

    if(this.HelpFlag)
        this.StopHelp();

    if(Base.Score>Base.HiScore) {
        Base.HiScore = Base.Score;
        this.Papa.Papa.saveAll();
    }

     if(Base.Coins>=Base.PriceContinue){
        this.Papa.setChoice();
     } else {
        this.Papa.setResults();

     }         

    if(this.FreenzyFlag )
        this.StopFreenzy();
};

CField.prototype.OnClick = function(x,y) {//点击数字盘面
    // debugger
    if(!this.ClickAllowFlag)  return;

    if(y<this.Y_field0)  return;
    if(y>this.Y_field1)  return;

    var index = -1;
    for(var i=0;i<Base.GameCols;i++) {
        if(x>=this.Pads[i].x0 &&  x<=this.Pads[i].x1)
        {
            index = i;
            break;
        }
    }

    if(index<0)  return;

    if(this.HelpFlag) {
        this.setHandScaleOut();
    }
    globleData.filedClick = true;
    this.ScoreUpFlag = false;
  //  this.CascadeMatchCntr = 0;
    this.makeFishFly(index,this.FishStay.type,this.FishStay.joker);
    this.makeFishStay();
};

CField.prototype.setSpeedUp = function(force) {

    this.SpeedUp = this.SpeedUps[force];
    this.SpeedUpFade = this.SpeedUpFades[force];
    this.SpeedUpFlag = true;
};

CField.prototype.DoScoreUp = function(type) {

    var add = 2;
    for(var i=0;i<type;i++) add *= 2;

    if(this.FreenzyFlag) add *= 3;

    this.ScoreUpFlag = true;
    Base.Score += add;
    this.Papa.updateScore();
    return add;
};

/*
CField.prototype.addScore = function(add) {
    this.ScoreUpFlag = true;
    Base.Score += add;
    this.Papa.updateScore();
}; */

CField.prototype.addCoin = function(add) {

    this.Papa.CoinsGame++;
    Base.Coins += add;
    this.Papa.PlaySnd(Base.SndCoin);
    this.Papa.updateCoins();
};

CField.prototype.getType = function() {

    if(this.HelpFlag) {
        choice = this.HelpTypes[this.HelpTypesIndex];// Math.floor(Math.random()*(2));
        this.HelpTypesIndex++;
        if(this.HelpTypesIndex>=this.HelpTypes.length)
            this.HelpTypesIndex = 0;
      //  if(choice==this.LastType) choice++;
      //  if(choice>=2) choice = 0;
        this.LastType = choice;
        return choice;
    }

    this.FishChooseRangeCurr = this.FishChooseRange;
    if(this.FishFlyCntr<15)  {
        this.FishChooseRangeCurr--;
        if(this.FishFlyCntr<10) this.FishChooseRangeCurr--;
        if(this.FishFlyCntr<7) this.FishChooseRangeCurr--;
    }

    var range = this.FishChooseRangeCurr;

    var choice;
   /* if(this.MatchesCntr<4) {
        choice = Math.floor(Math.random()*(this.FishChooseRange-2));
        if(choice==this.LastType) choice++;
        if(choice>=(this.FishChooseRange-2)) choice = 0;
        this.LastType = choice;
        return choice;
    }*/

    var num = 0;
    var danger =  false;
    choice = 0;
    for(var i=0;i<Base.GameCols;i++) {
        //check center fish
        num += this.CellsNum[i];
       // if(this.CellsNum[i]>5)
       //   long = true;
    }

    if((this.Y+this.DistCellsMax)>(this.Y_end-this.DangerDist)) danger = true;

    if(num<10) {
        choice = this.chooseType(range,this.HardEasy[this.HardEasyIndex].hard, 0);
    }
    else {

        if(danger) {
            if(num>20)
               choice = this.chooseType(range,0, 0.4);
            else
                choice = this.chooseType(range,0, this.HardEasy[this.HardEasyIndex].easy);
        }
        else
            choice = this.chooseType(range,this.HardEasy[this.HardEasyIndex].hard,
                this.HardEasy[this.HardEasyIndex].easy);
    }


    this.HardEasyCntr--;
    if(this.HardEasyCntr<0) {
        var index = Math.floor(Math.random()*this.HardEasy.length);
        if(index!==this.HardEasyIndex)
           this.HardEasyIndex = index;
        else {
            index++;
            if(index>=this.HardEasy.length) index = 0;
            this.HardEasyIndex = index;
        }
        this.HardEasyCntr = 10;
    }

    if(this.FishFlyCntr<15)  {
        if(choice==this.LastType) {
            choice --;
            if(choice<0) choice = range - 1;
        }
    }

    this.LastType = choice;
    return choice;
};

CField.prototype.chooseType = function(range,hard,easy) {

    var chooseRnd = Math.random();
    if(chooseRnd>=(hard+easy)) {
        // pure random
   //     console.log("choose "+range);
        return Math.floor(Math.random()*range);
    }

    // make Types to choose
    for(var i=0;i<range;i++)
        this.ChooseTypes[i] = 0;

    var num = 0;
    var type = 0;
    for(i=0;i<Base.GameCols;i++) {
        //check center fish
        num += this.CellsNum[i];

        if(this.CellsNum[i]>0) {
            type =  this.Cells[i][this.CellsNum[i]-1].type;
            if(type>=0 && type<range)
                this.ChooseTypes[type]++;
        }
        // check side fishki
        if(i>0 && this.CellsNum[i-1]>this.CellsNum[i])
        {
            type =  this.Cells[i-1][this.CellsNum[i]].type;
            if(type>=0 && type<range)
                this.ChooseTypes[type]++;
        }
        if(i<(Base.GameCols-1) && this.CellsNum[i+1]>this.CellsNum[i])
        {
            type =  this.Cells[i+1][this.CellsNum[i]].type;
            if(type>=0 && type<range)
                this.ChooseTypes[type]++;
        }
    }

    var types = 0;
    for(i=0;i<range;i++)
        if(this.ChooseTypes[i]>0) types++;

    if(chooseRnd<hard) {
        // HARD CASE
        for(i=0;i<5;i++) {
            type = Math.floor(Math.random()*range);
            if(this.ChooseTypes[type]==0) return type;
        }
        for(i=0;i<5;i++)
            if(this.ChooseTypes[i]==0) return i;

         return Math.floor(Math.random()*range);
    }

    if(chooseRnd>hard && chooseRnd<(hard+easy))
    {
        //EASY , choose some existing
        for(i=0;i<5;i++) {
            type = Math.floor(Math.random()*range);
            if(this.ChooseTypes[type]>0) return type;
        }
        for(i=0;i<5;i++)
            if(this.ChooseTypes[i]>0) return i;

        return Math.floor(Math.random()*range);
    }

    // usual
    return Math.floor(Math.random()*range);
};

CField.prototype.checkForMatches = function() {

 //   console.log('checking matches '+this.Temp);

    this.MatchesNum = 0;
    //this.Matches
    var i,k;
    for(i=0;i<Base.GameCols;i++) {
        for(k=0;k<this.CellsNum[i];k++) {
            if(this.Cells[i][k].obj!==null)
            {
                this.Cells[i][k].flag = false;
                this.Cells[i][k].index = k;
                this.Cells[i][k].matches = 0;

                if(i>0 && this.Cells[i-1][k]!==undefined && this.Cells[i-1][k].obj!=null &&
                    this.Cells[i-1][k].type==this.Cells[i][k].type && !this.Cells[i][k].coin)
                    this.Cells[i][k].matches++;

                if(i<(Base.GameCols-1)  && this.Cells[i+1][k]!==undefined && this.Cells[i+1][k].obj!=null &&
                    this.Cells[i+1][k].type==this.Cells[i][k].type && !this.Cells[i][k].coin)
                    this.Cells[i][k].matches++;

                if(k>0  && this.Cells[i][k-1]!==undefined && this.Cells[i][k-1].obj!=null &&
                    this.Cells[i][k-1].type==this.Cells[i][k].type && !this.Cells[i][k].coin)
                    this.Cells[i][k].matches++;

                if(k<(this.CellsNum[i]-1)  && this.Cells[i][k+1]!==undefined && this.Cells[i][k+1].obj!=null &&
                    this.Cells[i][k+1].type==this.Cells[i][k].type && !this.Cells[i][k].coin)
                    this.Cells[i][k].matches++;
            }
        }
    }

    for(i=0;i<Base.GameCols;i++) {
        for(k=0;k<this.CellsNum[i];k++) {
            if(this.Cells[i][k].obj!==null && this.Cells[i][k].flag==false && this.Cells[i][k].matches>0)
            {
                this.Cells[i][k].flag = true;
                this.MatchesTempNum = 0;
                var num = this.getMatchesAroundCell(i,k,this.Cells[i][k].type);
                if(num>0) {
                    this.MatchesTemp[this.MatchesTempNum ] = this.Cells[i][k];
                    this.MatchesTempNum++;

                    if(this.Matches[this.MatchesNum]==undefined)
                        this.Matches[this.MatchesNum] = [];
                    for(var j=0;j<this.MatchesTempNum;j++)
                        this.Matches[this.MatchesNum][j] =  this.MatchesTemp[j];
                    this.MatchesNums[this.MatchesNum] = this.MatchesTempNum;
                    this.MatchesNum++;
                }
            }
        }
    }

    if(this.MatchesNum==0)  return false;

    for(i=0;i<this.MatchesNum;i++) {

        var firstIndex = -1;

        for(k=0;k<this.MatchesNums[i];k++)
        {
            if(this.Matches[i][k].moved)
            {
                firstIndex = k;
                break;
            }
        }

        if(firstIndex>=0) {

            var fly = this.getFly(this.Matches[i][firstIndex]);

            for(k=0;k<this.MatchesNums[i];k++)
            {
                if(k!=firstIndex)
                {
                    this.addToFly(fly,this.Matches[i][k]);
                    this.killFish(this.Matches[i][k],true);
                   // this.Matches[i][k].img = null;
                   // console.log("fly added "+k);
                }
            }

           // this.DoScoreUp(this.MatchesNums[i]-1);

            fly.type = this.Matches[i][firstIndex].type + this.MatchesNums[i] - 1;
            if(fly.type>34) fly.type = 35;
            fly.scoreup = this.DoScoreUp(fly.type);

          /*  var fxtype =  this.getFishFXType(fly.matchesNum,fly.type);
            this.Papa.addFishFX(fly.dest.x,fly.dest.y,this.gameGroup,
                fxtype,this.OnMergeAnimOver,this);
            this.Papa.PlaySnd(Base.SndTrow);*/

            this.makeFishMergeFX(fly);

            this.MergeAnimCntr++;

            this.checkMatch(fly,this.MatchesNums[i] - 1);

           // console.log("firstIndex "+firstIndex);
         //   console.log("matchesNums "+this.MatchesNums[i]);
         //   console.log("flysNum "+ this.FlysNum);
        }
    }

    return true;
};

CField.prototype.makeFishMergeFX = function(match) {
    var fxtype =  this.getFishFXType(match.matchesNum,match.type);
    this.Papa.addFishFX(match.dest.x,match.dest.y,this.gameGroup,
        fxtype,this.OnMergeAnimOver,this);
    if(fxtype==0) this.Papa.PlaySnd(Base.SndMerge0);
    if(fxtype==1) this.Papa.PlaySnd(Base.SndMerge1);
    if(fxtype==2) this.Papa.PlaySnd(Base.SndMerge2);
};

CField.prototype.setStayFish = function(fish,type,joker) {
    fish.type = type;
    fish.joker = joker;
    fish.obj.img.frameName = Base.FishPads[type];
    fish.obj.top.frameName = Base.FishNums[type];
};

CField.prototype.applyBooster = function(type) {
     this.Papa.PlaySnd(Base.SndPrize);
     switch(type)
     {
         case 0: // change cue fishka
             var index = Math.floor( this.FishChooseRangeCurr*Math.random());
             if(this.FishStay.joker) {
                 this.setFishStayJokerOff(index);
             } else {
                 if(index==this.FishStay.type) index++;
                 if(index>=this.FishChooseRangeCurr) index = 0;
             }

          //   this.FishStay.obj.img.frameName = Base.FishPads[index];
          //   this.FishStay.obj.top.frameName = Base.FishNums[index];

             this.setStayFish(this.FishStay,index,false);
             this.LastType = index;

             // wait till send end signal
             this.BoosterType = 0;
             this.BoosterWaitTimeCntr = 0.75;
             this.Threads.addThread(this,this.updateWaitBooster);
             return true;
             break;
         case 1:   // delete some fishka

             if(!this.ClickAllowFlag)
             {
                 return false;
             }

             if(!this.makeSomeFishGone())  return false;

             this.BoosterType = 1;
             this.BoosterWaitTimeCntr = 0.75;
             this.Threads.addThread(this,this.updateWaitBooster);
             return true;
             break;
         case 2:
             if(this.FreezeFlag) {
                 this.FreezeTime += 5;
             }
             else
             {
                 this.FreezeTime = 5;
                 this.Threads.addThread(this,this.updateFreeze);
             }

             this.FreezeFlag = true;
             this.SpeedDownFlag = false;

             this.BoosterType = 2;
             this.BoosterWaitTimeCntr = 0.75;
             this.Threads.addThread(this,this.updateWaitBooster);
             return true;
             break;
     }
     return false;
};

CField.prototype.updateWaitBooster = function() {
    this.BoosterWaitTimeCntr -= Base.RealTimeInt;
    if(this.BoosterWaitTimeCntr<0) {
        this.Threads.removeThread(this,this.updateWaitBooster);
        this.Papa.OnBoosterEnd(this.BoosterType); // allow boosters to be clicked
    }
};

CField.prototype.updateFreeze = function() {
     this.FreezeTime -=  Base.RealTimeInt
     if(this.FreezeTime<0) {
         this.SpeedDownFlag = true;
         this.Threads.removeThread(this, this.updateFreeze);
      //   this.Papa.OnBoosterEnd(2);
     }
};

CField.prototype.setFlashUp = function(rowsLeft,func,funcContex) {

    if(this.FlashUpFlag)  return;

    this.makeDownFishGone(rowsLeft);

    this.FlashUpCall = func;
    this.FlashUpCallContex = funcContex;
    this.FlashUpFlag = true;
    this.ClickAllowFlag = false;
    this.SpeedDownFlag = false;
    this.Threads.addThread(this,this.updateFlashUp);
};

CField.prototype.updateFlashUp = function() {
   /* this.FlashUpDist -= this.FlashUpSpeed*Base.RealTimeInt;

    if(this.FlashUpDist<0) {
        this.Threads.removeThread(this,this.updateFlashUp);
        this.ClickAllowFlag = true;
        this.SpeedDownFlag = true;
        return;
    } */

    if(this.Y>115) this.Y -= this.FlashUpSpeed*Base.RealTimeInt;
    if(this.Y <=115)  this.Y = 115;

    if(this.Y <=115 && this.ScaleFishkiFlag==false)
    {
        this.Threads.removeThread(this,this.updateFlashUp);
        this.ClickAllowFlag = true;
        this.SpeedDownFlag = true;
        this.FlashUpFlag = false;

        if(this.FlashUpCall!=null)
            this.FlashUpCall.call(this.FlashUpCallContex);
    }
};

CField.prototype.updateShift = function() {
    this.Shift -= this.ShiftSpeed*Base.RealTimeInt;
    if(this.Shift<=0)
        this.Shift = 0;

    for(var i=0;i<this.ShiftsNum;i++) {
       if(this.Shifts[i].obj!==null) {
           this.Shifts[i].x = this.Shifts[i].x_dest - (this.Shifts[i].x_dest - this.Shifts[i].x) * this.Shift;
           this.Shifts[i].y = this.Shifts[i].y_dest - (this.Shifts[i].y_dest - this.Shifts[i].y) * this.Shift;
           this.Shifts[i].obj.img.x = this.Shifts[i].x;
           this.Shifts[i].obj.img.y = this.Shifts[i].y;
           this.Shifts[i].obj.top.x = this.Shifts[i].x;
           this.Shifts[i].obj.top.y = this.Shifts[i].y;
       }
    }

    if(this.Shift<=0)
       if(!this.setShifting())
       {
           this.Threads.removeThread(this,this.updateShift);
           this.ShiftingFlag = false;
           this.OnShiftingEnd();
       }
};

CField.prototype.getDistCellsMax = function() {
   // var cntrMax = 0;
    this.DistCellsMax = Base.CellDiam*0;
    for(var i=0;i<Base.GameCols;i++) {
        if(this.CellsNum[i]>0) {
            if( this.Cells[i][this.CellsNum[i]-1].coin)
            {
                var dist =  Base.CellDiam*(this.CellsNum[i]-1) +
                    Base.CellDiam/2;
            }
            else
            {
                dist =  Base.CellDiam*this.CellsNum[i];
            }
            if(dist>this.DistCellsMax)
                this.DistCellsMax = dist;
        }
      //  if(this.CellsNum[i]>cntrMax)
        //   cntrMax = this.CellsNum[i];
    }

   // this.DistCellsMax = Base.CellDiam*cntrMax;
   // this.Cells[col][this.CellsNum[col]]
};

CField.prototype.OnShiftingEnd = function() {

    // correct numbers

    for(var i=0;i<Base.GameCols;i++) {
        var cntr = 0;
        for(var k=0;k<this.CellsNum[i];k++) {
            if(this.Cells[i][k].obj!==null)
              cntr++;
        }
        this.CellsNum[i] = cntr;
    }

    this.getDistCellsMax();

   console.log("checkForMatches start "+this.Temp);
    // check for new matches
    if(!this.checkForMatches()) {
        this.checkForShoutOuts();

        if(this.HelpFlag)
            this.HelpCycle();

        // clear temp flags
        this.OnAfterMatch();
        this.clearFlags();
        this.ClickAllowFlag = true;

        if(this.ScoreUpFlag) {
            if(Base.Score>Base.HiScore) {
                Base.HiScore = Base.Score;
                this.Papa.Papa.saveAll();
            }
            this.ScoreUpFlag = false;
        }

        this.MoveScoreCntr = 0;
        this.MoveMatchesCntr = 0;

       /* if(!this.FreenzyFlag) {
            this.FreenzyRateCntr--;
            if(this.FreenzyRateCntr<0) {
                this.FreenzyRateCntr = 6;
                this.setFreenzy();
            }
        }*/
    }
};

CField.prototype.checkForShoutOuts = function() {

    if(this.MaxFishBeatFlag) {
        this.MaxFishBeatFlag = false;
        if(this.MaxFishType>9) {
            this.Papa.makeConfeti(Base.Width/2-40,290);
        }
    }

    if(this.MoveBestMatchNum>3) {
        this.Papa.makeShoutOut(1,true);
        return;
    }

    if(!this.HiScoreBeatFlag && Base.Score>Base.HiScore  && Base.HiScore>0) {
        this.Papa.makeConfeti(Base.Width/2-150,280);
        this.Papa.makeConfeti(Base.Width/2+150,290);
        this.Papa.makeShoutOutHiScore();
        this.HiScoreBeatFlag = true;
        return;
    }

    if(this.MoveMatchesCntr>1 || this.MoveScoreCntr>32) {

        if(this.MoveScoreCntr>128)  {
            if(this.MoveScoreCntr>265) this.Papa.makeShoutOut(1,true);
            else  {
                if(this.MoveMatchesCntr>1) this.Papa.makeShoutOut(1,true);
                else  this.Papa.makeShoutOut(1,false);
            }
            return;
        }

        if(this.MoveMatchesCntr>4) {
            if(this.MoveMatchesCntr>6) this.Papa.makeShoutOut(1,true);
            else this.Papa.makeShoutOut(1,false);
            return;
        }

        if(this.MoveMatchesCntr>2)
            this.Papa.makeShoutOut(0,false);
        else
            if(this.MoveScoreCntr>64)
               this.Papa.makeShoutOut(0,false);
    }
};

CField.prototype.clearFlags = function() {
    for(var i=0;i<Base.GameCols;i++) {
        for (var k = 0; k < this.CellsNum[i]; k++) {
            this.Cells[i][k].moved = false;
        }
    }
};

CField.prototype.setShifting = function() {

    this.ShiftsNum = 0;

    for(var i=0;i<Base.GameCols;i++) {
        for(var k=0;k<this.CellsNum[i];k++) {
            if(this.Cells[i][k].obj==null) {
               if((k+1)<this.CellsNum[i] && this.Cells[i][k+1].obj!==null) {

                   this.Cells[i][k].obj = this.Cells[i][k+1].obj;
                   this.Cells[i][k+1].obj = null;
                   this.Cells[i][k].type = this.Cells[i][k+1].type;
                   this.Cells[i][k].empty = this.Cells[i][k+1].empty;
                   this.Cells[i][k].x_dest = this.Cells[i][k].x;
                   this.Cells[i][k].y_dest = this.Cells[i][k].y;
                   this.Cells[i][k].y = this.Cells[i][k+1].y;
                   this.Cells[i][k].coin = this.Cells[i][k+1].coin;
                   this.Cells[i][k].moved = true;

                   this.Shifts[this.ShiftsNum] = this.Cells[i][k];
                   this.ShiftsNum++;
               }
            }
        }
    }

    if(this.ShiftsNum==0)  return false;

    //console.log("Shifting start ");

    if(this.ShiftingFlag==false)
        this.Threads.addThread(this,this.updateShift);

    this.Shift = 1;
    this.ShiftingFlag = true;
    return true;
};

CField.prototype.setFishStayJokerOff = function(type) {
    this.FishStay.obj.img.frameName = Base.FishPads[type];
    this.FishStay.obj.top.frameName = Base.FishNums[type];
    this.FishStay.type = type;
    this.FishStay.joker = false;
    this.FishStay.obj.top.visible = true;
};

CField.prototype.makeFishStay = function() {

    if(this.LastType<0) {
        type = this.getType();
        this.FishStay.obj.img.frameName = Base.FishPads[type];
        this.FishStay.obj.top.frameName = Base.FishNums[type];
        this.FishStay.type = type;
        this.FishStay.joker = false;
        this.FishStay.obj.img.visible = true;
        this.FishStay.obj.top.visible = true;
    }
    else {
        if(this.FishNext.joker) {
            this.FishStay.obj.img.frameName = 'joker.png';
            this.FishStay.type = -1;
            this.FishStay.joker = true;
            this.FishStay.obj.img.visible = true;
            this.FishStay.obj.top.visible = false;
        } else {
            type = this.FishNext.type;
            this.FishStay.obj.img.frameName = Base.FishPads[type];
            this.FishStay.obj.top.frameName = Base.FishNums[type];
            this.FishStay.type = type;
            this.FishStay.joker = false;
            this.FishStay.obj.img.visible = true;
            this.FishStay.obj.top.visible = true;
        }
    }

    var joker = false;
    if(this.HelpFlag==false && (this.JokerRateCntr--)<=0)  {
        this.JokerRateCntr = this.JokerRate + this.JokerRateRnd*Math.random();
        joker = true;
    }

    //joker = false;

    if(!joker) {
        var type = this.getType();
        this.FishNext.obj.img.frameName = Base.FishPads[type];
        this.FishNext.obj.top.frameName = Base.FishNums[type];
        this.FishNext.type = type;
        this.FishNext.joker = false;
        this.FishNext.obj.img.visible = true;
        this.FishNext.obj.top.visible = true;
        this.LastType = type;
    }
    else {
        this.FishNext.obj.img.frameName = 'joker.png';
        this.FishNext.type = -1;
        this.FishNext.joker = true;
        this.FishNext.obj.img.visible = true;
        this.FishNext.obj.top.visible = false;
    }
};

CField.prototype.makeOneFishGone = function(cel) {
    this.FishkiNum = 0;
    this.ScaleFishki = 1;

    this.Fishki[this.FishkiNum] = cel;
    this.FishkiNum++;

    this.Threads.addThread(this, this.updateScaleFishOut);
    this.ScaleFishkiFlag = true;
    this.ClickAllowFlag = false;
};

CField.prototype.makeDownFishGone = function(left) {

    this.FishkiNum = 0;
    this.ScaleFishki = 1;
    var num = 0;

    for(var i=0;i<Base.GameCols;i++) {
        for (var k = this.CellsNum[i]-1; k>=left ; k--) {
            this.Fishki[this.FishkiNum] = this.Cells[i][k];
            this.FishkiNum++;
            num++;
        }
    }
    if(num>0) {
        this.Threads.addThread(this, this.updateScaleFishOut);
        this.ScaleFishkiFlag = true;
    }
};

CField.prototype.makeSomeFishGone = function() {

    this.FishkiNum = 0;
    this.ScaleFishki = 1;

    var num = 0;
    var longIndex = -1;
    for(var i=0;i<Base.GameCols;i++) {
        for (var k = 0; k < this.CellsNum[i]; k++) {
            this.Cells[i][k].flag = false;
            num++;
        }
        if(longIndex<0) { if(this.CellsNum[i]>0) longIndex = i; }
        else {
            if(this.CellsNum[longIndex]<this.CellsNum[i])
                longIndex = i;
        }
    }

    if(num==0)  return false;

    var cntr = 3;
    if(cntr>num) cntr = num;

    while(cntr>0) {

        var col0 = Math.floor(Math.random()*Base.GameCols);
        var row0 = Math.floor(Math.random()*this.CellsNum[col0]);
        var rowSel = -1;
        var colSel = -1;
        for(i=0;i<Base.GameCols;i++) {
            var col = i + col0;
            if(col>=Base.GameCols) col -= Base.GameCols;

            for (k = 0; k < this.CellsNum[col]; k++) {
               var row = row0 + k;
               if(row>=this.CellsNum[col])  row -= this.CellsNum[col];

                if( this.Cells[col][row].flag == false) {
                    rowSel = row;
                    colSel = col;
                }

                if(rowSel>=0)  break;
            }
            if(rowSel>=0)  break;
        }

        if(rowSel>=0)  {
            this.Cells[col][row].flag = true;
            this.Fishki[this.FishkiNum] = this.Cells[colSel][rowSel];
            this.FishkiNum++;
        }
        cntr--;
    }

    this.Threads.addThread(this,this.updateScaleFishOut);
    this.ScaleFishkiFlag = true;
    this.ClickAllowFlag = false;
    return true;
    // fill array to scale
   // this.CallOnScaleFishki = null;
};

CField.prototype.updateScaleFishOut = function() {

    this.ScaleFishki -= 3*Base.RealTimeInt;
    if(this.ScaleFishki<0) {
        this.ScaleFishki = 0;
        this.Threads.removeThread(this,this.updateScaleFishOut);
        for(i=0;i<this.FishkiNum;i++)  {
            this.killFish(this.Fishki[i],false);
          //  this.Fishki[i].img.kill();
          //  this.Fishki[i].img = null;
        }

        this.MoveMatchesCntr = 0;
        this.MoveScoreCntr = 0;
        if(!this.setShifting())
        {
            this.OnShiftingEnd();
        }
        this.ScaleFishkiFlag = false;
        return;
    }

    for(var i=0;i<this.FishkiNum;i++)  {
        if(this.Fishki[i].obj!==null) {
            this.Fishki[i].obj.img.scale.set(1 - (this.ScaleFishki-1)*(this.ScaleFishki-1));
            this.Fishki[i].obj.img.alpha = 1 - (this.ScaleFishki-1)*(this.ScaleFishki-1);
            this.Fishki[i].obj.top.scale.set(1 - (this.ScaleFishki-1)*(this.ScaleFishki-1));
            this.Fishki[i].obj.top.alpha = 1 - (this.ScaleFishki-1)*(this.ScaleFishki-1);
        }
    }
};

CField.prototype.setAllFishScaleIn = function() {

    this.FishkiNum = 0;
    for(var i=0;i<Base.GameCols;i++) {
        for (var k =0; k<this.CellsNum[i] ; k++) {
            if(this.Cells[i][k]!==undefined && this.Cells[i][k].obj!==null) {
                this.Fishki[this.FishkiNum] = this.Cells[i][k];
                this.FishkiNum++;
            }
        }
    }
    if(this.FishkiNum>0) {
   //     this.ClickAllowFlag = false;
        this.Threads.addThread(this,this.updateScaleFishIn);
        this.scaleFishki(0);
    }
};

CField.prototype.updateScaleFishIn = function() {

    this.ScaleFishki += 3*Base.RealTimeInt;
    if(this.ScaleFishki>=1) {
        this.ScaleFishki = 1;
        this.Threads.removeThread(this,this.updateScaleFishIn);
        this.ScaleFishkiFlag = false;
     //   this.ClickAllowFlag = true;
    }

    for(var i=0;i<this.FishkiNum;i++)  {
        if(this.Fishki[i].obj!==null) {
            this.Fishki[i].obj.img.scale.set(1 - (this.ScaleFishki-1)*(this.ScaleFishki-1));
            this.Fishki[i].obj.img.alpha = 1 - (this.ScaleFishki-1)*(this.ScaleFishki-1);
            this.Fishki[i].obj.top.scale.set(1 - (this.ScaleFishki-1)*(this.ScaleFishki-1));
            this.Fishki[i].obj.top.alpha = 1 - (this.ScaleFishki-1)*(this.ScaleFishki-1);
        }
       // else console.log("this.Fishki[i].obj==null");
    }
};

CField.prototype.scaleFishki = function(scale) {
    this.ScaleFishki =  scale;
    for(var i=0;i<this.FishkiNum;i++)  {
        if(this.Fishki[i].obj!==null) {
            this.Fishki[i].obj.img.scale.set(1 - (this.ScaleFishki-1)*(this.ScaleFishki-1));
            this.Fishki[i].obj.img.alpha = 1 - (this.ScaleFishki-1)*(this.ScaleFishki-1);
            this.Fishki[i].obj.top.scale.set(1 - (this.ScaleFishki-1)*(this.ScaleFishki-1));
            this.Fishki[i].obj.top.alpha = 1 - (this.ScaleFishki-1)*(this.ScaleFishki-1);
        }
    }
};

CField.prototype.makeFishFly = function(col,type,joker) {
    // debugger
    this.FishFly.x =  Base.Lines[col];
    this.FishFly.y = this.FishStay.y;
    this.FishFly.obj.img.x = this.FishFly.x;
    this.FishFly.obj.img.y = this.FishFly.y;
    this.FishFly.obj.top.x = this.FishFly.x;
    this.FishFly.obj.top.y = this.FishFly.y;

   // this.FishFly.img.reset(this.FishFly.x, this.FishFly.y);
    if(!joker) {
        this.FishFly.obj.img.frameName = Base.FishPads[type];
        this.FishFly.obj.top.frameName = Base.FishNums[type];
    }
    else  this.FishFly.obj.img.frameName = 'joker.png';

    this.FishFly.obj.img.visible = false;
    this.FishFly.obj.top.visible = false;

    this.FishFly.type = type;
    this.FishFly.col = col;

    this.FishFly.joker = joker;
    this.FishFly.coin = this.checkOnCoin(col);
    this.FishFly.dest = this.getColBottom(col);
    this.Threads.addThread(this,this.updateFish);
    this.FlyFlag = true;
    this.ClickAllowFlag = false;

    this.FishFlyCntr++;

    this.MoveMatchesCntr = 0;
    this.MoveScoreCntr = 0;
    this.MoveBestMatchNum = 0;

    this.Papa.PlaySnd(Base.SndTrow);
};

CField.prototype.updateFish = function() {
    // debugger
    this.FishFly.y -= this.SpeedFlyUp*Base.RealTimeInt;
    this.FishFly.obj.img.y = this.FishFly.y;
    this.FishFly.obj.top.y = this.FishFly.y;
   // this.FishFly.img.reset(this.FishFly.x, this.FishFly.y);
    if(!this.FishFly.obj.img.visible) {
        this.FishFly.obj.img.visible = true;
        if(!this.FishFly.joker)
           this.FishFly.obj.top.visible = true;
    }
    if(this.FishFly.y<(this.gameGroup.y+this.FishFly.dest.y+Base.CellDiam)) {
        this.FlyFlag = false;
        this.FishFly.obj.img.visible = false;
        this.FishFly.obj.top.visible = false;
      //  this.FishFly.img.kill();
       // this.FishFly.img = null;
        this.Threads.removeThread(this,this.updateFish);

       // this.clearFlags();  // TEMP
        //this.ClickAllowFlag = true; // TEMP
      // return;

        if(this.FishFly.coin) {
            this.addCoin(1);
            this.killCoin(this.FishFly.col);
        }

        var cel = this.addFishToField(this.FishFly.dest.y,this.FishFly.col,
            this.FishFly.type,this.FishFly.joker);

        this.setSpeedUp(0);

      //   this.clearFlags();  // TEMP
      //   this.ClickAllowFlag = true; // TEMP
     //   return;

        if(this.FishFly.joker) {
            //JOKER CASE
            if(this.checkJokerOnMatch(cel.col,this.CellsNum[cel.col]-1))
            {
                 this.OnMatch();
            }
            else
            {
                this.Papa.PlaySnd(Base.SndAttach);
                this.RowMatchCntr = 0;
                if((cel.y+this.gameGroup.y)>this.Y_end)
                {
                    // this.Stop();
                    // this.Papa.OnFieldGameover();
                   // this.setFlashUp(2);
                    this.OnLoose();
                    return;
                }
                else {
                     this.clearFlags();
                    //this.ClickAllowFlag = true;
                }
            }
            return;
        }

        //if(this.checkForMatches())
        if(this.checkCellOnMatch(cel.col,this.CellsNum[cel.col]-1,cel.type))
        {
            this.OnMatch();

           /* if(this.RowMatchCntr>2 && this.FreenzyFlag) {
               //this.addScore(Base.Score + Base.Score);
               // this.RowMatchCntr = 0;
               // this.Papa.makeShoutOutTripple();
               // this.StopFreenzy();
            } else */
              if(this.RowMatchCntr>2 && this.FreenzyFlag==false && this.HelpFlag==false) {
                  if(!this.setFreenzy()) {

                  }
              }
        }
        else
        {
            this.Papa.PlaySnd(Base.SndAttach);

            if(this.HelpFlag)
                this.HelpCycle();

            this.RowMatchCntr = 0;
            if((cel.y+this.gameGroup.y)>this.Y_end)
            {
               // this.Stop();
               // this.Papa.OnFieldGameover();
                //this.setFlashUp(2);
                this.OnLoose();
                return;
            }
            else {
               // this.OnAfterMatch();
                this.clearFlags();
                this.ClickAllowFlag = true;
            }
        }
    }
};

CField.prototype.OnMatch = function() {
    // console.log('合成新数字,只会出一次广告？？')

    this.setSpeedUp(1);
    this.RowMatchCntr++;
    this.AllMatchesCntr++;
};

CField.prototype.OnAfterMatch = function() {
    //合成新数字可以出广告了
    // debugger
    var curLevelRandom = html.getRandomIntInclusive(1,100);
    console.log('random'+curLevelRandom)
    if (curLevelRandom <= Number(globleData.randomData.red_packet) && globleData.filedClick) {
        globleData.filedClick = false
        if(!globleData.appStorage.hasRed){
            //第一次直接开红包                   
            appBoot.setStorageValue('hasRed',1); 
            this.Papa.DownPanel.OnWithdrawButton()
            globleData.btnClicked = false
        }else{
            //有未领红包 红包向下再向上动画
            this.Papa.DownPanel.createPopIcon()
        }
        this.Papa.DownPanel.showWithdraw()
    }

    // console.log('match game over????，不适合出广告')
    if(this.MoveMatchesCntr>2 && this.HelpFlag==false && this.FreenzyFlag==false)
    {
        this.setFreenzy();
        console.log('FreezeTime')
    }

//    this.CoinsRateCntr = -1;

    if(this.HelpFlag==false && (this.CoinsRateCntr--)<0) {

        var index0 = Math.floor(Math.random()*Base.GameCols);
        for(var i=0;i<Base.GameCols;i++) {
            var index = index0 + i;
            if (index >= Base.GameCols) index -= Base.GameCols;
            if (!this.checkOnCoin(index)) {
                var y = this.Y + Base.CellDiam * this.CellsNum[index];
                if (this.CellsNum[index] < 5 && y < this.Y_coinmax) {
                    this.addCoinToField(index);
                    this.CoinsRateCntr = this.CoinsRate + this.CoinsRateRnd * Math.random();
                    return;
                }
            }
        }
    }

    this.MatchesCntr++;
};

CField.prototype.getFly = function(dest) {

     if(this.Flys[this.FlysNum]==undefined)
         this.Flys[this.FlysNum] = {matches:[],matchesNum:0,dest:null,type:0};

    this.Flys[this.FlysNum].matchesNum = 0;
    this.Flys[this.FlysNum].dest = dest;
    this.Flys[this.FlysNum].type = 0;

    this.FlysNum++;
    this.FlysDist = 1;
    return this.Flys[this.FlysNum-1];
};

CField.prototype.addToFly = function(flys,cell) {
     if(flys.matches[flys.matchesNum]===undefined)
         flys.matches[flys.matchesNum] = {img:null,x:0,y:0,dx:0,dy:0};
    var fly =  flys.matches[flys.matchesNum];
    flys.matchesNum++;

    fly.img = cell.obj.img;
    fly.x = cell.x;
    fly.y = cell.y;
    fly.dx = cell.x - flys.dest.x;
    fly.dy = cell.y - flys.dest.y;
    fly.matchesNum++;
};

CField.prototype.addCoinToField = function(col) {
    var cel = this.addFishToField(this.getColBottom(col).y,col,0,false);
    cel.obj.img.frameName = 'coin.png';
    cel.obj.top.visible = false;
    cel.type = -1;
    cel.coin = true;
    return cel;
};

CField.prototype.addFishToField = function(y_papa,col,type,joker) {

    var cel = this.Cells[col][this.CellsNum[col]];
    if(this.Cells[col][this.CellsNum[col]]===undefined) {
        this.Cells[col][this.CellsNum[col]] = {x:Base.Lines[col],y:0,row:this.CellsNum[col],col:col,
            obj:null,x_dest:0,y_dest:0,flag:false,index:-1,moved:false};
        cel = this.Cells[col][this.CellsNum[col]];
    }

    cel.x = Base.Lines[col];
    cel.y = y_papa + Base.CellDiam;

    cel.obj = this.getFishSave(0,this.gameGroup);

    if(!joker) {
      //  cel.obj.img.revive();
       // cel.obj.top.revive();
        cel.obj.img.visible = true;
        cel.obj.top.visible = true;
        cel.obj.img.scale.set(1);
        cel.obj.top.scale.set(1);
        cel.obj.img.alpha = 1;
        cel.obj.top.alpha = 1;
        cel.obj.img.x = cel.x;
        cel.obj.img.y = cel.y;
        cel.obj.top.x = cel.x;
        cel.obj.top.y = cel.y;
        cel.obj.img.frameName = Base.FishPads[type];
        cel.obj.top.frameName = Base.FishNums[type];
    }
    else
    {
       // cel.obj.img.revive();
        cel.obj.img.frameName =  'joker.png';
        cel.obj.img.x = cel.x;
        cel.obj.img.y = cel.y;
        cel.obj.top.x = cel.x;
        cel.obj.top.y = cel.y;
        cel.obj.img.alpha = 1;
        cel.obj.top.alpha = 1;
        cel.obj.img.scale.set(1);
        cel.obj.top.scale.set(1);
        cel.obj.top.frameName = Base.FishNums[0]; // placeholder
        cel.obj.img.alpha = 1;
        cel.obj.top.alpha = 1;
        cel.obj.img.visible = true;
        cel.obj.top.visible = false;
    }
  //  cel.obj.img = this.Papa.getZeroImg(Base.Lines[col],cel.y,
   //        'atlas',str,this.gameGroup,0);

    cel.type = type;
    cel.empty = false;
    cel.fresh = true;
    cel.col = col;
    cel.moved = true;
    cel.coin = false;
    this.CellsNum[col]++;
    this.getDistCellsMax();
    return cel;
};


CField.prototype.checkCellOnMatch = function(col,index,type) {

    var cntr = 0;
    var match = null;
    // left
    if(col>0 && this.Cells[col-1][index]!==undefined && this.Cells[col-1][index].obj!=null &&
        this.Cells[col-1][index].type==type)
    {
        if(cntr==0) match = this.getFly(this.Cells[col][index]);
        cntr++;
        this.addToFly(match,this.Cells[col-1][index]);
        this.killFish(this.Cells[col-1][index],true);
       // this.Cells[col-1][index].img = null;
    }

    // right
    if(col<(Base.GameCols-1) && this.Cells[col+1][index]!==undefined && this.Cells[col+1][index].obj!=null &&
        this.Cells[col+1][index].type==type)
    {
        if(cntr==0) match = this.getFly(this.Cells[col][index]);
        cntr++;
        this.addToFly(match,this.Cells[col+1][index]);
        this.killFish(this.Cells[col+1][index],true);
      //  this.Cells[col+1][index].img = null;
        //  this.killCell(col+1,index);
    }

    //top
    if(index>0 && this.Cells[col][index-1]!==undefined && this.Cells[col][index-1].obj!=null &&
        this.Cells[col][index-1].type==type)
    {
        if(cntr==0) match = this.getFly(this.Cells[col][index]);
        cntr++;
        this.addToFly(match,this.Cells[col][index-1]);
        this.killFish(this.Cells[col][index-1],true);
        //this.Cells[col][index-1].obj = null;
     //   this.killCell(col,index-1);
    }

    if(cntr==0)  return false;

    match.type = this.Cells[col][index].type + cntr;
   if(match.type>34) match.type = 35; //TEMP
  //  match.dest = this.Cells[col][index];
    match.scoreup = this.DoScoreUp(match.type);

    this.makeFishMergeFX(match);
  //  this.Papa.addFishFX(match.dest.x,match.dest.y,this.gameGroup,
   //     this.getFishFXType(match.matchesNum,match.type),this.OnMergeAnimOver,this);

    this.MergeAnimCntr++;
    this.checkMatch(match,cntr);

    return true;
};

CField.prototype.getFishFXType = function(num,type) {
    if(this.FreenzyFlag)  return 2;
    if(this.MoveMatchesCntr>1) return 2;
    if(num>2)  return 2;
   // if(num>1 && type>8)  return 2;
    //if(this.RowMatchCntr>1) return 2;
   // if(this.RowMatchCntr>0) return 1;
    if(num>1)  return 1;
    if(this.MoveMatchesCntr>0) return 1;
    return 0;
};

CField.prototype.checkMatch = function(match,cntr) {

    if(match.type>this.MaxFishType) {
        this.MaxFishType = match.type;
        this.MaxFishBeatFlag = true;
    }
    if(cntr>this.MoveBestMatchNum)
        this.MoveBestMatchNum = cntr;
};

CField.prototype.getMatchesAroundCell = function(col,index,type) {

    var cntr = 0;

    // left
    if(col>0 && this.Cells[col-1][index]!==undefined && this.Cells[col-1][index].obj!=null &&
        this.Cells[col-1][index].matches>0 && this.Cells[col-1][index].flag==false &&
        this.Cells[col-1][index].type==type) {
       // this.MatchingCells[cntr] = this.Cells[col-1][index];
        this.Cells[col-1][index].flag = true;
        this.MatchesTemp[this.MatchesTempNum] = this.Cells[col-1][index];
        this.MatchesTempNum++;
        cntr++;
        cntr += this.getMatchesAroundCell(col-1,index,type);
    }

    // right
    if(col<(Base.GameCols-1) && this.Cells[col+1][index]!==undefined && this.Cells[col+1][index].obj!=null &&
        this.Cells[col+1][index].flag==false && this.Cells[col+1][index].type==type &&
        this.Cells[col+1][index].matches>0) {
      //  this.MatchingCells[cntr] = this.Cells[col+1][index];
        this.Cells[col+1][index].flag = true;
        this.MatchesTemp[this.MatchesTempNum] = this.Cells[col+1][index];
        this.MatchesTempNum++;
        cntr++;
        cntr += this.getMatchesAroundCell(col+1,index,type);
    }

    //top
    if(index>0 && this.Cells[col][index-1]!==undefined && this.Cells[col][index-1].obj!=null &&
        this.Cells[col][index-1].flag==false && this.Cells[col][index-1].type==type &&
        this.Cells[col][index-1].matches>0) {
       // this.MatchingCells[cntr] = this.Cells[col][index-1];
        this.Cells[col][index-1].flag = true;
        this.MatchesTemp[this.MatchesTempNum] = this.Cells[col][index-1];
        this.MatchesTempNum++;
        cntr++;
        cntr += this.getMatchesAroundCell(col,index-1,type);
    }

    //down
    if(index<(this.CellsNum[col]-1) && this.Cells[col][index+1]!==undefined && this.Cells[col][index+1].obj!=null &&
        this.Cells[col][index+1].flag==false && this.Cells[col][index+1].type==type &&
        this.Cells[col][index+1].matches>0) {
       // this.MatchingCells[cntr] = this.Cells[col][index+1];
        this.Cells[col][index+1].flag = true;
        this.MatchesTemp[this.MatchesTempNum] = this.Cells[col][index+1];
        this.MatchesTempNum++;
        cntr++;
        cntr += this.getMatchesAroundCell(col,index+1,type);
    }

    return cntr;
};

CField.prototype.checkJokerOnMatch = function(col,index) {

    var cntr = 0;
    var match = null;
    // left
    var type = -1;
    //top
    if(index>0 && this.Cells[col][index-1]!==undefined && this.Cells[col][index-1].obj!=null  &&
        this.Cells[col][index-1].coin==false)
    {
        if(cntr==0) match = this.getFly(this.Cells[col][index]);
        cntr++;
        this.addToFly(match,this.Cells[col][index-1]);
        type = this.Cells[col][index-1].type;
        this.killFish(this.Cells[col][index-1],true);
        //this.Cells[col][index-1].img = null;

        //check left
        if(col>0 && this.Cells[col-1][index]!==undefined && this.Cells[col-1][index].obj!=null &&
            this.Cells[col-1][index].type===type && this.Cells[col-1][index].coin==false)
        {
            cntr++;
            this.addToFly(match,this.Cells[col-1][index]);
            this.killFish(this.Cells[col-1][index],true);
          //  this.Cells[col-1][index].img = null;
        }
        //check right
        if(col<(Base.GameCols-1) && this.Cells[col+1][index]!==undefined && this.Cells[col+1][index].obj!=null &&
            this.Cells[col+1][index].type===type && this.Cells[col+1][index].coin==false)
        {
            cntr++;
            this.addToFly(match,this.Cells[col+1][index]);
            this.killFish(this.Cells[col+1][index],true);
           // this.Cells[col+1][index].img = null;
        }
    }

    if(type<0) {
        if(col>0 && this.Cells[col-1][index]!==undefined && this.Cells[col-1][index].obj!=null
            && this.Cells[col-1][index].coin==false)
        {
            if(cntr==0) match = this.getFly(this.Cells[col][index]);
            cntr++;
            this.addToFly(match,this.Cells[col-1][index]);
            type = this.Cells[col-1][index].type;
            this.killFish(this.Cells[col-1][index],true);
          //  this.Cells[col-1][index].img = null;
            //  this.killCell(col-1,index);

            //check right
            if(col<(Base.GameCols-1) && this.Cells[col+1][index]!==undefined && this.Cells[col+1][index].obj!=null &&
                this.Cells[col+1][index].type===type && this.Cells[col+1][index].coin==false)
            {
                cntr++;
                this.addToFly(match,this.Cells[col+1][index]);
                this.killFish(this.Cells[col+1][index],true);
                //this.Cells[col+1][index].img = null;
            }
        }
    }

    if(type<0) {
        // right
        if(col<(Base.GameCols-1) && this.Cells[col+1][index]!==undefined && this.Cells[col+1][index].obj!=null
            && this.Cells[col+1][index].coin==false)
        {
            if(cntr==0) match = this.getFly(this.Cells[col][index]);
            cntr++;
            this.addToFly(match,this.Cells[col+1][index]);
            type = this.Cells[col+1][index].type;
            this.killFish(this.Cells[col+1][index],true);
          //  this.Cells[col+1][index].img = null;
            //  this.killCell(col+1,index);
        }
    }

    if(type<0) {
        // no any fish around
        // delete joker
        this.makeOneFishGone(this.Cells[col][index]);
        return false;
    }

    if(cntr==0)  return false;

    match.type = type + cntr;
    if(match.type>34) match.type = 35; // TEMP
   // match.dest = this.Cells[col][index];
   // this.Papa.addFishFX(match.dest.x,match.dest.y,this.gameGroup,
    //    this.getFishFXType(match.matchesNum,match.type),this.OnMergeAnimOver,this);
    this.makeFishMergeFX(match);
    this.MergeAnimCntr++;
    match.scoreup = this.DoScoreUp(match.type);
    this.checkMatch(match,cntr);

    return true;
};

CField.prototype.checkOnCoin = function(col) {
    if(this.CellsNum[col]>0) {
        if(this.Cells[col][this.CellsNum[col] - 1].coin)
            return true;
    }
    return false
};

CField.prototype.killCoin = function(col) {
    if(this.CellsNum[col]>0) {
        var cel = this.Cells[col][this.CellsNum[col] - 1];
        this.killFish(cel,false);
      //  cel.img.kill();
      //  cel.img = null;
        cel.coin = false;
        this.CellsNum[col]--;
        this.getDistCellsMax();
    }
};

CField.prototype.getColBottom = function(col) {
    if(this.CellsNum[col]>0) {
        if(this.Cells[col][this.CellsNum[col] - 1].coin) {
            if((this.CellsNum[col] - 2)>=0)
                return this.Cells[col][this.CellsNum[col] - 2];
        }
        else  return this.Cells[col][this.CellsNum[col] - 1];
    }
    return this.Pushers[col];
};

CField.prototype.Kill = function() {
    if(!this.ActiveFlag)  return;

    if(this.HelpFlag)  this.StopHelp();
    this.Threads.removeThread(this,this.update);
    this.Threads.removeThread(this,this.updateShift);
    this.Threads.removeThread(this,this.updateFish);

    if(this.FreenzyFlag ) {
        this.StopFreenzy();
    }
    this.Clear();

    this.ActiveFlag = false;
};

CField.prototype.Clear = function() {

    for(var i=0;i<this.PushersNum;i++) {
        this.Pushers[i].img.kill();
        this.Pushers[i].img = null;
    }
    this.PushersNum = 0;
    this.PusherLinesNum = 0;

    for(i=0;i<Base.GameCols;i++) {
        for (var k = 0; k < this.CellsNum[i]; k++) {
            if (this.Cells[i][k].obj != null) {
                this.killFish(this.Cells[i][k],false);
             //   this.Cells[i][k].img.kill();
             //   this.Cells[i][k].img = null;
            }
        }
        this.CellsNum[i] = 0;
    }
};

CField.prototype.KillCells = function() {
    for(var i=0;i<Base.GameCols;i++) {
        for (var k = 0; k < this.CellsNum[i]; k++) {
            if (this.Cells[i][k].img != null) {
                this.killFish(this.Cells[i][k],false);
              //  this.Cells[i][k].img.kill();
              //  this.Cells[i][k].img = null;
            }
        }
        this.CellsNum[i] = 0;
    }
};

CField.prototype.addPushersLine = function() {

    var y = -(this.PusherLinesNum*Base.CellDiam + Base.CellDiam/2);
    for(var i=0;i<this.ColsNum;i++) {
        if(this.Pushers[this.PushersNum]===undefined)
            this.Pushers[this.PushersNum] = {col:0,img:null};
        this.Pushers[this.PushersNum].img = this.Papa.getZeroImg(Base.Lines[i],y,
            'atlas','startpointBlock.png',this.gameGroup,0);
        this.Pushers[this.PushersNum].col = i;
        this.Pushers[this.PushersNum].x = Base.Lines[i];
        this.Pushers[this.PushersNum].y = y;
        this.Pushers[this.PushersNum].empty = true;
        this.PushersNum++;
    }

    this.Y_pushtop += Base.CellDiam;
    this.PusherLinesNum++;
};

CField.prototype.Stop = function() {
    this.SpeedDownFlag = false;
    this.SpeedUpFlag = false;
};

CField.prototype.checkCellAlive = function(row,col) {
    if(this.Cells[col][row]!=undefined) {
        if(this.Cells[col][row].obj!==null)
            return true;
    }
    return false;
};

CField.prototype.update = function() {

    if(this.SpeedDownFlag) {
        this.Y += this.SpeedDown*Base.RealTimeInt;
        if(this.Y>this.Y_pushtop)
            this.addPushersLine();
        if(this.ClickAllowFlag && (this.Y+this.DistCellsMax)>this.Y_end) {
          //  this.Stop();
          //  this.Papa.OnFieldGameover();
            //this.setFlashUp(2);

            this.OnLoose();
            return;
        }
    }

    if(this.SpeedUpFlag) {
        this.Y -= this.SpeedUp*Base.RealTimeInt;
        if(this.Y<this.Y_top)  this.Y =  this.Y_top;
        this.SpeedUp -= this.SpeedUpFade*Base.RealTimeInt;
        if(this.SpeedUp<0) {
            this.SpeedUp = 0;
            this.SpeedUpFlag = false;
        }
    }

    this.gameGroup.y = this.Y;

    if(this.FlysNum>0) {

      //  console.log("fly...");
        this.FlysDist -= Base.RealTimeInt*5;
        if(this.FlysDist<0) { this.FlysDist = 0;}

        for(var i=0;i<this.FlysNum;i++) {
            var matches = this.Flys[i].matches;
            for(var k=0;k<this.Flys[i].matchesNum;k++) {
                matches[k].x = this.Flys[i].dest.x + matches[k].dx*this.FlysDist*this.FlysDist;
                matches[k].y = this.Flys[i].dest.y + matches[k].dy*this.FlysDist*this.FlysDist;
                matches[k].img.x = matches[k].x;
                matches[k].img.y = matches[k].y;
                matches[k].img.alpha = this.FlysDist;
            }
        }

        if(this.FlysDist<=0) {
            // finish matches
            for(i=0;i<this.FlysNum;i++) {

                this.Flys[i].dest.type = this.Flys[i].type;
               // this.Flys[i].dest.img.frameName = Base.Fishki[ this.Flys[i].type].frame;
                this.Flys[i].dest.obj.img.frameName = Base.FishPads[this.Flys[i].type];
                this.Flys[i].dest.obj.top.frameName = Base.FishNums[this.Flys[i].type];
                this.Flys[i].dest.obj.top.visible = true;

                if((this.Flys[i].dest.obj.img.y+this.Y)<550 &&
                    this.checkCellAlive(this.Flys[i].dest.row+1,this.Flys[i].dest.col)===false) {

                    if(this.FreenzyFlag)
                       var pop =  this.Papa.addScorePop(this.Flys[i].dest.obj.img.x,
                            this.gameGroup.y+this.Flys[i].dest.obj.img.y+55,
                            this.Flys[i].scoreup*2,this.FreenzyFlag,this.Flys[i].dest.row,
                           this.Flys[i].dest.col);
                    else
                       pop =  this.Papa.addScorePop(this.Flys[i].dest.obj.img.x,
                            this.gameGroup.y+this.Flys[i].dest.obj.img.y+55,
                            this.Flys[i].scoreup,this.FreenzyFlag,this.Flys[i].dest.row,
                            this.Flys[i].dest.col);

                    if(pop!=null) pop.setRowCol(this.Flys[i].dest.row,
                        this.Flys[i].dest.col);
                }

                this.MoveScoreCntr += this.Flys[i].scoreup;
                this.MoveMatchesCntr++;

                for(k=0;k<this.Flys[i].matchesNum;k++) {
                   // this.killFish(this.Flys[i].matches[k],false);
                      this.Flys[i].matches[k].img.visible = false;
                  //  this.Flys[i].matches[k].img = null;
                }
            }
            this.FlysNum = 0;
            this.setSpeedUp(1);

          /*  if(!this.setShifting())
            {
              // unreachable
                this.OnShiftingEnd();
            } */
        }
    }
};