
CBaseWnd = function (papa,threads,group,groupTop) {
    this.Papa = papa; //papa is the Game
    this.Threads = threads;
    this.Group = group;
    this.GroupTop = groupTop;
    this.ActiveFlag = false;

    this.Buttons = [];
    this.Imgs = [];
    this.Texts = [];
    this.TextVecs = [];

    this.Xc = 0;
    this.Yc = 0;

    this.ImgsNum  = 0;
    this.TextsNum = 0;
    this.TextVecsNum = 0;
    this.ButtonsNum = 0;

    this.ShiftX = 0;
    this.ShiftY = 0;

    this.Shifters = [];
    this.ShiftersNum = 0;

    this.Faders = [];
    this.FadersNum = 0;

    this.Groups = [];
    this.GroupsNum = 0;

    this.Alpha = 1;
    this.Scale = 1;
};

CBaseWnd.prototype.clear = function() {
    this.ShiftersNum = 0;
    this.FadersNum = 0;
};


CBaseWnd.prototype.P3EasingIn = function(k)
{
    return k * k * k;
};

CBaseWnd.prototype.P3EasingOut = function(k)
{
    return --k * k * k   +  1;

};

CBaseWnd.prototype.P2EasingIn = function(k)
{
    return k * k;
};

CBaseWnd.prototype.P2EasingOut = function(k)
{
    return k * ( 2 - k );
};

CBaseWnd.prototype.initFading = function(func) {
    this.FadersNum = 0;
    this.FadersFunc = func;
    this.Threads.addThread(this,this.updateFadings);
};

CBaseWnd.prototype.addFading = function(img,dest,time,tween,delay) {
    if(this.Faders[this.FadersNum]==undefined)
        this.Faders[this.FadersNum] = {obj:null,flag:false};
    var obj = this.Faders[this.FadersNum];
    this.FadersNum++;
    obj.obj = img;
    obj.time = time;
    obj.timeCntr = 0;
    obj.alpha = img.alphaCoeff;
    obj.alpha0 = img.alphaCoeff;
    obj.alpha1  = dest;
    obj.tweenFunc = tween;
    obj.delay = delay;
    obj.flag = true;
    return obj;
};

CBaseWnd.prototype.updateFadings = function() {

    var last = -1;
    for(var i=0;i<this.FadersNum;i++) {
        var shift = this.Faders[i];
        if(shift.flag) {
            last = i;

            if(shift.delay<0) {
                shift.timeCntr+=Base.RealTimeInt;
                if(shift.timeCntr>=shift.time) {
                    shift.timeCntr = shift.time;
                    shift.flag = false;
                }
                var coeff = shift.timeCntr/shift.time;
                coeff = shift.tweenFunc(coeff);
                shift.alpha =  shift.alpha0  + (shift.alpha1-shift.alpha0)*coeff;

                if(shift.obj.obj!==null) {
                    shift.obj.alphaCoeff = shift.alpha;
                    shift.obj.obj.alpha = shift.obj.alphaCoeff;
                }
            } else {
                shift.delay-=Base.RealTimeInt;
            }
        }
    }
    if(last<0) {
        this.Threads.removeThread(this,this.updateFadings);
        if(this.FadersFunc!=null) this.FadersFunc.call(this);
    }
};

CBaseWnd.prototype.initShifting = function(func) {
    this.ShiftersNum = 0;
    this.ShiftersFunc = func;
    this.Threads.addThread(this,this.updateShiftings)
};

CBaseWnd.prototype.addShifter = function(img,sx,sy,time,tween,delay) {
    if(this.Shifters[this.ShiftersNum]==undefined)
        this.Shifters[this.ShiftersNum] = {obj:null,flag:false};
    var obj = this.Shifters[this.ShiftersNum];
    this.ShiftersNum++;
    obj.obj = img;
    obj.time = time;
    obj.timeCntr = 0;
    obj.sx0 = img.sx;
    obj.sy0 = img.sy;
    obj.sx1  = sx;
    obj.sy1  = sy;
    obj.tweenFunc = tween;
    obj.delay = delay;
    obj.flag = true;
    return obj;
};

CBaseWnd.prototype.updateShiftings = function() {

    var last = -1;
    for(var i=0;i<this.ShiftersNum;i++) {
        var shift = this.Shifters[i];
        if(shift.flag) {
            last = i;
            shift.delay-=Base.RealTimeInt;
            if(shift.delay<0) {
                shift.timeCntr+=Base.RealTimeInt;
                if(shift.timeCntr>=shift.time) {
                    shift.timeCntr = shift.time;
                    shift.flag = false;
                }
                var coeff = shift.timeCntr/shift.time;
                coeff = shift.tweenFunc(coeff);
                if(shift.obj.obj!==null) {
                    shift.obj.sx = shift.sx0  + (shift.sx1 - shift.sx0)*coeff;
                    shift.obj.sy = shift.sy0  + (shift.sy1 - shift.sy0)*coeff;

                    shift.obj.obj.x = this.Xc + shift.obj.x + this.ShiftX + shift.obj.sx;
                    shift.obj.obj.y = this.Yc + shift.obj.y + this.ShiftY + shift.obj.sy;
                }
            }
        }
    }
    if(last<0) {
        this.Threads.removeThread(this,this.updateShiftings);
        if(this.ShiftersFunc!=null) this.ShiftersFunc.call(this);
    }
};

CBaseWnd.prototype.OnResize = function() {

};

CBaseWnd.prototype.setAlpha = function(obj,alpha) {
    obj.alphaCoeff = alpha;
    obj.obj.alpha = this.Alpha*obj.alphaCoeff;
};

CBaseWnd.prototype.setButtonsAlpha = function(alpha) {
    for(var i=0;i<this.ButtonsNum;i++) {
        if(this.Buttons[i].obj!=null)
        {
            this.Buttons[i].alphaCoeff = alpha;
            this.Buttons[i].obj.alpha = this.Alpha*this.Buttons[i].alphaCoeff;
        }
    }
};

CBaseWnd.prototype.setTextsAlpha = function(alpha) {
    for(var i=0;i<this.TextsNum;i++) {
        if(this.Texts[i].obj!=null)
        {
            this.Texts[i].alphaCoeff = alpha;
            this.Texts[i].obj.alpha = this.Alpha*this.Texts[i].alphaCoeff;
        }
    }
};

CBaseWnd.prototype.setTextVecsAlpha = function(alpha) {
    for(var i=0;i<this.TextVecsNum;i++) {
        if(this.TextVecs[i].obj!=null)
        {
            this.TextVecs[i].alphaCoeff = alpha;
            this.TextVecs[i].obj.alpha = this.Alpha*this.TextVecs[i].alphaCoeff;
        }
    }
};

CBaseWnd.prototype.setImgsAlpha = function(alpha) {
    for(var i=0;i<this.ImgsNum;i++) {
        if(this.Imgs[i].obj!=null)
        {
            this.Imgs[i].alphaCoeff = alpha;
            this.Imgs[i].obj.alpha = this.Alpha*this.Imgs[i].alphaCoeff;
        }
    }
};

CBaseWnd.prototype.setGroupsAlpha = function(alpha) {
    for(var i=0;i<this.GroupsNum;i++) {
        if(this.Groups[i].obj!=null)
        {
            this.Groups[i].alphaCoeff = alpha;
            this.Groups[i].obj.alpha = this.Alpha*this.Groups[i].alphaCoeff;
        }
    }
};

CBaseWnd.prototype.makeElementsVisible = function(vis) {
    for(var i=0;i<this.ImgsNum;i++) {
        if(this.Imgs[i].obj!=null)
        {
            this.Imgs[i].obj.visible = vis;
        }
    }
    for(i=0;i<this.ButtonsNum;i++) {
        if(this.Buttons[i].obj!=null)
        {
            this.Buttons[i].obj.visible = vis;
        }
    }
    for(i=0;i<this.TextsNum;i++) {
        if(this.Texts[i].obj!=null)
        {
            this.Texts[i].obj.visible = vis;
        }
    }
    for(i=0;i<this.TextVecsNum;i++) {
        if(this.TextVecs[i].obj!=null)
        {
            this.TextVecs[i].obj.visible = vis;
        }
    }
    for(i=0;i<this.GroupsNum;i++) {
        if(this.Groups[i].obj!=null)
        {
            this.Groups[i].obj.visible = vis;
        }
    }
};

CBaseWnd.prototype.setObjShift = function(obj,sx,sy) {
    obj.sx = sx;
    obj.sy = sy;
};

CBaseWnd.prototype.setObjXY = function(obj,x,y) {
    obj.x = x;
    obj.y = y;
    this.updateObj(obj);
};

CBaseWnd.prototype.killObj = function(obj) {
    if(obj==null)  return;
    if(obj.obj==null)  return;
    obj.obj.kill();
    obj.obj = null;
};

CBaseWnd.prototype.updateObj = function(obj) {
    obj.obj.x = this.Xc + obj.x + this.ShiftX + obj.sx ;
    obj.obj.y = this.Yc + obj.y + this.ShiftY + obj.sy ;
    obj.obj.alpha = this.Alpha*obj.alphaCoeff;
    obj.obj.scale.set(this.Scale*obj.scaleCoeff);
};

CBaseWnd.prototype.updateImg = function(img) {
    img.obj.x = this.Xc + img.x + this.ShiftX + img.sx ;
    img.obj.y = this.Yc + img.y + this.ShiftY + img.sy ;
    img.obj.alpha = this.Alpha*img.alphaCoeff;
    img.obj.scale.set(this.Scale*img.scaleCoeff);
};

CBaseWnd.prototype.updateButton = function(butt) {
    butt.obj.x = this.Xc + butt.x + this.ShiftX + butt.sx ;
    butt.obj.y = this.Yc + butt.y + this.ShiftY + butt.sy ;
    butt.obj.alpha = this.Alpha*butt.alphaCoeff;
    butt.obj.scale.set(this.Scale*butt.scaleCoeff);
};


CBaseWnd.prototype.updateText = function(text) {
    text.obj.x = this.Xc + text.x + this.ShiftX + text.sx ;
    text.obj.y = this.Yc + text.y + this.ShiftY + text.sy ;
    text.obj.alpha = this.Alpha*text.alphaCoeff;
    text.obj.scale.set(this.Scale*text.scaleCoeff);
};

CBaseWnd.prototype.updateTextVec = function(text) {
    text.obj.x = this.Xc + text.x + this.ShiftX + text.sx ;
    text.obj.y = this.Yc + text.y + this.ShiftY + text.sy ;
    text.obj.alpha = this.Alpha*text.alphaCoeff;
    text.obj.scale.set(this.Scale*text.scaleCoeff);
};

CBaseWnd.prototype.updateGroup = function(group) {
    group.obj.x = this.Xc + group.x + this.ShiftX + group.sx ;
    group.obj.y = this.Yc + group.y + this.ShiftY + group.sy ;
    group.obj.alpha = this.Alpha*group.alphaCoeff;
    group.obj.scale.set(this.Scale*group.scaleCoeff);
};

CBaseWnd.prototype.updateElements = function() {

    for(var i=0;i<this.ImgsNum;i++) {
        if(this.Imgs[i].obj!=null)
        {
            this.updateImg(this.Imgs[i]);
        }
    }
    for(i=0;i<this.ButtonsNum;i++) {
        if(this.Buttons[i].obj!=null)
        {
            this.updateButton(this.Buttons[i]);
        }
    }
    for(i=0;i<this.TextsNum;i++) {
        if(this.Texts[i].obj!=null)
        {
            this.updateText(this.Texts[i]);
        }
    }
    for(i=0;i<this.TextVecsNum;i++) {
        if(this.TextVecs[i].obj!=null)
        {
            this.updateTextVec(this.TextVecs[i]);
        }
    }
    for(i=0;i<this.GroupsNum;i++) {
        if(this.Groups[i].obj!=null)
        {
            this.updateGroup(this.Groups[i]);
        }
    }
};

CBaseWnd.prototype.addGroup = function(x,y,group,order)
{
    if(this.Groups[this.GroupsNum]==undefined)
        this.Groups[this.GroupsNum] = {x:0,y:0,obj:null};
    var obj = this.Groups[this.GroupsNum];
    this.GroupsNum++;

    //x,y,tex,frameName,group,order
    obj.obj = this.Papa.game.add.group();
    group.add(obj.obj);
    obj.x = x ;
    obj.y = y ;
    obj.sx = 0 ;
    obj.sy = 0 ;
    obj.scaleCoeff = 1;
    obj.scalingFlag = false;
    obj.alphaCoeff = 1;
   // obj.obj.anchor.set(0.5);
    obj.obj.Order = order;
    return obj;
};

CBaseWnd.prototype.addImg = function(x,y,tex,frameName,group,order)
{
    if(this.Imgs[this.ImgsNum]==undefined)
        this.Imgs[this.ImgsNum] = {x:0,y:0,obj:null};
    var obj = this.Imgs[this.ImgsNum];
    this.ImgsNum++;

    //x,y,tex,frameName,group,order
    obj.obj = this.Papa.getZeroImg(this.Xc+x+ this.ShiftX,this.Yc+y+ this.ShiftY,
        tex,frameName,group,0);
    obj.x = x ;
    obj.y = y ;
    obj.sx = 0;
    obj.sy = 0;
    obj.scaleCoeff = 1;
    obj.scalingFlag = false;
    obj.alphaCoeff = 1;
    obj.obj.anchor.set(0.5);
    obj.obj.Order = order;
    return obj;
};

CBaseWnd.prototype.addBitmapText = function(x,y,font,str,size,group,order)
{
    if(this.Texts[this.TextsNum]==undefined)
        this.Texts[this.TextsNum] = {x:0,y:0,obj:null};
    var obj = this.Texts[this.TextsNum];
    this.TextsNum++;

    //x,y,font,str,size,group
    obj.obj = this.Papa.getBitmapText(this.Xc+x+this.ShiftX,this.Yc+y+this.ShiftY,
        font,str,size,group);
    obj.x = x ;
    obj.y = y ;
    obj.sx = 0 ;
    obj.sy = 0 ;
    obj.scaleCoeff = 1;
    obj.alphaCoeff = 1;
    obj.obj.Order = order;
    return obj;
};

CBaseWnd.prototype.addText = function(x,y,text,group,order)
{
    if(this.TextVecs[this.TextVecsNum]==undefined)
        this.TextVecs[this.TextVecsNum] = {x:0,y:0,obj:null};
    var obj = this.TextVecs[this.TextVecsNum];
    this.TextVecsNum++;
    group.add(text);
    //x,y,font,str,size,group
    obj.obj =  text;
    obj.x = x ;
    obj.y = y ;
    obj.sx = 0 ;
    obj.sy = 0 ;
    obj.scaleCoeff = 1;
    obj.alphaCoeff = 1;
    obj.obj.Order = order;
    return obj;
};

CBaseWnd.prototype.addButton = function(x,y,tex,frames,callback,callbackContext,group,order)
{
    if(this.Buttons[this.ButtonsNum]==undefined)
        this.Buttons[this.ButtonsNum] = {x:0,y:0,obj:null};
    var obj = this.Buttons[this.ButtonsNum];
    this.ButtonsNum++;

    /*  obj.butt = this.Papa.game.make.button(0, 0, tex,callback,callbackContext,
     frames[0],frames[1],frames[2],frames[3]);
     obj.x = x;
     obj.y = y;
     obj.butt.Order = order;
     this.Group.add(obj.butt);*/

    //x,y,tex,frames,callback,callbackContext,group
    obj.obj = this.Papa.getButton(this.Xc+x+ this.ShiftX,this.Yc+y+ this.ShiftY,
        tex,frames,callback,callbackContext,group);
    obj.obj.anchor.set(0.5);
    obj.x = x ;
    obj.y = y ;
    obj.sx = 0 ;
    obj.sy = 0 ;
    obj.scaleCoeff = 1;
    obj.alphaCoeff = 1;
    obj.obj.Order = order;
    return obj;
};

//###################################################################################
//###################################################################################
//###################################################################################
//###################################################################################
//金币弹窗
CWndCoins = function (papa,threads,group,groupTop) {

    CBaseWnd.call(this,papa,threads,group,groupTop);

    this.MoveTween = null;
    this.MovingFlag = false;

    this.CloseFrames = ['closeButton.png','closeButton.png',
        'closeButton.png','closeButton.png'];

    this.ResumeFrames = ['buttonContinue.png','buttonContinue.png',
        'buttonContinue.png','buttonContinue.png'];
};

CWndCoins.prototype = Object.create(CBaseWnd.prototype);
CWndCoins.prototype.constructor = CWndCoins;

CWndCoins.prototype.init = function() {

    var text =  this.Papa.game.add.text(0, 0, sgLang.adcoins[Base.Lang],
        { font: "40px FontVector", fill: "#FFFFFF", align: "center" });
    text.setShadow(0,2,'rgba(0.2,0.2,0,0.2)');
   // if(text.width>510) text.scale.set(510/text.width);
    text.anchor.set(0.5,1);
    text.Order = 1;
    this.CoinsMoreText = this.addText(0,-70,text,this.Group,1);
    text.visible = false;
   // if(text.width>560)
    //    this.CoinsMoreText.scaleCoeff = 560/text.width;

    text =  this.Papa.game.add.text(0, 0, sgLang.watch[Base.Lang],
        { font: "40px FontVector", fill: "#6b1f21", align: "center" });
    text.setShadow(0,3,'rgba(0.1,0.1,0,0.3)');
    text.anchor.set(0.5);
    text.shadowBlur = 3;
    text.Order = 1;
    this.ButtCoinsText = this.addText(0,0,text,this.Group,2);
    text.visible = false;

  //  if(text.width>230)
   //     this.ButtCoinsText.scaleCoeff = 230/text.width;

    this.ActiveFlag = false;
};

CWndCoins.prototype.create = function() {

    this.clear();
    //  CPanel.prototype.create.call(Base.Xc,Base.Yc - Base.HeightGame/2);
    this.Xc = Base.Width/2;//Base.Xc;
    this.Yc = Base.HeightGame/2;
    this.EndCall = null;

    this.Type = 0;
    this.HaltButtonsFlag = false;

    this.BgImg = this.addImg(0,0,'atlas','bg.png',this.Group,0);
    this.BgImg.obj.anchor.set(0.5);

    this.setObjXY(this.CoinsMoreText,0,-70);
    this.CoinsMoreText.obj.setText(sgLang.adcoins[Base.Lang]);
    if(this.CoinsMoreText.obj.width>560)
        this.CoinsMoreText.scaleCoeff = 560/this.CoinsMoreText.obj.width;

    this.ButtClose =  this.addButton(-270,0,'atlas',this.CloseFrames,this.OnClose,this,this.Group,1);
    this.ButtCoins =  this.addButton(0,100,'atlas',this.ResumeFrames,this.OnCoins,this,this.Group,1);
    this.setObjXY(this.ButtCoinsText,25,100-5);
    this.ButtCoinsText.obj.setText(sgLang.watch[Base.Lang]);
    this.ButtCoinsText.scaleCoeff = 1;
    this.updateTextVec(this.ButtCoinsText);
    if(this.ButtCoinsText.obj.width>175)
        this.ButtCoinsText.scaleCoeff = 175/this.ButtCoinsText.obj.width;

   // this.ButtCoinsText = this.addBitmapText(25,100-10,'MainFont','Watch',45,this.Group,2);
   // this.ButtCoinsText.obj.tint = 0x6b2022;
    this.ButtCoinsImg = this.addImg(-100,100-8,'atlas','video.png',this.Group,2);

    this.CoinPanel = this.addImg(0,100-85,'atlas','coinPanel.png',this.Group,1);
    this.CoinsText = this.addBitmapText(10,100+11-85,'GoldFont',''+Base.VideoCoins,72,this.Group,2);
    this.CoinsText.obj.anchor.set(0.5,1);

    this.CoinsImg = this.addImg(0,0,'atlas','coins.png',this.Group,1);
    this.CoinsImg.scaleCoeff = 1.8;

    this.CoinTopPanel = this.addImg(225,0,'atlas','coinPanel.png',this.Group,1);
    this.CoinsTopText = this.addBitmapText(225+15,0,'GoldFont',''+Base.Coins,70,this.Group,2);
    this.CoinsTopText.obj.anchor.set(0.5,1);

    var scale = 1;
    if(Base.Coins>=20000) scale = 0.8;
    if(Base.Coins>=200000) scale = 0.7;
    if(Base.Coins>=2000000) scale = 0.6;
    this.CoinsTopText.scaleCoeff = scale;
    this.updateText(this.CoinsTopText);

    this.makeElementsVisible(true);

    this.BgAlpha = 0;
    this.BgImg.alphaCoeff = this.BgAlpha;
    this.BgImg.obj.alpha = this.BgAlpha;

    var tween = this.Papa.Tweens.addTween(null,this.updateBgAlpha,this);
    tween.createEasingOut(this);
    tween.to({BgAlpha:0.9}, 0.5,true,this.OnReady,this);
    tween.start();

    this.setButtonsAlpha(0);
    this.initFading(null);
    this.initShifting(null);

    var dist = 400;
    this.addFading(this.CoinsImg,1,0.4,this.P3EasingIn,0);

    this.setObjShift(this.ButtClose,-dist,0);
    this.addFading(this.ButtClose,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.ButtClose,0,0+globleData.statusBarH,0.75,this.P3EasingOut,0); //img,ang,dist,time,tween,delay

    this.setObjShift(this.CoinTopPanel,dist,0);
    this.addFading(this.CoinTopPanel,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.CoinTopPanel,0,0+globleData.statusBarH,0.75,this.P3EasingOut,0);
    this.setObjShift(this.CoinsTopText,dist,0);
    this.addFading(this.CoinsTopText,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.CoinsTopText,0,0+globleData.statusBarH,0.75,this.P3EasingOut,0);

    this.setObjShift(this.CoinsMoreText,-dist,0);
    this.addFading(this.CoinsMoreText,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.CoinsMoreText,0,0,0.75,this.P3EasingOut,0);

    this.setObjShift(this.CoinPanel,dist,0);
    this.addFading(this.CoinPanel,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.CoinPanel,0,0,0.75,this.P3EasingOut,0);
    this.setObjShift(this.CoinsText,dist,0);
    this.addFading(this.CoinsText,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.CoinsText,0,0,0.75,this.P3EasingOut,0);

    this.setObjShift(this.ButtCoins,-dist,0);
    this.addFading(this.ButtCoins,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.ButtCoins,0,0,0.75,this.P3EasingOut,0);
    this.setObjShift(this.ButtCoinsText,-dist,0);
    this.addFading(this.ButtCoinsText,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.ButtCoinsText,0,0,0.75,this.P3EasingOut,0);
    this.setObjShift(this.ButtCoinsImg,-dist,0);
    this.addFading(this.ButtCoinsImg,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.ButtCoinsImg,0,0,0.75,this.P3EasingOut,0);

    this.ClickAllowFlag = true;
    this.MovingFlag = false;
    this.State = 0;
    this.ActiveFlag = true;

    this.Group.sort('Order',-1);

    this.Papa.PlaySnd(Base.SndWindow);

    this.OnResize();
};

CWndCoins.prototype.setSecondType = function() {

    this.setObjXY(this.ButtCoinsText,0,100-5);
    this.setObjXY(this.CoinsMoreText,0,-50);

    this.killObj(this.ButtClose);
    this.killObj(this.CoinPanel);
    this.killObj(this.CoinsText);
    this.killObj(this.ButtCoinsImg);
    this.CoinsMoreText.obj.setText(sgLang.thanks[Base.Lang]);
    this.CoinsMoreText.scaleCoeff = 1;

    if(this.CoinsMoreText.obj.width>570)
        this.CoinsMoreText.scaleCoeff = 570/this.CoinsMoreText.obj.width;


    this.ButtCoinsText.obj.setText(sgLang.continue[Base.Lang]);
    this.ButtCoinsText.scaleCoeff = 1;
    this.updateTextVec(this.ButtCoinsText);
    this.ButtCoinsText.obj.update();

    if(this.ButtCoinsText.obj.width>230)
        this.ButtCoinsText.scaleCoeff = 230/this.ButtCoinsText.obj.width;

    this.Type = 1;

    this.OnResize();
};

CWndCoins.prototype.OnClose = function() {
    if(this.HaltButtonsFlag)  return;
     this.Papa.PlaySnd(Base.SndButton);

    this.setFadeOut();
};

CWndCoins.prototype.OnCoins = function() {

    if(this.HaltButtonsFlag)  return;

    if(this.Type==0) {

        if(sgSettings.config.rewarded.enabled) {
            this.HaltButtonsFlag = true; //看广告得金币
            var success = true
            appBoot.showAdBase(globleData.red_hint_pos, (success)=>{
                if (success) {/* show thanks for watching screen and the reward given (e.g. coins, boosters, continue game) */
                   this.Papa.PlaySnd(Base.SndButton);
                    this.HaltButtonsFlag = false;
                    this.Papa.addCoins(Base.VideoCoins);
                   // this.CoinsText.obj.setText(Base.Coins);
                    this.setSecondType();
                }
                else {/* 'no more videos screen */
                  this.Papa.PlaySnd(Base.SndButton);
                    this.setFadeOut();
                }
            })

            // sdkHandler.trigger('rewardedAd',{
            //     callback: function(success) {
            //         if (success) {/* show thanks for watching screen and the reward given (e.g. coins, boosters, continue game) */
            //            this.Papa.PlaySnd(Base.SndButton);
            //             this.HaltButtonsFlag = false;
            //             this.Papa.addCoins(Base.VideoCoins);
            //            // this.CoinsText.obj.setText(Base.Coins);
            //             this.setSecondType();
            //         }
            //         else {/* 'no more videos screen */
            //           this.Papa.PlaySnd(Base.SndButton);
            //             this.setFadeOut();
            //         }
            //     }
            // },this);
        }
        else
        {
            /*this.Papa.PlaySnd(Base.SndButton);  // TEMP
            this.HaltButtonsFlag = false; // TEMP
            this.Papa.addCoins(Base.VideoCoins); // TEMP
            this.setSecondType(); // TEMP */

           this.Papa.PlaySnd(Base.SndButton);   // REAL
           this.setFadeOut(); // REAL
        }
       /* this.Papa.PlaySnd(Base.SndButton);
        this.Papa.addCoins(Base.VideoCoins);
        this.CoinsText.obj.setText(Base.Coins);
        this.setSecondType(); */
    }
    else {
       this.Papa.PlaySnd(Base.SndButton);
        this.setFadeOut();
    }
};

CWndCoins.prototype.OnReady = function() {
    this.BlockButtons(false);
};

CWndCoins.prototype.BlockButtons = function(block) {
    this.ButtCoins.obj.input.enabled = !block;
    if(this.ButtClose.obj!=null)
       this.ButtClose.obj.input.enabled = !block;
};

CWndCoins.prototype.setFadeOut = function() {
    this.BlockButtons(true);

    this.initFading(null);
    this.initShifting(null);

    this.addFading(this.CoinsImg,0,0.35,this.P2EasingOut,0);
    if(this.Type==0) this.addFading(this.ButtClose,0,0.35,this.P2EasingOut,0);
    this.addFading(this.CoinTopPanel,0,0.35,this.P2EasingOut,0);
    this.addFading(this.CoinsTopText,0,0.35,this.P2EasingOut,0);

    var dist = -400;

    this.addFading(this.CoinsMoreText,0,0.35,this.P2EasingOut,0);
    this.addShifter(this.CoinsMoreText,dist,0,0.75,this.P3EasingOut,0);
    dist = -dist;

    if(this.Type==0) this.addFading(this.CoinPanel,0,0.35,this.P2EasingOut,0);
    if(this.Type==0)  this.addShifter(this.CoinPanel,dist,0,0.75,this.P3EasingOut,0);
    if(this.Type==0) this.addFading(this.CoinsText,0,0.35,this.P2EasingOut,0);
    if(this.Type==0)  this.addShifter(this.CoinsText,dist,0,0.75,this.P3EasingOut,0);
    if(this.Type==0) dist = -dist;

    this.addFading(this.ButtCoins,0,0.35,this.P2EasingOut,0);
    this.addShifter(this.ButtCoins,dist,0,0.75,this.P3EasingOut,0);
    this.addFading(this.ButtCoinsText,0,0.35,this.P2EasingOut,0);
    this.addShifter(this.ButtCoinsText,dist,0,0.75,this.P3EasingOut,0);
    if(this.Type==0)   this.addFading(this.ButtCoinsImg,0,0.35,this.P2EasingOut,0);
    if(this.Type==0) this.addShifter(this.ButtCoinsImg,dist,0,0.75,this.P3EasingOut,0);
    dist = -dist;

    var tween = this.Papa.Tweens.addTween(null,this.updateBgAlpha,this);
    tween.createEasingOut(this);
    tween.to({BgAlpha:0}, 0.75,true,this.OnEnd,this);
    tween.start();

    this.Papa.PlaySnd(Base.SndWindow);
};

CWndCoins.prototype.updateBgAlpha = function() {
    if(this.BgImg.obj==null)  return;
    this.BgImg.alphaCoeff = this.BgAlpha;
    this.BgImg.obj.alpha = this.BgAlpha;
};

CWndCoins.prototype.OnEnd = function() {
    this.makeElementsVisible(false);
    this.Papa.PauseOff();

    this.killObj(this.BgImg);
    this.killObj(this.CoinsImg);
    this.killObj(this.ButtClose);
    this.killObj(this.CoinTopPanel);
    this.killObj(this.CoinsTopText);
    this.killObj(this.CoinPanel);
    this.killObj(this.CoinsText);
    this.killObj(this.ButtCoins);
  //  this.killObj(this.ButtCoinsText);
    this.killObj(this.ButtCoinsImg);

    this.ActiveFlag = false;
    if(this.EndCall!=null) this.EndCall.call(this);
};

CWndCoins.prototype.OnResize = function() {
    if(!this.ActiveFlag)  return;

    this.Yc = Base.HeightGame/2;

    this.CoinTopPanel.y = -Base.HeightGame/2 + 52;
    this.CoinsTopText.y = -Base.HeightGame/2 + 52 + 11;
    this.ButtClose.y = -Base.HeightGame/2 + 52;

    this.updateElements();
    this.BgImg.obj.scale.set(1,Base.HeightGame/960);
};

//###################################################################################
//###################################################################################
//###################################################################################
//###################################################################################
//红包弹窗区域
CWndRedPacket = function (papa,threads,group,groupTop) {

    CBaseWnd.call(this,papa,threads,group,groupTop);

    this.MoveTween = null;
    this.MovingFlag = false;

    this.PopOpenbg = ['pop_open.png','pop_open.png','pop_open.png','pop_open.png'];
    this.PopOpenClose = ['pop_open_close.png','pop_open_close.png','pop_open_close.png','pop_open_close.png'];
    this.PopBalanceClose = ['pop_balance_close.png','pop_balance_close.png','pop_balance_close.png','pop_balance_close.png'];

    this.PopOpenRed = ['popblackbg.png','popblackbg.png','popblackbg.png','popblackbg.png'];
    this.PopWithBlank = ['popBlank.png','popBlank.png','popBlank.png','popBlank.png'];
    // this.MusicFrames0 = ['musicB.png','musicB.png','musicB.png','musicB.png'];
    // this.MusicFrames1 = ['musicBgrey.png','musicBgrey.png','musicBgrey.png','musicBgrey.png'];
};

CWndRedPacket.prototype = Object.create(CBaseWnd.prototype);
CWndRedPacket.prototype.constructor = CWndRedPacket;

CWndRedPacket.prototype.init = function() {
  /*  this.BgImg = this.addImg(0,0,'atlas','bg.png',this.Group);
    this.BgImg.obj.anchor.set(0.5);

    this.ButtResume =  this.addButton(0,-165,'atlas',this.ResumeFrames,this.OnResume,this,this.Group);
    this.ButtReplay =  this.addButton(0,0,'atlas',this.ReplayFrames,this.OnReplay,this,this.Group);
    this.ButtSound =  this.addButton(-105,120,'atlas',this.SoundFrames0,this.OnSound,this,this.Group);
    this.ButtMusic =  this.addButton(105,120,'atlas',this.MusicFrames0,this.OnMusic,this,this.Group);
*/
    this.ActiveFlag = false;
};

CWndRedPacket.prototype.create = function(type,callback) {
    // pop红包 type == 1 是显示余额的背景，2 显示开红包背景
    this.clear();
    //  CPanel.prototype.create.call(Base.Xc,Base.Yc - Base.HeightGame/2);
    this.Xc = Base.Width/2;//Base.Xc;
    this.Yc = Base.HeightGame/2;
    this.EndCall = null;

    this.BgImg = this.addImg(0,0,'atlas','bg.png',this.Group,0);
    this.BgImg.obj.anchor.set(0.5);

    this.PopOpenImg = this.addImg(0,0,'newimg',type == 1 ? 'pop_balance.png' :  'pop_open.png',this.Group,1);
    this.PopOpenImg.obj.anchor.set(0.5,0.5);

    this.ButtOpenClose =  this.addButton(210, -288,'newimg',type == 1 ? this.PopBalanceClose :  this.PopOpenClose,this.setFadeOut,this,this.Group,1);
    this.ButtOpenClose.obj.anchor.set(0.5);

    var text =  this.Papa.game.add.text(0,0,  '每合成一个新数字，就有几率获得红包',
        { font: "22px FontVector", fill: "#ac2606", align: "center" });
    this.bomText = this.addText(0,310,text,this.Group,1)
    this.bomText.obj.anchor.set(0.5,1)

    
    if (type == 1) {
        text =  this.Papa.game.add.text(0,0,  '现金红包',
            { font: "50px FontVector", fill: "#c19c66", align: "center" });
        this.title1 = this.addText(0,-265,text,this.Group,1)
        this.title1.obj.anchor.set(0.5,0.5)

        text =  this.Papa.game.add.text(0,0,  '余额：'+ (globleData.profile.amount) + '元',
            { font: "36px ComicSansBold", fill: "#e96c14", align: "center" });
        this.title2 = this.addText(0,globleData.rabValue ? -165 : -125,text,this.Group,1)
        this.title2.obj.anchor.set(0.5,0.5)

        text =  this.Papa.game.add.text(0,0,  '满100元可以提现',
            { font: "22px FontVector", fill: "#d5a267", align: "center" });
        this.title21 = this.addText(0,globleData.rabValue ? -120 : -80,text,this.Group,1)
        this.title21.obj.anchor.set(0.5,0.5)

        if (globleData.rabValue) {
            text =  this.Papa.game.add.text(0,0,  globleData.rabValue + '元',
                { font: "80px ComicSansBold", fill: "#e96c14", align: "center" });
            this.title3 = this.addText(0,-30,text,this.Group,1)
            this.title3.obj.anchor.set(0.5,0.5)

            text =  this.Papa.game.add.text(0,0,  '已充入当前余额',
                { font: "22px FontVector", fill: "#c1a36c", align: "center" });
            this.title31 = this.addText(0,30,text,this.Group,1)
            this.title31.obj.anchor.set(0.5,0.5)
            
            globleData.rabValue = '' 
        }

        this.ButtWithdraw =  this.addButton(0,170,'newimg',this.PopWithBlank,this.OnWithDraw,this,this.Group,1);
        this.ButtWithdraw.obj.anchor.set(0.5);
        // debugger
        // this.ButtWithdraw.obj.width = 250;
        this.ButtWithdraw.obj.height = 90;


    }else{
        text =  this.Papa.game.add.text(0,0,  '您获得一个现金红包',
            { font: "42px FontVector", fill: "#f7ac5e", align: "center" });
        this.titleText = this.addText(0,- 120,text,this.Group,1)
        this.titleText.obj.anchor.set(0.5,0.5)

        this.ButtOpenRed =  this.addButton(0,80,'newimg',this.PopOpenRed,this.OnClickRed,this,this.Group,1);
        this.ButtOpenRed.obj.anchor.set(0.5);
        // debugger
        this.ButtOpenRed.obj.width = 250;
        this.ButtOpenRed.obj.height = 250;

    }

    // 白色弹窗

    this.PopWhiteImg = this.addImg(0,0,'newimg','pop_white_bg.png',this.Group,2);
    this.PopWhiteImg.obj.anchor.set(0.5,0.5);
    this.Papa.game.add.tween(this.PopWhiteImg.obj.scale)
        .to({
            x: .92,
            y: .92
        }, 100, Phaser.Easing.Linear.None, true);

    text =  this.Papa.game.add.text(0,0,  '红包金额达到100元方可提现',
        { font: "26px FontVector", fill: "#b5b3b6", align: "center" });
    this.whiteText = this.addText(0,-32,text,this.Group,2)
    this.whiteText.obj.anchor.set(0.5,0.5)

    text =  this.Papa.game.add.text(0,0,  '确定',
        { font: "26px FontVector", fill: "#99d7a8", align: "center" });
    this.subText = this.addText(0,63,text,this.Group,2)
    this.subText.obj.anchor.set(0.5,0.5)
    this.subText.obj.inputEnabled = true;
    this.subText.obj.events.onInputDown.add(()=> {
        this.Papa.PlaySnd(Base.SndButton);
        console.log('submit click')
        this.PopWhiteImg.obj.visible = false;
        this.whiteText.obj.visible = false;
        this.subText.obj.visible = false;

    });



    this.makeElementsVisible(true);
    this.PopWhiteImg.obj.visible = false;
    this.whiteText.obj.visible = false;
    this.subText.obj.visible = false;
    this.BgAlpha = 0;
    this.BgImg.alphaCoeff = this.BgAlpha;
    this.BgImg.obj.alpha = this.BgAlpha;

    var tween = this.Papa.Tweens.addTween(null,this.updateBgAlpha,this);
    tween.createEasingOut(this);
    tween.to({BgAlpha:0.85}, 0.5,true,this.OnReady,this);
    tween.start();

    this.initFading(null);
    this.initShifting(null);
    

    this.ClickAllowFlag = true;
    this.MovingFlag = false;
    this.State = 0;
    this.ActiveFlag = true;

    this.Group.sort('Order',-1);

    this.Papa.PlaySnd(Base.SndWindow);

    this.OnResize();
};



CWndRedPacket.prototype.OnClickRed = function() {
    if(globleData.btnClicked) return
    globleData.btnClicked = true;
    console.log('click 拆红包')

    this.Papa.PlaySnd(Base.SndButton);
    // debugger
    globleData.gameCallback = (success)=> {
        if (success) {
            appBoot.setStorageValue('hasRed',false); 
            this.Papa.DownPanel.showBalance();
            // this.BlockButtons(true);
            this.initFading(null);
            this.initShifting(null);
            this.OnEnd();
            this.init()
            this.create(1);
            this.Papa.MainPanel.PauseOn();
            this.Papa.PauseFlag = true;
        }
    }
    if(globleData.appStorage.firstOpen){//点开红包，先看广告后获取金额
    // TODO: 第一次拆红包不需要播放广告 
      appBoot.setStorageValue('firstOpen',false);
      appBoot.openRedpacket(true)
      return
    }
    appBoot.showAdBase(globleData.red_packet_pos, appBoot.openRedpacket);

    // this.setFadeOut();
    // sdkHandler.trigger('playButtonPressed', {
    //     callback: function() {
    //         this.Papa.PlaySnd(Base.SndButton);
    //         this.setFadeOut();
    //     }
    // }, this)
};

CWndRedPacket.prototype.OnWithDraw = function() {
    if (this.subText.obj.visible) return
    // debugger //点击弹窗提现按钮
    this.Papa.PlaySnd(Base.SndButton);
    if (Number(globleData.profile.amount) >= 100) {
      globleData.refreshCash = true
      html.gotoWebpage('/my/withdraw','支付宝提现')
      this.setFadeOut();
    }else{
      this.PopWhiteImg.obj.visible = true;
      this.whiteText.obj.visible = true;
      this.subText.obj.visible = true;
    }
};


CWndRedPacket.prototype.OnReady = function() {
    this.BlockButtons(false);
};

CWndRedPacket.prototype.BlockButtons = function(block) {
    // this.ButtResume.obj.input.enabled = !block;
    // this.ButtReplay.obj.input.enabled = !block;
    // this.ButtSound.obj.input.enabled = !block;
    // this.ButtMusic.obj.input.enabled = !block;
};

CWndRedPacket.prototype.setFadeOut = function() {
    this.BlockButtons(true);

    this.initFading(null);
    this.initShifting(null);

    // this.addFading(this.ButtResume,0,0.35,this.P2EasingOut,0);
    // this.addShifter(this.ButtResume,400,0,0.75,this.P3EasingOut,0); //img,sx,sy,time,tween,delay

    // this.addFading(this.ButtReplay,0,0.35,this.P2EasingOut,0);
    // this.addShifter(this.ButtReplay,-400,0,0.75,this.P3EasingOut,0);

    // this.addFading(this.ButtSound,0,0.35,this.P2EasingOut,0);
    // this.addShifter(this.ButtSound,-400,0,0.75,this.P3EasingOut,0);

    // this.addFading(this.ButtMusic,0,0.35,this.P2EasingOut,0);
    // this.addShifter(this.ButtMusic,400,0,0.75,this.P3EasingOut,0);

    var tween = this.Papa.Tweens.addTween(null,this.updateBgAlpha,this);
    tween.createEasingOut(this);
    tween.to({BgAlpha:0}, 0.9,true,()=>{},this);
    tween.start();
    this.OnEnd()
    this.Papa.PlaySnd(Base.SndWindow);
};

CWndRedPacket.prototype.updateBgAlpha = function() {
    if(this.BgImg.obj==null)  return;
    this.BgImg.alphaCoeff = this.BgAlpha;
    this.BgImg.obj.alpha = this.BgAlpha;
};

CWndRedPacket.prototype.OnEnd = function() {
    globleData.btnClicked = false;
    this.makeElementsVisible(false);
    this.Papa.PauseOff();

    this.killObj(this.BgImg);
    this.killObj(this.PopOpenImg);
    this.killObj(this.PopOpenClose);
    this.killObj(this.bomText);
    this.killObj(this.whiteText);
    this.killObj(this.subText);
    this.killObj(this.PopWhiteImg)
    if(this.title1)this.killObj(this.title1);
    if(this.title2)this.killObj(this.title2);
    if(this.title21)this.killObj(this.title21);
    if(this.title3)this.killObj(this.title3);
    if(this.title31)this.killObj(this.title31);
    if(this.titleText)this.killObj(this.titleText);
    if(this.ButtOpenRed)this.killObj(this.ButtOpenRed);

    this.ActiveFlag = false;
    if(this.EndCall!=null) this.EndCall.call(this);
};

CWndRedPacket.prototype.OnResize = function() {
    if(!this.ActiveFlag)  return;

    this.Yc = Base.HeightGame/2;

    this.updateElements();
    this.BgImg.obj.scale.set(1,Base.HeightGame/960);
};



//###################################################################################
//###################################################################################
//###################################################################################
//###################################################################################
//暂停弹窗区域
CWndPause = function (papa,threads,group,groupTop) {

    CBaseWnd.call(this,papa,threads,group,groupTop);

    this.MoveTween = null;
    this.MovingFlag = false;

    this.ResumeFrames = ['playB.png','playB.png','playB.png','playB.png'];
    this.ReplayFrames = ['replayB.png','replayB.png','replayB.png','replayB.png'];
    this.HomeFrames = ['popHoeme.png','popHoeme.png','popHoeme.png','popHoeme.png'];

    this.SoundFrames0 = ['soundB.png','soundB.png','soundB.png','soundB.png'];
    this.SoundFrames1 = ['soundBgrey.png','soundBgrey.png','soundBgrey.png','soundBgrey.png'];
    this.MusicFrames0 = ['musicB.png','musicB.png','musicB.png','musicB.png'];
    this.MusicFrames1 = ['musicBgrey.png','musicBgrey.png','musicBgrey.png','musicBgrey.png'];
};

CWndPause.prototype = Object.create(CBaseWnd.prototype);
CWndPause.prototype.constructor = CWndPause;

CWndPause.prototype.init = function() {
  /*  this.BgImg = this.addImg(0,0,'atlas','bg.png',this.Group);
    this.BgImg.obj.anchor.set(0.5);

    this.ButtResume =  this.addButton(0,-165,'atlas',this.ResumeFrames,this.OnResume,this,this.Group);
    this.ButtReplay =  this.addButton(0,0,'atlas',this.ReplayFrames,this.OnReplay,this,this.Group);
    this.ButtSound =  this.addButton(-105,120,'atlas',this.SoundFrames0,this.OnSound,this,this.Group);
    this.ButtMusic =  this.addButton(105,120,'atlas',this.MusicFrames0,this.OnMusic,this,this.Group);
*/
    this.ActiveFlag = false;
};

CWndPause.prototype.create = function() {

    this.clear();
    //  CPanel.prototype.create.call(Base.Xc,Base.Yc - Base.HeightGame/2);
    this.Xc = Base.Width/2;//Base.Xc;
    this.Yc = Base.HeightGame/2;
    this.EndCall = null;

    this.BgImg = this.addImg(0,0,'atlas','bg.png',this.Group,0);
    this.BgImg.obj.anchor.set(0.5);

    this.ButtResume =  this.addButton(0,-165,'atlas',this.ResumeFrames,this.OnResume,this,this.Group,1);

    this.ButtReplay =  this.addButton(0,0,'atlas',this.ReplayFrames,this.OnReplay,this,this.Group,1);
    this.ButtReplay.scaleCoeff = 0.65;

    this.ButtHome =  this.addButton(0,265,'newimg',this.HomeFrames,this.OnHome,this,this.Group,1);
    // this.ButtHome.scaleCoeff = 0.65;

    globalButtonHelper.pauseResumeBtn = this.ButtResume;
    globalButtonHelper.pauseReplayBtn = this.ButtReplay;


    this.ButtSound =  this.addButton(-105,120,'atlas',this.SoundFrames0,this.OnSound,this,this.Group,1);
    this.ButtMusic =  this.addButton(105,120,'atlas',this.MusicFrames0,this.OnMusic,this,this.Group,1);

    this.makeElementsVisible(true);

    this.BgAlpha = 0;
    this.BgImg.alphaCoeff = this.BgAlpha;
    this.BgImg.obj.alpha = this.BgAlpha;

    var tween = this.Papa.Tweens.addTween(null,this.updateBgAlpha,this);
    tween.createEasingOut(this);
    tween.to({BgAlpha:0.85}, 0.5,true,this.OnReady,this);
    tween.start();

    this.setButtonsAlpha(0);
    this.initFading(null);
    this.initShifting(null);

    var dist = 400;
    this.setObjShift(this.ButtResume,-dist,0);
    this.addFading(this.ButtResume,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.ButtResume,0,0,0.75,this.P3EasingOut,0); //img,ang,dist,time,tween,delay

    this.setObjShift(this.ButtHome,-dist,0);
    this.addFading(this.ButtHome,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.ButtHome,0,0,0.75,this.P3EasingOut,0); //img,ang,dist,time,tween,delay

    this.setObjShift(this.ButtReplay,dist,0);
    this.addFading(this.ButtReplay,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.ButtReplay,0,0,0.75,this.P3EasingOut,0);

    this.setObjShift(this.ButtSound,-dist,0);
    this.addFading(this.ButtSound,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.ButtSound,0,0,0.75,this.P3EasingOut,0);

    this.setObjShift(this.ButtMusic,dist,0);
    this.addFading(this.ButtMusic,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.ButtMusic,0,0,0.75,this.P3EasingOut,0);

    if(Base.SoundFlag)
        this.ButtSound.obj.setFrames(this.SoundFrames0[0],
            this.SoundFrames0[1],this.SoundFrames0[2],this.SoundFrames0[3]);
    else
        this.ButtSound.obj.setFrames(this.SoundFrames1[0],
            this.SoundFrames1[1],this.SoundFrames1[2],this.SoundFrames1[3]);

    if(Base.MusicFlag)
        this.ButtMusic.obj.setFrames(this.MusicFrames0[0],
            this.MusicFrames0[1],this.MusicFrames0[2],this.MusicFrames0[3]);
    else
        this.ButtMusic.obj.setFrames(this.MusicFrames1[0],
            this.MusicFrames1[1],this.MusicFrames1[2],this.MusicFrames1[3]);

    this.ClickAllowFlag = true;
    this.MovingFlag = false;
    this.State = 0;
    this.ActiveFlag = true;

    this.OldSoundFlag = Base.SoundFlag;
    this.OldMusicFlag = Base.MusicFlag;

    this.Group.sort('Order',-1);

    this.Papa.PlaySnd(Base.SndWindow);

    this.OnResize();
};

CWndPause.prototype.OnSound = function() {
    Base.SoundFlag = !Base.SoundFlag;
   this.Papa.PlaySnd(Base.SndButton);
    if(Base.SoundFlag)
        this.ButtSound.obj.setFrames(this.SoundFrames0[0],
            this.SoundFrames0[1],this.SoundFrames0[2],this.SoundFrames0[3]);
    else
        this.ButtSound.obj.setFrames(this.SoundFrames1[0],
            this.SoundFrames1[1],this.SoundFrames1[2],this.SoundFrames1[3]);
};

CWndPause.prototype.OnMusic = function() {
    Base.MusicFlag = !Base.MusicFlag;
     this.Papa.PlaySnd(Base.SndButton);
    if(Base.MusicFlag)
        this.ButtMusic.obj.setFrames(this.MusicFrames0[0],
            this.MusicFrames0[1],this.MusicFrames0[2],this.MusicFrames0[3]);
    else
        this.ButtMusic.obj.setFrames(this.MusicFrames1[0],
            this.MusicFrames1[1],this.MusicFrames1[2],this.MusicFrames1[3]);

    this.Papa.Papa.MuteMusic(!Base.MusicFlag);
};

CWndPause.prototype.OnResume = function() {
    // debugger 继续游戏
    this.Papa.PlaySnd(Base.SndButton);
    this.setFadeOut();
    // sdkHandler.trigger('playButtonPressed', {
    //     callback: function() {
    //         this.Papa.PlaySnd(Base.SndButton);
    //         this.setFadeOut();
    //     }
    // }, this)
};

CWndPause.prototype.OnReplay = function() {
    // debugger //看广告重新玩
    this.Papa.PlaySnd(Base.SndButton);
    appBoot.showAdBase(globleData.red_complete_pos, (success)=>{
        this.EndCall = this.ReplayGame;
        this.setFadeOut()        
    })
    // sdkHandler.trigger('playButtonPressed', {
    //     callback: function() {
    //         this.Papa.PlaySnd(Base.SndButton);
    //         this.EndCall = this.ReplayGame;
    //         this.setFadeOut()
    //     }
    // }, this)
};
CWndPause.prototype.OnHome = function(){//回首页
    this.Papa.PlaySnd(Base.SndButton);
    appBoot.showAdBase(globleData.red_complete_pos, (success)=>{
        if (globleData.inAPP) {
            dsBridge.call('closeNewWebView',{},function(){});
        }else{
            html.gotoWebpage('/','疯狂拼数字')
        }
    })
}
CWndPause.prototype.ReplayGame = function() {
   // sgSettings.commands.startOver();
    this.Papa.OnReplay();
};

CWndPause.prototype.OnReady = function() {
    this.BlockButtons(false);
};

CWndPause.prototype.BlockButtons = function(block) {
    this.ButtResume.obj.input.enabled = !block;
    this.ButtReplay.obj.input.enabled = !block;
    this.ButtSound.obj.input.enabled = !block;
    this.ButtMusic.obj.input.enabled = !block;
    this.ButtHome.obj.input.enabled = !block;
};

CWndPause.prototype.setFadeOut = function() {
    this.BlockButtons(true);

    if(this.OldSoundFlag!=Base.MusicFlag ||
        this.OldSoundFlag!=Base.SoundFlag)
        this.Papa.Papa.saveAll();

    this.initFading(null);
    this.initShifting(null);

    this.addFading(this.ButtHome,0,0.35,this.P2EasingOut,0);
    this.addShifter(this.ButtHome,400,0,0.75,this.P3EasingOut,0); //img,sx,sy,time,tween,delay

    this.addFading(this.ButtResume,0,0.35,this.P2EasingOut,0);
    this.addShifter(this.ButtResume,400,0,0.75,this.P3EasingOut,0); //img,sx,sy,time,tween,delay

    this.addFading(this.ButtReplay,0,0.35,this.P2EasingOut,0);
    this.addShifter(this.ButtReplay,-400,0,0.75,this.P3EasingOut,0);

    this.addFading(this.ButtSound,0,0.35,this.P2EasingOut,0);
    this.addShifter(this.ButtSound,-400,0,0.75,this.P3EasingOut,0);

    this.addFading(this.ButtMusic,0,0.35,this.P2EasingOut,0);
    this.addShifter(this.ButtMusic,400,0,0.75,this.P3EasingOut,0);

    var tween = this.Papa.Tweens.addTween(null,this.updateBgAlpha,this);
    tween.createEasingOut(this);
    tween.to({BgAlpha:0}, 0.9,true,this.OnEnd,this);
    tween.start();

    this.Papa.PlaySnd(Base.SndWindow);
};

CWndPause.prototype.updateBgAlpha = function() {
    if(this.BgImg.obj==null)  return;
    this.BgImg.alphaCoeff = this.BgAlpha;
    this.BgImg.obj.alpha = this.BgAlpha;
};

CWndPause.prototype.OnEnd = function() {
    this.makeElementsVisible(false);
    this.Papa.PauseOff();

    this.killObj(this.BgImg);
    this.killObj(this.ButtResume);
    this.killObj(this.ButtHome);
    this.killObj(this.ButtMusic);
    this.killObj(this.ButtSound);
    this.killObj(this.ButtReplay);

    this.ActiveFlag = false;
    if(this.EndCall!=null) this.EndCall.call(this);
};

CWndPause.prototype.OnResize = function() {
    if(!this.ActiveFlag)  return;

    this.Yc = Base.HeightGame/2;

    this.updateElements();
    this.BgImg.obj.scale.set(1,Base.HeightGame/960);
};

//#####################################################################
//#####################################################################
//#####################################################################


CWndResults = function (papa,threads,group,groupTop) {

    CBaseWnd.call(this,papa,threads,group,groupTop);

  //  this.Rain = new CParticleRain(this.Papa,threads);

    this.ActiveFlag = false;
    this.ReplayFrames = ['replayB.png','replayB.png','replayB.png','replayB.png'];
    this.ConfFrames = ['conf0.png','conf1.png','conf2.png','conf3.png'];

    this.ConfXYs = [{x:0,y:0},{x:45,y:29},{x:10,y:-30},{x:-30,y:-10},{x:-40,y:30}];
};

CWndResults.prototype = Object.create(CBaseWnd.prototype);
CWndResults.prototype.constructor = CWndResults;

CWndResults.prototype.init = function() {
    this.BgImg = this.addImg(0,0,'atlas','bg.png',this.Group,0);
    this.BgImg.obj.anchor.set(0.5);

    this.CoinPanel = this.addImg(225,0,'atlas','coinPanel.png',this.Group,1);
    this.CoinsTopText = this.addBitmapText(225+15,0,'GoldFont',''+Base.Coins,75,this.Group,2);
    this.CoinsTopText.obj.anchor.set(0.5,1);

    var text =  this.Papa.game.add.text(0, 0, sgLang.newhs[Base.Lang],
        { font: "50px FontVector", fill: "#f4dd36", align: "center" });
    text.setShadow(0,3,'rgba(0.2,0.2,0,0.2)');
    text.shadowBlur = 2;
    text.anchor.set(0.5,1);
    text.Order = 1;
    this.HSText = this.addText(0,-290,text,this.Group,1);

    if(text.width>500)
        this.HSText.scaleCoeff = 500/text.width;

    this.GroupHiScore = this.addGroup(-20,-270,this.Group,1);

    this.HiScoreText = this.Papa.getBitmapText(-5,20,
         'GoldFont',''+Base.HiScore,120, this.GroupHiScore.obj);
    this.HiScoreText.anchor.set(0,1);

    this.HiScoreImg = this.Papa.getZeroImg(-40,0, 'atlas','scoreIcon.png',this.GroupHiScore.obj);
    this.HiScoreImg.anchor.set(0.5,0.5);

   // this.PosHiScore = [{x:-20,y:-275},{x:-45,y:-308}];
    this.PosHiScore = [{x:-20,y:20},{x:-55,y:0}];

 /*   this.HiScoreText = this.addBitmapText(this.PosHiScore[0].x,this.PosHiScore[0].y,
        'GoldFont',''+Base.HiScore,120,this.GroupHiScore.obj);
    this.HiScoreText.obj.anchor.set(0,1);
    this.HiScoreImg = this.addImg(this.PosHiScore[1].x,this.PosHiScore[1].y,
        'atlas','scoreIcon.png',this.GroupHiScore.obj);
    this.HiScoreImg.obj.anchor.set(0.5,0.5); */

   // this.ScoreText = this.addBitmapText(-70+30,-150,'MainFont','Score',35,this.Group,1);
  //  this.ScoreText.obj.anchor.set(1,1);
  //  this.ScoreText.obj.tint = 0xf4c536;

    text =  this.Papa.game.add.text(0, 0,  sgLang.score[Base.Lang],
        { font: "35px FontVector", fill: "#f4c536", align: "center" });
    text.setShadow(0,3,'rgba(0.2,0.2,0,0.15)');
    text.shadowBlur = 2;
    text.anchor.set(1,1);
    text.Order = 1;
    this.ScoreText = this.addText(-70+30,-150+7,text,this.Group,1);

    this.ScoreNumText = this.addBitmapText(-40+30,-150,'GoldFont',''+100,90,this.Group,1);
    this.ScoreNumText.obj.anchor.set(0,1);
    this.ScoreImg = this.addImg(0,-150-15,'atlas','scoreIcon.png',this.Group,1);
    this.ScoreImg.scaleCoeff = 0.6;

   // this.CoinsText = this.addBitmapText(-70+30,-60,'MainFont','Coins',35,this.Group,1);
   // this.CoinsText.obj.anchor.set(1,1);
  //  this.CoinsText.obj.tint = 0xf4c536;

    text =  this.Papa.game.add.text(0, 0,  sgLang.coins[Base.Lang],
        { font: "35px FontVector", fill: "#f4c536", align: "center" });
    text.setShadow(0,3,'rgba(0.2,0.2,0,0.2)');
    text.shadowBlur = 2;
    text.anchor.set(1,1);
    text.Order = 1;
    this.CoinsText = this.addText(-70+30,-60+7,text,this.Group,1);

    this.CoinsNumText = this.addBitmapText(-40+30,-60,'GoldFont',''+100,90,this.Group,1);
    this.CoinsNumText.obj.anchor.set(0,1);
    this.CoinsImg = this.addImg(0,-60-15,'atlas','coin.png',this.Group,1);

    this.ButtReplay =  this.addButton(0,170,'atlas',this.ReplayFrames,this.OnReplay,this,this.Group,1);
    globalButtonHelper.resultsReplayBtn = this.ButtReplay;

    this.ActiveFlag = false;
};

CWndResults.prototype.create = function() {

    this.clear();

    //  CPanel.prototype.create.call(Base.Xc,Base.Yc - Base.HeightGame/2);
    this.Xc = Base.Width/2;//Base.Xc;
    this.Yc = Base.HeightGame/2;
    this.EndCall = null;
    this.HiScoreScalingFlag = false;

    this.HiScoreFlag = false;
    if(Base.HiScore==Base.Score)
        this.HiScoreFlag = true;

   // this.HiScoreFlag = true; // temp

  //  this.Papa.game.input.enabled = false;

    this.BgAlpha = 0;
    this.BgImg.alphaCoeff = this.BgAlpha;
    this.BgImg.obj.alpha = this.BgAlpha;
    var tween = this.Papa.Tweens.addTween(null,this.updateBgAlpha,this);
    tween.createEasingOut(this);
    tween.to({BgAlpha:0.85}, 0.5,true,this.OnReady,this);
    tween.start();

    this.CountSpanTime = 0;
    this.CountSpanTimeCntr = 0;
    this.CountStage = 0;

   // this.HiScoreText.obj.scale.set(1);
   // this.HiScoreImg.obj.scale.set(1);

    this.CoinsTopText.obj.setText(''+Base.Coins);

    if(!this.HiScoreFlag) this.HiScoreText.setText(''+Base.HiScore);
    else this.HiScoreText.setText(''+0);

    this.ScoreNumText.obj.setText(''+Base.Score);
    this.CoinsNumText.obj.setText(''+this.Papa.CoinsGame);

    this.ScoreImg.x = this.ScoreNumText.x + this.ScoreNumText.obj.width + 40;
    this.CoinsImg.x = this.CoinsNumText.x + this.CoinsNumText.obj.width + 40;

    this.ScoreNumText.obj.setText(''+0);
    this.CoinsNumText.obj.setText(''+0);

    window.makeElementsVisible  =this.makeElementsVisible;

    this.makeElementsVisible(true);
    this.setTextsAlpha(0);
    this.setTextVecsAlpha(0);
    this.setButtonsAlpha(0);
    this.setImgsAlpha(0);
    this.setGroupsAlpha(0);

    this.initFading(null);
    this.initShifting(null);

    this.setObjShift(this.CoinPanel,100,0);
    this.setObjShift(this.CoinsTopText,100,0);
    this.addFading(this.CoinPanel,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.CoinPanel,0,0,0.5,this.P3EasingOut,0);
    this.addFading(this.CoinsTopText,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.CoinsTopText,0,0,0.5,this.P3EasingOut,0);

    var shift = -320;
    var delay = 0;
  //  var dy = 50;//115;

    this.GroupHiScore.y = -270;
    if(this.HiScoreFlag)  this.GroupHiScore.y += 60;

    //this.GroupHiScore.x =  -this.Xc;
   // this.GroupHiScore.y = -this.Yc + this.ShiftHS;

   /* this.HiScoreText.x = this.PosHiScore[0].x;
    this.HiScoreText.y = this.PosHiScore[0].y + dy;
    this.HiScoreImg.x = this.PosHiScore[1].x;
    this.HiScoreImg.y = this.PosHiScore[1].y + dy;*/

    if(this.HiScoreFlag) {
        this.setObjShift(this.HSText,shift,0);
        this.addFading(this.HSText,1,0.4,this.P3EasingIn,delay);
        this.addShifter(this.HSText,0,0,0.5,this.P3EasingOut,delay);
        shift = -shift;
        delay += 0.25;
    }

    this.setObjShift(this.GroupHiScore,shift,0);
    this.addFading(this.GroupHiScore,1,0.4,this.P3EasingIn,delay);
    this.addShifter(this.GroupHiScore,0,0,0.5,this.P3EasingOut,delay);

   /* this.setObjShift(this.HiScoreText,shift,0);
    this.setObjShift(this.HiScoreImg,shift,0);
    this.addFading(this.HiScoreText,1,0.4,this.P3EasingIn,delay);
    this.addShifter(this.HiScoreText,0,0,0.5,this.P3EasingOut,delay);
    this.addFading(this.HiScoreImg,1,0.4,this.P3EasingIn,delay);
    this.addShifter(this.HiScoreImg,0,0,0.5,this.P3EasingOut,delay);*/

    if(!this.HiScoreFlag) {
        shift = -shift;
        delay += 0.25;
        this.setObjShift(this.ScoreText,shift,0);
        this.setObjShift(this.ScoreNumText,shift,0);
        this.setObjShift(this.ScoreImg,shift,0);
        this.addFading(this.ScoreText,1,0.4,this.P3EasingIn,delay);
        this.addShifter(this.ScoreText,0,0,0.5,this.P3EasingOut,delay);
        this.addFading(this.ScoreNumText,1,0.4,this.P3EasingIn,delay);
        this.addShifter(this.ScoreNumText,0,0,0.5,this.P3EasingOut,delay);
        this.addFading(this.ScoreImg,1,0.4,this.P3EasingIn,delay);
        this.addShifter(this.ScoreImg,0,0,0.5,this.P3EasingOut,delay);
    }

    shift = -shift;
    delay += 0.25;
    this.setObjShift(this.CoinsText,shift,0);
    this.setObjShift(this.CoinsNumText,shift,0);
    this.setObjShift(this.CoinsImg,shift,0);
    this.addFading(this.CoinsText,1,0.4,this.P3EasingIn,delay);
    this.addShifter(this.CoinsText,0,0,0.5,this.P3EasingOut,delay);
    this.addFading(this.CoinsNumText,1,0.4,this.P3EasingIn,delay);
    this.addShifter(this.CoinsNumText,0,0,0.5,this.P3EasingOut,delay);
    this.addFading(this.CoinsImg,1,0.4,this.P3EasingIn,delay);
    this.addShifter(this.CoinsImg,0,0,0.5,this.P3EasingOut,delay);

    //
    shift = -shift;
    delay += 0.25;
   // this.setObjShift(this.ButtReplay,shift,0);
   // this.addFading(this.ButtReplay,1,0.4,this.P3EasingIn,delay);
   // this.addShifter(this.ButtReplay,0,0,0.75,this.P3EasingOut,delay);
    // this.ButtReplay.obj.visible = false;

    this.ClickAllowFlag = true;
    this.MovingFlag = false;
    this.State = 0;
    this.ReplayClickedFlag = false;
    this.ActiveFlag = true;

    this.CountingFlag = false;
    this.WaitTimeCntr = 1.5;
    this.Threads.addThread(this,this.updateWait);

    this.ScaleReplay = 1;
    this.ScaleReplaySpeed = 0.2;
    this.ButtReplay.obj.scale.set(this.ScaleReplay);

    this.CounfetiFlag = false;

    this.Group.sort('Order',-1);

    this.Papa.PlaySnd(Base.SndWindow);

    this.OnResize();
};

CWndResults.prototype.updateReplayScale = function() {
    this.ScaleReplay += this.ScaleReplaySpeed*Base.RealTimeInt;
    if((this.ScaleReplaySpeed>0 && this.ScaleReplay>1.05) ||
       (this.ScaleReplaySpeed<0 && this.ScaleReplay<0.95)) {
        this.ScaleReplaySpeed = -this.ScaleReplaySpeed;
    }
    this.ButtReplay.obj.scale.set(this.ScaleReplay);
};

CWndResults.prototype.setHiScoreScaling = function() {

    this.HiScoreScale = 1;
    this.HiScoreScaleSpeed = 0.1;
    this.Threads.addThread(this,this.updateHiScoreSclaing);
    this.HiScoreScalingFlag = true;
};

CWndResults.prototype.updateHiScoreSclaing = function() {

    this.HiScoreScale += this.HiScoreScaleSpeed*Base.RealTimeInt;
    if(this.HiScoreScaleSpeed>0 && this.HiScoreScale>1.1)
        this.HiScoreScaleSpeed = -this.HiScoreScaleSpeed ;
    if(this.HiScoreScaleSpeed<0 && this.HiScoreScale<1)
        this.HiScoreScaleSpeed = -this.HiScoreScaleSpeed ;

    this.GroupHiScore.obj.scale.set(this.HiScoreScale*this.HiScoreScale);

  //  this.HiScoreText.obj.scale.set(this.HiScoreScale*this.HiScoreScale);
  //  this.HiScoreImg.obj.scale.set(this.HiScoreScale*this.HiScoreScale);
};

CWndResults.prototype.setConfetis  = function() {

    this.ConfIndexLeft = Math.floor(Math.random()*this.ConfXYs.length);
    this.ConfIndexRight = Math.floor(Math.random()*this.ConfXYs.length);

    this.ConfRateCntr = 0;
    this.ConfLeftFlag = true;
   // this.ConfXYs
    this.ConfCntr = 4;

    this.Threads.addThread(this,this.updateConfeti);
    this.CounfetiFlag = true;
};

CWndResults.prototype.updateConfeti  = function() {
    this.ConfRateCntr-=Base.RealTimeInt;
    if(this.ConfRateCntr<=0) {

        var xc = 0;
        var yc = 0;
        if(this.ConfLeftFlag) {

            xc = this.Xc - 170 + this.ConfXYs[this.ConfIndexLeft].x;
            yc = this.Yc - 160 + this.ConfXYs[this.ConfIndexLeft].y;

            this.ConfIndexLeft++;
            if(this.ConfIndexLeft>=this.ConfXYs.length)
                this.ConfIndexLeft = 0;
            this.ConfLeftFlag = false;
            this.ConfRateCntr = 0.2;
        }
        else
        {
            xc = this.Xc + 170 + this.ConfXYs[this.ConfIndexRight].x;
            yc = this.Yc - 160 + this.ConfXYs[this.ConfIndexRight].y;

            this.ConfIndexRight++;
            if(this.ConfIndexRight>=this.ConfXYs.length)
                this.ConfIndexRight = 0;
            this.ConfLeftFlag = true;

            this.ConfRateCntr = 0.5;

            this.ConfCntr--;
            if( this.ConfCntr<0) {
                this.Threads.removeThread(this,this.updateConfeti);
                this.CounfetiFlag = false;
            }
        }

        this.makeConfeti(xc,yc);
    }
};

CWndResults.prototype.makeConfeti  = function(xc,yc) {

    // addExplGlow = function(x,y,scale0,scale1,life,fade,alpha,atlas,imgStr,group)
     this.Papa.addExplGlow(xc,yc,0.5,2,0.1,0.2,0.3,'atlas','ring1.png',this.GroupTop);

     var lastFrame = -1;
     var num = 8;
     var speed0 = 1000;
     var speedRnd = 50;
     for(var i=0;i<3;i++) {

         var ang0 = i*(Math.PI/num)/2;
         var ang = ang0;
         var angStep = 2*Math.PI/num;

         for(var k=0;k<num;k++) {
             var frame =  Math.floor(Math.random()*this.ConfFrames.length);
             if(frame==lastFrame) frame++; if(frame>=this.ConfFrames.length) frame = 0;
             var speed = speed0 + speedRnd*Math.random();
             var rot = Math.PI/10 +  Math.random()*Math.PI/8;
             if(Math.random()>0.5) rot = -rot;
             //x,y,pic,type,life,speedx,speedy,ang,rot,group)
             var part = this.Papa.addExplParticle(xc+10*Math.cos(ang),yc+10*Math.sin(ang),
                 this.ConfFrames[frame],0,0.5+0.2*Math.random(),speed*Math.cos(ang),
                 speed*Math.sin(ang),Math.PI*Math.random(),rot,this.GroupTop);
              part.setGravity(40);
              ang0 += angStep;
              ang = ang0 + 0.3*angStep*Math.random();
         }
         num -= 2;
         speed0 -= 250;
     }
};

CWndResults.prototype.updateWait  = function() {
    this.WaitTimeCntr -= Base.RealTimeInt;
    if(this.WaitTimeCntr<0) {
        this.Threads.removeThread(this,this.updateWait);

       this.BlockButtons(true);

        this.CountingFlag = true;
        if(!this.HiScoreFlag) {
            var time = Base.Score * 0.01;
            if (time > 2) time = 2;
            this.setCounting(time, this.ScoreNumText.obj, Base.Score, 0,true);
        }
        else {
            time = Base.Score * 0.01;
            if (time > 2) time = 2;
            this.setCounting(time, this.HiScoreText, Base.Score, 0,false);
            this.Papa.PlaySnd(Base.SndWin);
           // this.setRain();
            this.setConfetis();
            this.setHiScoreScaling();
        }


      //  this.WaitTimeCntr  = 2; // TEMP
     //   this.Threads.addThread(this,this.updateWait2); // TEMP
        this.OnReady();
        
    }
};

CWndResults.prototype.updateWait2 = function() { // unused
    this.WaitTimeCntr -= Base.RealTimeInt;
    if (this.WaitTimeCntr < 0) {
        this.Threads.removeThread(this, this.updateWait2);
        this.OnReady();
    }
};

CWndResults.prototype.OnReady = function() {

    this.ButtReplay.obj.visible = false;

    if(Base.NoInterAdFlag) {
        this.ButtReplay.obj.visible = true;
        // this.Papa.game.input.enabled = true;
        this.addFading(this.ButtReplay,1,1,this.P2EasingIn,0);
        this.BlockButtons(false);
        this.Threads.addThread(this,this.updateReplayScale);

    } else {
        this.ButtReplay.obj.visible = true;
        // this.Papa.game.input.enabled = true;
        this.addFading(this.ButtReplay,1,1,this.P2EasingIn,0);
        this.BlockButtons(false);
        this.Threads.addThread(this,this.updateReplayScale);
    }
    // this.BlockButtons(false);
};

CWndResults.prototype.setCounting  = function(time,text,num,stage,snd) {
    this.CountNum = num;
    this.CountText = text;
    this.CountSpanTimeCntr = 0;
    this.CountSpanTime = time;
    this.CountStage = stage;
    this.CountSoundFlag = snd;
    if(this.CountSoundFlag) this.Papa.PlaySnd(Base.SndCount);
    this.Threads.addThread(this,this.updateHiScore);
    this.CountingFlag = true;
};

CWndResults.prototype.updateHiScore  = function() {

    this.CountSpanTimeCntr += Base.RealTimeInt;
    if(this.CountSpanTimeCntr>this.CountSpanTime) {
        this.CountSpanTimeCntr = this.CountSpanTime;
    }

    var coeff = this.CountSpanTimeCntr/this.CountSpanTime;
    var num =  Math.floor(coeff*this.CountNum);
    this.CountText.setText(''+num);

    if(this.CountSpanTimeCntr==this.CountSpanTime) {

        if(this.CountSoundFlag) {
            this.Papa.StopSnd(Base.SndCount);
            this.CountSoundFlag = false;
        }

        num =  this.CountNum;
        this.Threads.removeThread(this,this.updateHiScore);
        this.CountText.setText(''+num);

        if(this.HiScoreFlag) {

            if(this.CountStage==1)   { this.CountingFlag = false;  return; }

            if(this.Papa.CoinsGame>0) {
               var time = this.Papa.CoinsGame*0.1;
               if(time>2) time = 2;
               this.setCounting(time, this.CoinsNumText.obj,this.Papa.CoinsGame,1,true);
           }
           else
               this.CoinsNumText.obj.setText(''+this.Papa.CoinsGame);
        }
        else {
            switch(this.CountStage) {
                case 0:
                    if(this.CountStage==1) {
                        if (this.Papa.CoinsGame > 0) {
                            time = this.Papa.CoinsGame * 0.1;
                            if (time > 1.5) time = 1.5;
                            this.setCounting(time, this.CoinsNumText.obj, this.Papa.CoinsGame, 1,true);
                        }
                    }
                    else
                        this.CoinsNumText.obj.setText(''+this.Papa.CoinsGame);
                    break;
                case 1:
                    this.CountingFlag = false;
                    return;
                    break;
           }
        }
    }
};

CWndResults.prototype.OnReplay = function() {

    //游戏结束后的弹窗点击重新开始需要看广告？
    if( this.ReplayClickedFlag)  return;

    this.ReplayClickedFlag = true;
    appBoot.showAdBase(globleData.red_complete_pos, (success)=>{
        this.EndCall = this.ReplayGame;
        this.setFadeOut();
        this.ReplayClickedFlag = false;
    })
    

    // sdkHandler.trigger('playButtonPressed', {
    //     callback: function() {
    //         if(Base.NoInterAdFlag)
    //         {
    //             console.log("OnReplay: done");
    //             this.EndCall = this.ReplayGame;
    //             this.setFadeOut();
    //         }
    //         else
    //         {
    //             this.EndCall = this.ReplayGame;
    //             this.setFadeOut();
    //         }
    //     }
    // }, this)

 //   this.EndCall = this.ReplayGame;
//    this.setFadeOut();
};


CWndResults.prototype.ReplayGame = function() {
    //sgSettings.commands.startOver();
    this.Papa.OnReplay();
};

CWndResults.prototype.BlockButtons = function(block) {

    this.ButtReplay.obj.input.enabled = !block;
};

CWndResults.prototype.setFadeOut = function() {

    if(this.CountSoundFlag) {
        this.Papa.StopSnd(Base.SndCount);
        this.CountSoundFlag = false;
    }

    if(this.CountingFlag)
        this.Threads.removeThread(this,this.updateHiScore);
    this.CountingFlag = false;

    if(this.CounfetiFlag)
        this.Threads.removeThread(this,this.updateConfeti);
    this.CounfetiFlag = false;

    if(this.HiScoreScalingFlag)
        this.Threads.removeThread(this,this.updateHiScoreSclaing);
    this.HiScoreScalingFlag = false;

    this.Threads.removeThread(this,this.updateReplayScale);

    this.BlockButtons(true);

    this.initFading(null);
    this.initShifting(null);

    this.addFading(this.CoinPanel,0,0.4,this.P2EasingOut,0);
    this.addShifter(this.CoinPanel,0,-400,0.5,this.P3EasingOut,0);
    this.addFading(this.CoinsTopText,0,0.4,this.P2EasingOut,0);
    this.addShifter(this.CoinsTopText,-400,0,0.5,this.P3EasingOut,0);

    var shift = -400;
    if(this.HiScoreFlag) {
       this.addFading(this.HSText,0,0.4,this.P2EasingOut,0);
       this.addShifter(this.HSText,shift,0,0.5,this.P3EasingOut,0);
        shift = -shift;
    }

    this.addFading(this.GroupHiScore,0,0.4,this.P2EasingOut,0);
    this.addShifter(this.GroupHiScore,shift,0,0.5,this.P3EasingOut,0);
    shift = -shift;
  //  this.addFading(this.HiScoreImg,0,0.4,this.P2EasingOut,0);
 //   this.addShifter(this.HiScoreImg,400,0,0.5,this.P3EasingOut,0);

    if(!this.HiScoreFlag) {
        this.addFading(this.ScoreText,0,0.4,this.P2EasingOut,0);
        this.addShifter(this.ScoreText,shift,0,0.5,this.P3EasingOut,0);
        this.addFading(this.ScoreNumText,0,0.4,this.P2EasingOut,0);
        this.addShifter(this.ScoreNumText,shift,0,0.5,this.P3EasingOut,0);
        this.addFading(this.ScoreImg,0,0.4,this.P2EasingOut,0);
        this.addShifter(this.ScoreImg,shift,0,0.5,this.P3EasingOut,0);
        shift = -shift;
    }

    this.addFading(this.CoinsText,0,0.4,this.P2EasingOut,0);
    this.addShifter(this.CoinsText,shift,0,0.5,this.P3EasingOut,0);
    this.addFading(this.CoinsNumText,0,0.4,this.P2EasingOut,0);
    this.addShifter(this.CoinsNumText,shift,0,0.5,this.P3EasingOut,0);
    this.addFading(this.CoinsImg,0,0.4,this.P2EasingOut,0);
    this.addShifter(this.CoinsImg,shift,0,0.5,this.P3EasingOut,0);
    shift = -shift;

    this.addFading(this.ButtReplay,0,0.35,this.P2EasingOut,0);
  //  this.addShifter(this.ButtReplay,shift,0,0.75,this.P3EasingOut,0);

    var tween = this.Papa.Tweens.addTween(null,this.updateBgAlpha,this);
    tween.createEasingOut(this);
    tween.to({BgAlpha:0}, 0.9,true,this.OnEnd,this);
    tween.start();

    this.Papa.PlaySnd(Base.SndWindow);
};

CWndResults.prototype.updateBgAlpha = function() {
    if(this.BgImg.obj==null)  return;
    this.BgImg.alphaCoeff = this.BgAlpha;
    this.BgImg.obj.alpha = this.BgAlpha;
};

CWndResults.prototype.OnEnd = function() {
    this.makeElementsVisible(false);
    this.Papa.PauseOff();
    this.ActiveFlag = false;
    if(this.EndCall!=null) this.EndCall.call(this);
};

CWndResults.prototype.OnResize = function() {
    if(!this.ActiveFlag)  return;

    this.Yc = Base.HeightGame/2;

    this.CoinPanel.y = -Base.HeightGame/2 + 82;
    this.CoinsTopText.y = -Base.HeightGame/2 + 82 + 11;

   // this.GroupHiScore.y = -this.Yc + this.ShiftHS;

    this.updateElements();
    this.BgImg.obj.scale.set(1,Base.HeightGame/960);
};

//####################################################################
//####################################################################
//####################################################################

CWndChoice = function (papa,threads,group,groupTop) {

    CBaseWnd.call(this,papa,threads,group,groupTop);

    this.ActiveFlag = false;
    this.ContFrames = ['buttonContinue.png','buttonContinue.png',
        'buttonContinue.png','buttonContinue.png'];
};

CWndChoice.prototype = Object.create(CBaseWnd.prototype);
CWndChoice.prototype.constructor = CWndChoice;

CWndChoice.prototype.init = function() {
    //结束游戏前是否看花金币复活
    this.BgImg = this.addImg(0,0,'atlas','bg.png',this.Group,0);
    this.BgImg.obj.anchor.set(0.5);

    var text =  this.Papa.game.add.text(50, 0,  sgLang.nospace[Base.Lang],
        { font: "50px FontVector", fill: "#ffffff", align: "center" });
    text.setShadow(0,3,'rgba(0,0,0,0.25)');
    text.shadowBlur = 2;
    text.anchor.set(0.5,1);
    text.Order = 1;
    this.SpaceText = this.addText(10,-320,text,this.Group,1);
    if(text.width>570)
        this.SpaceText.scaleCoeff = 570/text.width;

  //  this.SpaceText = this.addBitmapText(-20,-320,'MainFont','No more space',60,this.Group);

    text =  this.Papa.game.add.text(0, 0, 'xxx',
        { font: "90px FontVector", fill: "#ffffff", align: "center" });
    text.setShadow(0,3,'rgba(0,0,0,0.25)');
    text.shadowBlur = 2;
    text.anchor.set(0.5,1);
    text.Order = 1;
    this.TimeText = this.addText(0,-120,text,this.Group,1);

  //  this.TimeText = this.addBitmapText(0,-120,'NumBigFont','0',90,this.Group);
  //  this.TimeText.obj.anchor.set(0.5,1);

    this.SliderBgImg = this.addImg(0,-30,'atlas','timeOutMain.png',this.Group,1);
    this.SliderImg = this.addImg(0,-30,'atlas','timeOutBlue.png',this.Group,2);
    this.SliderBgImg.obj.anchor.set(0,0.5);
    this.SliderImg.obj.anchor.set(0,0.5);
    this.SliderBgImg.x = -this.SliderBgImg.obj.width/2;
    this.SliderImg.x = -this.SliderImg.obj.width/2;

    this.SliderImg.obj.cropRect =  new Phaser.Rectangle(0,0,
        this.SliderImg.obj.width,this.SliderImg.obj.height);
    this.SliderWidth = this.SliderImg.obj.width;

    this.CoinPanel = this.addImg(0,126-60,'atlas','coinPanel.png',this.Group,1);
    this.CoinsText = this.addBitmapText(10,126+11-60,'GoldFont',''+Base.PriceContinue,72,this.Group,2);
    this.CoinsText.obj.anchor.set(0.5,1);

    this.ButtCont =  this.addButton(0,190-50,'atlas',this.ContFrames,this.OnCont,this,this.Group,1);
  //  this.ButtContText = this.addBitmapText(0,190-50-10,'MainFont','Continue?',45,this.Group,2);
   // this.ButtContText.obj.tint = 0x664400;

    text =  this.Papa.game.add.text(0, 0, sgLang.continueq[Base.Lang],
        { font: "40px FontVector", fill: "#6b1f21", align: "center" });
    text.setShadow(0,3,'rgba(0.1,0.1,0,0.3)');
    text.anchor.set(0.5);
    text.shadowBlur = 3;
    text.Order = 1;

    this.ButtContText = this.addText(0,190-50,text,this.Group,2);
    text.visible = false;
    if(text.width>230)
        this.ButtContText.scaleCoeff = 230/text.width;

    /*  this.ButtContVid =  this.addButton(0,310-50,'atlas',this.ContFrames,this.OnContVid,this);
      this.VideoImg = this.addImg(-100,310-50,'atlas','video.png',0);
      this.ButtContVidText = this.addBitmapText(20,310-50-10,'MainFont','Continue?',35,0);
      this.ButtContVidText.obj.tint = 0x664400; */

    this.ActiveFlag = false;
};

CWndChoice.prototype.create = function() {

    this.clear();

    //  CPanel.prototype.create.call(Base.Xc,Base.Yc - Base.HeightGame/2);
    this.Xc = Base.Width/2;//Base.Xc;
    this.Yc = Base.HeightGame/2;
    this.EndCall = null;

    this.TwoButtonsFlag = false;
    if(Base.Coins>=Base.PriceContinue)
        this.TwoButtonsFlag = true;

    this.BgAlpha = 0;
    this.BgImg.alphaCoeff = this.BgAlpha;
    this.BgImg.obj.alpha = this.BgAlpha;
    var tween = this.Papa.Tweens.addTween(null,this.updateBgAlpha,this);
    tween.createEasingOut(this);
    tween.to({BgAlpha:0.9}, 0.5,true,null,this);
    tween.start();

    this.WaitTime = 8;
    this.WaitTimeCntr = this.WaitTime;
    this.SliderImg.obj.cropRect.width = this.SliderWidth;
    this.SliderImg.obj.updateCrop();

    this.SecCntr = this.WaitTime;
    this.TimeCntr = 0;
    this.TimeText.obj.setText(""+this.SecCntr);
    this.Threads.addThread(this,this.updateWait);

    this.makeElementsVisible(true);
    this.setTextVecsAlpha(0);
    this.setTextsAlpha(0);
    this.setButtonsAlpha(0);
    this.setImgsAlpha(0);

    this.initFading(null);
    this.initShifting(null);

    this.setObjShift(this.SpaceText,-300,0);
    this.addFading(this.SpaceText,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.SpaceText,0,0,0.5,this.P3EasingOut,0);

    this.setObjShift(this.TimeText,300,0);
    this.addFading(this.TimeText,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.TimeText,0,0,0.5,this.P3EasingOut,0);

    this.setObjShift(this.SliderBgImg,-300,0);
    this.setObjShift(this.SliderImg,-300,0);
    this.addFading(this.SliderBgImg,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.SliderBgImg,0,0,0.5,this.P3EasingOut,0);
    this.addFading(this.SliderImg,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.SliderImg,0,0,0.5,this.P3EasingOut,0);

    if(this.TwoButtonsFlag ) {
        this.setObjShift(this.CoinPanel, 300, 0);
        this.setObjShift(this.CoinsText, 300, 0);
        this.addFading(this.CoinPanel, 1, 0.4, this.P3EasingIn, 0);
        this.addShifter(this.CoinPanel, 0, 0, 0.5, this.P3EasingOut, 0);
        this.addFading(this.CoinsText, 1, 0.4, this.P3EasingIn, 0);
        this.addShifter(this.CoinsText, 0, 0, 0.5, this.P3EasingOut, 0);

        this.setObjShift(this.ButtCont, -300, 0);
        this.setObjShift(this.ButtContText, -300, 0);
        this.addFading(this.ButtCont, 1, 0.4, this.P3EasingIn, 0);
        this.addShifter(this.ButtCont, 0, 0, 0.75, this.P3EasingOut, 0);
        this.addFading(this.ButtContText, 1, 0.4, this.P3EasingIn, 0);
        this.addShifter(this.ButtContText, 0, 0, 0.75, this.P3EasingOut, 0);
    }
    else
        this.ButtCont.obj.input.enabled = false;

    //var y = 310-50;
    //if(!this.TwoButtonsFlag) y = 190 - 50;
   // this.ButtContVid.y = y;
   // this.ButtContVidText.y = y;
    //this.VideoImg.y = y;

   /* this.setObjShift(this.ButtContVid,300,0);
    this.setObjShift(this.ButtContVidText,300,0);
    this.setObjShift(this.VideoImg,300,0);
    this.addFading(this.ButtContVid,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.ButtContVid,0,0,0.75,this.P3EasingOut,0);
    this.addFading(this.ButtContVidText,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.ButtContVidText,0,0,0.75,this.P3EasingOut,0);
    this.addFading(this.VideoImg,1,0.4,this.P3EasingIn,0);
    this.addShifter(this.VideoImg,0,0,0.75,this.P3EasingOut,0); */

    this.ClickAllowFlag = true;
    this.MovingFlag = false;
    this.State = 0;
    this.ActiveFlag = true;

    this.DelayCntr = 1.5;
    this.Threads.addThread(this,this.updateDelay);

    this.Group.sort('Order',-1);

    this.Papa.PlaySnd(Base.SndWindow);

    this.OnResize();
};

CWndChoice.prototype.updateDelay = function() {
    this.DelayCntr -= Base.RealTimeInt;
    if(this.DelayCntr<0) {
        this.Threads.removeThread(this,this.updateDelay);
        this.OnReady();
    }
};

CWndChoice.prototype.updateWait = function() {

    this.WaitTimeCntr -= Base.RealTimeInt;
    if(this.WaitTimeCntr<0) this.WaitTimeCntr = 0;
    var coeff = this.WaitTimeCntr/this.WaitTime;

    this.SliderImg.obj.cropRect.width = this.SliderWidth*coeff;
    this.SliderImg.obj.updateCrop();

    this.TimeCntr -= Base.RealTimeInt;
    if(this.TimeCntr<0) {
        this.TimeCntr = 1;
        this.SecCntr--;
        if(this.SecCntr<=0) {
            this.Threads.removeThread(this,this.updateWait);
            this.EndCall = this.ReplayGame;
            this.setFadeOut();
        }
        this.TimeText.obj.setText(""+this.SecCntr);
    }
};

CWndChoice.prototype.OnCont = function() {
     this.Papa.PlaySnd(Base.SndButton);
    this.Papa.spendCoins(40);
    this.Threads.removeThread(this,this.updateWait);
    this.EndCall = this.ContinueGame;
    this.setFadeOut();
};

CWndChoice.prototype.OnContVid = function() {
    this.Threads.removeThread(this,this.updateWait);
    this.EndCall = this.ContinueGame;
    this.setFadeOut()
};

CWndChoice.prototype.ContinueGame = function() {
    this.Papa.OnContinue();
};

CWndChoice.prototype.ReplayGame = function() {
    this.Papa.OnNoChoice();
};

CWndChoice.prototype.OnReady = function() {
    this.BlockButtons(false);
};

CWndChoice.prototype.BlockButtons = function(block) {

    if(this.TwoButtonsFlag) this.ButtCont.obj.input.enabled = !block;
   // this.ButtContVid.obj.input.enabled = !block;
};

CWndChoice.prototype.setFadeOut = function() {
    this.BlockButtons(true);

    this.initFading(null);
    this.initShifting(null);

    this.addFading(this.SpaceText,0,0.4,this.P2EasingOut,0);
    this.addShifter(this.SpaceText,0,-400,0.5,this.P3EasingOut,0);

    this.addFading(this.TimeText,0,0.4,this.P2EasingOut,0);
    this.addShifter(this.TimeText,400,0,0.5,this.P3EasingOut,0);

    this.addFading(this.SliderBgImg,0,0.4,this.P2EasingOut,0);
    this.addShifter(this.SliderBgImg,-400,0,0.5,this.P3EasingOut,0);
    this.addFading(this.SliderImg,0,0.4,this.P2EasingOut,0);
    this.addShifter(this.SliderImg,-400,0,0.5,this.P3EasingOut,0);

    if(this.TwoButtonsFlag ) {
        this.addFading(this.CoinPanel, 0, 0.4, this.P2EasingOut, 0);
        this.addShifter(this.CoinPanel, 400, 0, 0.5, this.P3EasingOut, 0);
        this.addFading(this.CoinsText, 0, 0.4, this.P2EasingOut, 0);
        this.addShifter(this.CoinsText, 400, 0, 0.5, this.P3EasingOut, 0);

        this.addFading(this.ButtCont, 0, 0.35, this.P2EasingOut, 0);
        this.addShifter(this.ButtCont, -400, 0, 0.75, this.P2EasingIn, 0);
        this.addFading(this.ButtContText, 0, 0.35, this.P2EasingOut, 0);
        this.addShifter(this.ButtContText, -400, 0, 0.75, this.P2EasingIn, 0);
    }

 /*   this.addFading(this.ButtContVid,0,0.35,this.P2EasingOut,0);
    this.addShifter(this.ButtContVid,400,0,0.75,this.P2EasingIn,0);
    this.addFading(this.ButtContVidText,0,0.35,this.P2EasingOut,0);
    this.addShifter(this.ButtContVidText,400,0,0.75,this.P2EasingIn,0);
    this.addFading(this.VideoImg,0,0.35,this.P2EasingOut,0);
    this.addShifter(this.VideoImg,400,0,0.75,this.P2EasingIn,0); */

    var tween = this.Papa.Tweens.addTween(null,this.updateBgAlpha,this);
    tween.createEasingOut(this);
    tween.to({BgAlpha:0}, 0.9,true,this.OnEnd,this);
    tween.start();

    this.Papa.PlaySnd(Base.SndWindow);
};

CWndChoice.prototype.updateBgAlpha = function() {
    if(this.BgImg.obj==null)  return;
    this.BgImg.alphaCoeff = this.BgAlpha;
    this.BgImg.obj.alpha = this.BgAlpha;
};

CWndChoice.prototype.OnEnd = function() {
    this.makeElementsVisible(false);
    this.Papa.PauseOff();
    this.ActiveFlag = false;
    if(this.EndCall!=null) this.EndCall.call(this);
};

CWndChoice.prototype.OnResize = function() {
    if(!this.ActiveFlag)  return;

    this.Yc = Base.HeightGame/2;

    this.updateElements();
    this.BgImg.obj.scale.set(1,Base.HeightGame/960);
};
