
CPanel = function (papa,threads,group) {
    this.Papa = papa; //papa is Game
    this.Threads = threads;
    this.Group = group;
    this.ActiveFlag = false;

    this.Buttons = [];
    this.Imgs = [];
    this.Texts = [];
    this.TextVecs = [];

    this.Xc = 0;
    this.Yc = 0;

    this.ImgsNum  = 0;
    this.TextsNum = 0;
    this.TextVecsNum = 0;
    this.ButtonsNum = 0;

    this.ShiftX = 0;
    this.ShiftY = 0;

    this.Alpha = 1;
    this.Scale = 1;
};

CPanel.prototype.OnResize = function() {

};

CPanel.prototype.updateImg = function(img) {
    img.img.x = this.Xc + img.x + this.ShiftX ;
    img.img.y = this.Yc + img.y + this.ShiftY;
    img.img.alpha = this.Alpha*img.alphaCoeff;
    img.img.scale.set(this.Scale*img.scaleCoeff);
};

CPanel.prototype.updateButton = function(butt) {
    butt.butt.x = this.Xc + butt.x + this.ShiftX;
    butt.butt.y = this.Yc + butt.y + this.ShiftY;
    butt.butt.alpha = this.Alpha;
    butt.butt.scale.set(this.Scale*butt.scaleCoeff);
};

CPanel.prototype.updateText = function(text) {
    text.text.x = this.Xc + text.x + this.ShiftX;
    text.text.y = this.Yc + text.y + this.ShiftY;
    text.text.alpha = this.Alpha;
    text.text.scale.set(this.Scale*text.scaleCoeff);
};

CPanel.prototype.updateTextVec = function(text) {
    text.text.x = this.Xc + text.x + this.ShiftX;
    text.text.y = this.Yc + text.y + this.ShiftY;
    text.text.alpha = this.Alpha;
    text.text.scale.set(this.Scale*text.scaleCoeff);
};

CPanel.prototype.updateElements = function() {

    for(var i=0;i<this.ImgsNum;i++) {
        if(this.Imgs[i].img!=null)
        {
            this.updateImg(this.Imgs[i]);
        }
    }
    for(i=0;i<this.ButtonsNum;i++) {
        if(this.Buttons[i].butt!=null)
        {
            this.updateButton(this.Buttons[i]);
        }
    }
    for(i=0;i<this.TextsNum;i++) {
        if(this.Texts[i].text!=null)
        {
            this.updateText(this.Texts[i]);
        }
    }
    for(i=0;i<this.TextVecsNum;i++) {
        if(this.TextVecs[i].text!=null)
        {
            this.updateText(this.TextVecs[i]);
        }
    }
};

CPanel.prototype.addImg = function(x,y,tex,frameName,order)
{
    if(this.Imgs[this.ImgsNum]==undefined)
        this.Imgs[this.ImgsNum] = {x:0,y:0,img:null};
    var obj = this.Imgs[this.ImgsNum];
    this.ImgsNum++;

    //x,y,tex,frameName,group,order
    obj.img = this.Papa.getZeroImg(this.Xc+x+ this.ShiftX,this.Yc+y+ this.ShiftY,tex,frameName,this.Group,order);
    obj.x = x ;
    obj.y = y ;
    obj.scaleCoeff = 1;
    obj.scalingFlag = false;
    obj.alphaCoeff = 1;
    obj.img.anchor.set(0.5);
    obj.img.Order = order;
    return obj;
};

CPanel.prototype.addBitmapText = function(x,y,font,str,size,order)
{
    if(this.Texts[this.TextsNum]==undefined)
        this.Texts[this.TextsNum] = {x:0,y:0,text:null};
    var obj = this.Texts[this.TextsNum];
    this.TextsNum++;

    //x,y,font,str,size,group
    obj.text = this.Papa.getBitmapText(this.Xc+x+ this.ShiftX,this.Yc+y+ this.ShiftY,font,str,size,this.Group);
    obj.x = x ;
    obj.y = y ;
    obj.scaleCoeff = 1;
    obj.text.Order = order;
    return obj;
};

CPanel.prototype.addText = function(x,y,text,group,order)
{
    if(this.TextVecs[this.TextVecsNum]==undefined)
        this.TextVecs[this.TextVecsNum] = {x:0,y:0,obj:null};
    var obj = this.TextVecs[this.TextVecsNum];
    this.TextVecsNum++;
    group.add(text);
    //x,y,font,str,size,group
    obj.text =  text;
    obj.x = x ;
    obj.y = y ;
    obj.scaleCoeff = 1;
    obj.text.Order = order;
    return obj;
};

CPanel.prototype.addButton = function(x,y,tex,frames,callback,callbackContext,order,tween)
{
    if(this.Buttons[this.ButtonsNum]==undefined)
        this.Buttons[this.ButtonsNum] = {x:0,y:0,butt:null};
    var obj = this.Buttons[this.ButtonsNum];
    this.ButtonsNum++;

    /*  obj.butt = this.Papa.game.make.button(0, 0, tex,callback,callbackContext,
     frames[0],frames[1],frames[2],frames[3]);
     obj.x = x;
     obj.y = y;
     obj.butt.Order = order;
     this.Group.add(obj.butt);*/

    //x,y,tex,frames,callback,callbackContext,group
    obj.butt = this.Papa.getButton(this.Xc+x+ this.ShiftX,this.Yc+y+ this.ShiftY,
        tex,frames,callback,callbackContext,this.Group,tween);
    obj.butt.anchor.set(0.5);
    obj.x = x ;
    obj.y = y ;
    obj.scaleCoeff = 1;
    obj.butt.Order = order;
    return obj;
};


//###############################

CDownPanel = function (papa,threads,group) {

    CPanel.call(this,papa,threads,group);

    this.Pads = [];
    this.MaxTextSpan = 190;
    this.ShiftMax = -102 + globleData.bottomBarHOld; //底部区域的位置兼容
    // alert('bottomBarHOld:'+globleData.bottomBarHOld)
  //  this.ShiftMin = 0;
    this.MoveTween = null;
    this.BoosterTween = null;
    this.MovingFlag = false;
    this.ButtBalanceFrames = ['balance.png','balance.png','balance.png','balance.png'];
    this.ButtWithdrawFrames = ['withdraw.png','withdraw.png','withdraw.png','withdraw.png'];
    this.ButtBonusFrames = ['innerBonus.png','innerBonus.png','innerBonus.png','innerBonus.png']
};

CDownPanel.prototype = Object.create(CPanel.prototype);
CDownPanel.prototype.constructor = CDownPanel;

CDownPanel.prototype.create = function() {

    //  CPanel.prototype.create.call(Base.Xc,Base.Yc - Base.HeightGame/2);
    this.Xc = Base.Width/2;//Base.Xc;
    this.Yc = Base.Yc + Base.HeightGame/2 - this.ShiftMax;
    this.Y_top =  Base.Yc + Base.HeightGame/2;

    this.BgImg = this.addImg(0,0,'atlas','mainBottomPanel.png',0);
    this.BgImg.img.anchor.set(0.5,1);
    this.Height = this.BgImg.img.height + globleData.bottomBarHOld;

    this.BoosterScale = 1;
    this.BoosterRx = 75/2;
    this.BoosterRy = 90/2;
    this.BoosterImg = this.addImg(265,-140,'atlas','boosterIcon.png',0);
    this.BoosterImg.img.anchor.set(0.5,0.95);
    this.BoosterImg.img.visible = true;
    this.BoosterFlag = true;
    this.BoosterScalingFlag = false;
    
    // 添加的红包及余额按钮
    this.bonusButton = this.addButton(0,-185, 'newimg', this.ButtBonusFrames, this.OnBonusButton, this, 1);
    this.Papa.game.tweens.create(this.bonusButton.butt.scale)
        .to({ x: 1.0, y: 1.0 }, 400, Phaser.Easing.Cubic.Out, true, 600)
        .onComplete.addOnce(function () {
        this.Papa.game.tweens.create(this.bonusButton.butt.scale)
            .to({ x: 1.05, y: 1.05 }, 200 * 2, Phaser.Easing.Sinusoidal.Out, false, 0)
            .to({ x: 0.95, y: 0.95 }, 400 * 2, Phaser.Easing.Sinusoidal.InOut, false, 0)
            .to({ x: 1.0, y: 1.0 }, 200 * 2, Phaser.Easing.Sinusoidal.In, true, 0)
            .loop();
    }, this);
    this.balanceButton = this.addButton(-250,-185, 'newimg', this.ButtBalanceFrames, this.OnBalanceButton, this, 1);
    this.withdrawButton = this.addButton(-250,-185, 'newimg', this.ButtWithdrawFrames, this.OnWithdrawButton, this, 1, 1);
    this.withdrawTImg = this.addImg(-250,-152,'newimg','withdraword.png',0);
    var balanceText =  this.Papa.game.add.text(0,0,  globleData.profile.amount+"元",
        { font: "18px FontVector", fill: "#FFFFFF", align: "center" });
    this.balanceText = this.addText(-253,-138,balanceText,this.Group,1)
    this.balanceText.text.anchor.set(0.5,1)
    if (!globleData.profile.amount) {
        appBoot.fetchProfile((btn)=> {
            this.balanceText.text.text = globleData.profile.amount+"元"
        })
    }
    //增加关闭弹窗回调
    if(globleData.inAPP){
        dsBridge.register('childViewClose',(data, response)=>{
          appBoot.fetchProfile(()=> {
                this.balanceText.text.text = globleData.profile.amount+"元"
          })
        })
    }
    if (globleData.appStorage.hasRed) {
        this.balanceButton.butt.visible = false;
        this.balanceText.text.visible = false;
    }else{
        this.withdrawTImg.img.visible = false;
        this.withdrawButton.butt.visible = false;
    }
    this.newSpeaker = this.addImg(-150,-255,'newimg','speaker.png',1);
    this.newSpeaker.img.anchor.set(0.5,0.5);
    var speakText =  this.Papa.game.add.text(0,0,  '',
        { font: "18px FontVector", fill: "#a29fdc", align: "center" });
    this.speakText = this.addText(-120,-240,speakText,this.Group,1)
    this.speakText.text.anchor.set(0,1)
    // this.speakTextY = this.speakText.text
    this.createSpeaker()
    var bonusText =  this.Papa.game.add.text(0,0, (globleData.appStorage.bonusAmt?globleData.appStorage.bonusAmt:'0.00')+"元",
        { font: "22px FontVector", fill: "#FFFFFF", align: "center" });
    this.bonusText = this.addText(0,-155,bonusText,this.Group,1)
    this.bonusText.text.anchor.set(0.5,1)
    this.Papa.game.tweens.create(this.bonusText.text.scale)
        .to({ x: 1.0, y: 1.0 }, 400, Phaser.Easing.Cubic.Out, true, 600)
        .onComplete.addOnce(function () {
        this.Papa.game.tweens.create(this.bonusText.text.scale)
            .to({ x: 1.05, y: 1.05 }, 200 * 2, Phaser.Easing.Sinusoidal.Out, false, 0)
            .to({ x: 0.95, y: 0.95 }, 400 * 2, Phaser.Easing.Sinusoidal.InOut, false, 0)
            .to({ x: 1.0, y: 1.0 }, 200 * 2, Phaser.Easing.Sinusoidal.In, true, 0)
            .loop();
    }, this);
    //底部增加红包end
    

      /*  if(Base.Coins<Base.BoostersPrice[0]) {
           // this.BoosterImg.img.visible = false;
           // this.BoosterFlag = false;
        } */

       // this.SelImg =  this.addImg(0,0,'atlas','redOverlay.png',0);
      //  this.SelImg.img.visible = false;
    this.SelPadIndex = -1;

    var step = this.BgImg.img.width/3;
    this.Pads[0] = {x:0,y:0,rx:0,ry:0,sx:-step,sy:-65,w:210,h:130,label:null,top:null,waitTime:2};
    this.Pads[1] = {x:0,y:0,rx:0,ry:0,sx:0,sy:-65,w:210,h:130,label:null,top:null,waitTime:2};
    this.Pads[2] = {x:0,y:0,rx:0,ry:0,sx:step,sy:-65,w:210,h:130,label:null,top:null,waitTime:4};

    this.addImg(-step,-70,'atlas','changeIcon.png',0);
    this.addImg(-step-25,-112,'atlas','coinIcon.png',0);

     //   this.Pads[0].label = this.addBitmapText(-step,-22,'MainFont','change number',22,1);
     //   this.Pads[0].top = this.addBitmapText(-step-10,-112,'MainFont','x20',22,1);
    var text =  this.Papa.game.add.text(0, 0,  sgLang.change[Base.Lang],
        { font: "20px FontVector", fill: "#FFFFFF", align: "center" });
    this.Pads[0].label =  this.addText(-step,-5,text,this.Group,1);
    this.Pads[0].label.text.anchor.set(0.5,1);
    text =  this.Papa.game.add.text(0, 0, 'x20',{ font: "22px FontVector", fill: "#FFFFFF", align: "center" });
    this.Pads[0].top =  this.addText(-step-10,-112,text,this.Group,1);
    this.Pads[0].top.text.anchor.set(0,0.5);

    this.addImg(0,-73,'atlas','bombIcon.png',0);
    this.addImg(-25,-112,'atlas','coinIcon.png',0);
    //  this.Pads[1].label = this.addBitmapText(0,-22,'MainFont','clear random number',22,1);
    //    this.Pads[1].top = this.addBitmapText(-10,-112,'MainFont','x25',22,1);
     text =  this.Papa.game.add.text(0, 0, sgLang.clear[Base.Lang],
        { font: "20px FontVector", fill: "#FFFFFF", align: "center" });
    this.Pads[1].label =  this.addText(0,-5,text,this.Group,1);
    this.Pads[1].label.text.anchor.set(0.5,1);
    text =  this.Papa.game.add.text(0, 0, 'x25', { font: "22px FontVector", fill: "#FFFFFF", align: "center" });
    this.Pads[1].top =  this.addText(-10,-112,text,this.Group,1);
    this.Pads[1].top.text.anchor.set(0,0.5);

    this.addImg(step,-64,'atlas','freezeIcon.png',0);
    this.addImg(step-25,-112,'atlas','coinIcon.png',0);
  //  this.Pads[2].label = this.addBitmapText(step,-22,'MainFont','freeze time',22,1);
  //  this.Pads[2].top = this.addBitmapText(step-10,-112,'MainFont','x30',22,1);
    text =  this.Papa.game.add.text(0, 0, sgLang.freeze[Base.Lang],
        { font: "20px FontVector", fill: "#FFFFFF", align: "center" });
    this.Pads[2].label = this.addText(step,-5,text,this.Group,1);
    this.Pads[2].label.text.anchor.set(0.5,1);
    text =  this.Papa.game.add.text(0, 0, 'x30', { font: "22px FontVector", fill: "#FFFFFF", align: "center" });
    this.Pads[2].top =  this.addText(step-10,-112,text,this.Group,1);
    this.Pads[2].top.text.anchor.set(0,0.5);

    this.Reds = [null,null,null];

    for(var i=0;i<this.Pads.length;i++) {

        this.Pads[i].x = this.Xc +  this.Pads[i].sx;
        this.Pads[i].y = this.Yc +  this.Pads[i].sy;
        this.Pads[i].rx = this.Pads[i].w/2;
        this.Pads[i].ry = this.Pads[i].h/2;

        if (this.Pads[i].label.text.width > this.MaxTextSpan) {
            this.Pads[i].label.scaleCoeff = this.MaxTextSpan / this.Pads[i].label.text.width;
            this.updateText(this.Pads[i].label);
        }
    }

    this.updateReds();
    
    this.BoosterScalingFlag = false;
  //  this.SelImg.img.visible = false;
    this.SelPadIndex = -1;
    this.ClickAllowFlag = true;
    this.WaitFlag = false;
    this.MovingFlag = false;
    this.State = 0;
    this.ActiveFlag = true;
};
CDownPanel.prototype.showBalance = function() {
    this.balanceButton.butt.visible = true;
    this.balanceText.text.text = globleData.profile.amount + '元';
    this.balanceText.text.visible = true;
    this.withdrawTImg.img.visible = false;
    this.withdrawButton.butt.visible = false;
}
CDownPanel.prototype.showWithdraw = function() {
    this.withdrawTImg.img.visible = true;
    this.withdrawButton.butt.visible = true;
    this.balanceButton.butt.visible = false;
    this.balanceText.text.visible = false;
}
CDownPanel.prototype.createSpeaker = function() {
    

    var igame = this.Papa.game;
    var _this = this;

    var textY = this.speakText.text.y;

    var notifyCreate = (data, index)=> {
        if (!textY) textY = this.speakText.text.y
      var str = "";
      if(!data || data.length <= 0){
        return;
      }
      if(index >= data.length){
        index = 0;
      }

      if(typeof data[index] == 'string'){
        data[index] = JSON.parse(data[index]);
      }

      if(data[index].name && data[index].amount){
        _this.speakText.text.text = data[index].name+"提现"+data[index].amount+"元成功"
         _this.speakText.text.y = textY + 20
        
        var alpha1_time = 400;
        var alpha0_time = 800;
        var delay_time = 800;

        igame.add.tween(_this.speakText.text).to( {y: textY, alpha: 1}, alpha1_time, Phaser.Easing.Linear.None, true).onComplete.add(function(item) {    
          igame.add.tween(_this.speakText.text).to( {y: textY - 20, alpha: 0}, alpha0_time, Phaser.Easing.Linear.None, true, delay_time).onComplete.add(function(item) {             
              index = index+1;
              notifyCreate(data, index);
          },_this);
        },_this);
      }else{
        index = index+1;
        notifyCreate(data, index);
      }
    }            
    appBoot.fetchNotice((data)=> {
        notifyCreate(data,0)
    })
}
CDownPanel.prototype.createPopIcon = function() {
    // debugger
    var iconShake = this.addImg(0,-this.Y_top+100,'newimg','withdraw.png',1);
    iconShake.img.anchor.set(0.5,0.5);
    var igame = this.Papa.game;
    var _this = this;

    iconShake.img.scale.setTo(1.5);
        igame.add.tween(iconShake.img).to( { x: Base.Width/2, y: Base.HeightGame/2 - 100}, 500, Phaser.Easing.Linear.None, true).onComplete.add(function() {             
          igame.add.tween(iconShake.img.scale).to( { x: 1.8, y: 1.8 }, 300, Phaser.Easing.Linear.None, true).onComplete.add(function() {
            igame.add.tween(iconShake.img.scale).to( { x: 1.3, y: 1.3 }, 300, Phaser.Easing.Linear.None, true).onComplete.add(function() {
                igame.add.tween(iconShake.img).to( { x: 75,y:  Base.HeightGame - 90 }, 300, Phaser.Easing.Linear.None, true).onComplete.add(function() {
                    iconShake.img.destroy();
                },this.Papa);
            },_this);
          },_this);
    },_this);
}
CDownPanel.prototype.Revive = function() {

    this.Xc = Base.Width/2;//Base.Xc;
    this.Yc = Base.Yc + Base.HeightGame/2 - this.ShiftMax;
    this.Y_top =  Base.Yc + Base.HeightGame/2;

    this.ShiftX = 0;
    this.ShiftY = 0;
    this.updateElements();

   // this.BoosterFlag = true;
    this.BoosterScalingFlag = false;
   /* if(Base.Coins<Base.BoostersPrice[0]) {
     //   this.BoosterImg.img.visible = false;
     //   this.BoosterFlag = false;
    }
    else
    {
        this.BoosterScale = 1;
        this.BoosterImg.scaleCoeff = this.BoosterScale;
        this.BoosterImg.img.scale.set(this.Scale*this.BoosterImg.scaleCoeff);
        this.BoosterImg.img.alpha = 1;
    } */

    this.BoosterScale = 1;
    this.BoosterImg.scaleCoeff = this.BoosterScale;
    this.BoosterImg.img.scale.set(this.Scale*this.BoosterImg.scaleCoeff);
    this.BoosterImg.img.alpha = 1;

    this.balanceButton.scaleCoeff = this.BoosterScale;
    this.balanceButton.butt.scale.set(this.Scale*this.balanceButton.scaleCoeff);
    this.balanceButton.butt.alpha = 1;

    this.balanceText.scaleCoeff = this.BoosterScale;
    this.balanceText.test.scale.set(this.Scale*this.balanceText.scaleCoeff);
    this.balanceText.test.alpha = 1;

    this.withdrawButton.scaleCoeff = this.BoosterScale;
    this.withdrawButton.butt.scale.set(this.Scale*this.withdrawButton.scaleCoeff);
    this.withdrawButton.butt.alpha = 1;

    this.withdrawTImg.scaleCoeff = this.BoosterScale;
    this.withdrawTImg.img.scale.set(this.Scale*this.withdrawTImg.scaleCoeff);
    this.withdrawTImg.img.alpha = 1;


    this.updateReds();

    this.ClickAllowFlag = true;
    this.WaitFlag = false;
    this.MovingFlag = false;
    this.State = 0;
    this.ActiveFlag = true;
};

CDownPanel.prototype.OnClick = function(x,y) { //底部闪电的点击

    if(this.MovingFlag)  return;

    if(!this.ClickAllowFlag) return;

    if(y<(this.Y_top-this.Height))  return;

  //  if(this.State==2)  return; // wait state
    // debugger
    if(this.State==0) {
        // debugger
        // down state
      //  console.log("y "+(y));
       // console.log("state 0 "+(this.Yc));
     //   if(y<(this.Y_top-this.HeightSmall))  return;

        var xb = this.Xc + this.BoosterImg.x + this.ShiftX;
        var yb = this.Yc + this.BoosterImg.y + this.ShiftY - this.BoosterRy;
        if(x>(xb-this.BoosterRx) && x<(xb+this.BoosterRx) &&
            y>(yb-this.BoosterRy) && y<(yb+this.BoosterRy)) {

            if(Base.Coins<Base.BoostersPrice[0])
            {
                this.Papa.makeNoCoinsText(Base.Width/2,450);
                return;
            }

            this.bonusText.text.visible = false
            this.bonusButton.butt.visible = false
            this.newSpeaker.img.visible = false;
            this.speakText.text.visible = false;        
            this.setMove(0,this.ShiftMax - globleData.bottomBarHOld,0.5,null);
            this.scaleBooster(this.BoosterScale,0,0.5);
            this.setWait(4);
            this.State = 1;
        }
    }
    else {
        // debugger
        var index = -1;
        for(var i=0;i<this.Pads.length;i++) {
            if(x>(this.Pads[i].x-this.Pads[i].rx) && x<(this.Pads[i].x+this.Pads[i].rx))
            {
               //console.log("pad ok "+i);
                if(Base.BoostersPrice[i]<=Base.Coins) {
                    index = i;
                    break;
                }
                else
                {
                    if(Base.VideoFlag)
                        this.Papa.setCoinsWnd();
                    else
                        this.Papa.makeNoCoinsText(this.Pads[i].x,200);
                    return;
                }
            }
        }

        if(index<0)  return;

        if(this.Papa.MakeBooster(index))
        {
            this.setWait(0.1);
         //   this.setSelPad(index);
            this.ClickAllowFlag = false; // allow at end
           // this.State = 2; // some effect of bonus, wait
        }
    }
};

CDownPanel.prototype.scaleBooster = function(scale,dest,time) {
    this.BoosterScale = scale;
    this.BoosterImg.scaleCoeff = this.BoosterScale;
    this.BoosterImg.img.scale.set(this.Scale*this.BoosterImg.scaleCoeff);
    this.BoosterImg.img.alpha = 1;

    this.balanceButton.scaleCoeff = this.BoosterScale;
    this.balanceButton.butt.scale.set(this.Scale*this.balanceButton.scaleCoeff);
    this.balanceButton.butt.alpha = 1;

    this.balanceText.scaleCoeff = this.BoosterScale;
    this.balanceText.text.scale.set(this.Scale*this.balanceText.scaleCoeff);
    this.balanceText.text.alpha = 1;

    this.withdrawButton.scaleCoeff = this.BoosterScale;
    this.withdrawButton.butt.scale.set(this.Scale*this.withdrawButton.scaleCoeff);
    this.withdrawButton.butt.alpha = 1;

    this.withdrawTImg.scaleCoeff = this.BoosterScale;
    this.withdrawTImg.img.scale.set(this.Scale*this.withdrawTImg.scaleCoeff);
    this.withdrawTImg.img.alpha = 1;


    // debugger
    // this.bonusButton.scaleCoeff = this.BoosterScale;
    // this.bonusButton.butt.scale.set(this.Scale*this.bonusButton.scaleCoeff)
    // this.bonusButton.butt.visible = 1;

    // this.bonusText.scaleCoeff = this.BoosterScale;
    // this.bonusText.text.scale.set(this.Scale*this.bonusText.scaleCoeff)
    // this.bonusText.text.visible = 1;

    if(this.BoosterTween==null)  this.BoosterTween = new CTween();
    this.BoosterTween.createEasingInOut(this);
    this.BoosterTween.to({BoosterScale:dest}, time,true,this.OnBoosterScaleEnd,this);
    this.BoosterTween.start();
    this.BoosterImg.img.alpha = 1;
    if(!this.BoosterScalingFlag)
       this.Threads.addThread(this,this.updateBooster);
    this.BoosterScalingFlag = true;
};

CDownPanel.prototype.OnBoosterScaleEnd = function() {
    this.Threads.removeThread(this,this.updateBooster);
    if(this.BoosterScale<0.1) {
        this.BoosterImg.img.alpha = 0;

        this.bonusButton.butt.alpha = 0;
        this.bonusText.text.alpha = 0;
        this.balanceButton.butt.alpha = 0;
        this.balanceText.text.alpha = 0;
        this.withdrawButton.butt.alpha = 0;
        this.withdrawTImg.img.alpha = 0;
        // this.newSpeaker.img.visible = 0;
        // this.speakText.text.visible = 0;
    }else{
        this.bonusButton.butt.visible = 1;
        this.bonusText.text.visible = 1;
        this.newSpeaker.img.visible = 1;
        this.speakText.text.visible = 1;        
    }
    this.BoosterScalingFlag = false;
  //  console.log("booster scaled "+ this.BoosterImg.img.y + "   "+this.BoosterImg.scaleCoeff);
};

CDownPanel.prototype.updateBooster = function() {
    this.BoosterTween.update();
    this.BoosterImg.scaleCoeff = this.BoosterScale;
    this.BoosterImg.img.scale.set(this.Scale*this.BoosterImg.scaleCoeff);

    this.balanceButton.scaleCoeff = this.BoosterScale;
    this.balanceButton.butt.scale.set(this.Scale*this.balanceButton.scaleCoeff);
    this.balanceText.scaleCoeff = this.BoosterScale;
    this.balanceText.text.scale.set(this.Scale*this.balanceText.scaleCoeff);
    this.withdrawButton.scaleCoeff = this.BoosterScale;
    this.withdrawButton.butt.scale.set(this.Scale*this.withdrawButton.scaleCoeff);
    this.withdrawTImg.scaleCoeff = this.BoosterScale;
    this.withdrawTImg.img.scale.set(this.Scale*this.withdrawTImg.scaleCoeff);
    this.newSpeaker.scaleCoeff = this.BoosterScale;
    this.newSpeaker.img.scale.set(this.Scale*this.newSpeaker.scaleCoeff);
    this.speakText.scaleCoeff = this.BoosterScale;
    this.speakText.text.scale.set(this.Scale*this.speakText.scaleCoeff);

    // this.bonusButton.scaleCoeff = this.BoosterScale;
    // this.bonusButton.butt.scale.set(this.Scale*this.bonusButton.scaleCoeff);
    this.bonusText.scaleCoeff = this.BoosterScale;
    this.bonusText.text.scale.set(this.Scale*this.bonusText.scaleCoeff);

};

CDownPanel.prototype.OnCoinsChange = function(coins) {
/*
     if(this.BoosterFlag) {
        if(Base.Coins<Base.BoostersPrice[0]) {
           if(this.State==0)
                this.scaleBooster(this.BoosterScale,0,0.5);
             this.BoosterFlag = false;
        }
    }
    else {
        if(Base.Coins>=Base.BoostersPrice[0]) {
            this.BoosterImg.img.visible = true;
            this.BoosterImg.img.alpha = 0;
            if(this.State==0) {
                this.scaleBooster(0, 1, 0.5);
            }
            this.BoosterFlag = true;
        }
    }   */

    this.updateReds();
};

CDownPanel.prototype.updateReds = function() {
    for(var i=0;i<3;i++) {
        if(Base.Coins<Base.BoostersPrice[i]) {
            if(this.Reds[i]===null) {
                this.Reds[i] = this.addImg(this.Pads[i].sx,this.Pads[i].sy,
                    'atlas','redOverlay.png',0);
                this.updateImg( this.Reds[i]);
            }
            this.Reds[i].img.visible = true;
        }
        if(Base.Coins>=Base.BoostersPrice[i]) {
            if(this.Reds[i]!==null)
              this.Reds[i].img.visible = false;
        }
    }
};

CDownPanel.prototype.setDown = function() {
    this.setMove(0,0,0.5,this.OnDownComplete);
    this.State =  0;
    this.offWait();
};
CDownPanel.prototype.OnBonusButton = function() {
    this.Papa.PlaySnd(Base.SndButton);
   html.gotoWebpage('/bonus','分红数字')
}
CDownPanel.prototype.OnBalanceButton = function() {
    if (globleData.refreshCash) {//提现的时候每点击一次取一次余额
        appBoot.fetchProfile(function(btn) {
            globleData.refreshCash = false;
            this.Papa.setOpenPop(1);
            this.balanceText.text.text = globleData.profile.amount+"元"
        })                    
    }else{
        this.Papa.setOpenPop(1);
    }
    console.log('click balance')
    
}
CDownPanel.prototype.OnWithdrawButton = function() {
    // this.showBalance()
    this.Papa.setOpenPop(2);
    console.log('click withdraw')
}
CDownPanel.prototype.OnDownComplete = function() {
  // if(this.BoosterFlag)
       this.scaleBooster(this.BoosterScale,1,0.5);
};

CDownPanel.prototype.setWait = function(time) {
    if(this.WaitFlag) {
        this.WaitTimeCntr += time;
        return;
    }

    this.WaitTimeCntr = time;
    this.Threads.addThread(this,this.updateWait);
    this.WaitFlag = true;
};

CDownPanel.prototype.offWait = function() {
    if(this.WaitFlag)
       this.Threads.removeThread(this,this.updateWait);
    this.WaitFlag = false;
};

CDownPanel.prototype.updateWait = function() {
    this.WaitTimeCntr -= Base.RealTimeInt;
    if(this.WaitTimeCntr<0) {
      //  console.log("set down");
        this.setDown();
        //this.setMove = function(x,y,time,func);
    }
};

CDownPanel.prototype.OnActionOver = function(type) {

   // this.SelImg.img.visible = false;
    this.SelPadIndex = -1;
    this.ClickAllowFlag = true;
   // this.State = 0;
};

CDownPanel.prototype.OnResize = function() {
   // this.Xc = Base.Width/2;//Base.Xc;
    this.Yc = Base.Yc + Base.HeightGame/2 - this.ShiftMax;
    this.Y_top =  Base.Yc + Base.HeightGame/2;
    this.updateElements();
};

CDownPanel.prototype.setMove = function(x,y,time,func)
{
    this.MoveNormX = x - this.ShiftX;
    this.MoveNormY = y - this.ShiftY;
    var dist = Math.sqrt(this.MoveNormX*this.MoveNormX+this.MoveNormY*this.MoveNormY);
    if(dist>0) {
        this.MoveNormX = this.MoveNormX / dist;
        this.MoveNormY = this.MoveNormY / dist;
    }
    else {
        this.MoveNormX = 0;
        this.MoveNormY = 0;
    }
    this.ShiftXdest = x;
    this.ShiftYdest = y;
    this.ShiftX0 = this.ShiftX;
    this.ShiftY0 = this.ShiftY;
    this.MoveDist = 0;
    if(this.MoveTween==null)  this.MoveTween = new CTween();
    if(!this.MovingFlag) this.MoveTween.createEasingInOut(this);
    this.MoveTween.to({MoveDist:dist}, time,true,this.OnMovingEnd,this);
    this.MoveFunc = func;
    if(!this.MovingFlag)
      this.Threads.addThread(this,this.updateMove);
    this.MovingFlag = true;
};

CDownPanel.prototype.updateMove = function()
{
    this.ShiftX = this.ShiftX0 + this.MoveDist*this.MoveNormX;
    this.ShiftY = this.ShiftY0 + this.MoveDist*this.MoveNormY;
    this.updateElements();
    this.MoveTween.update();
};

CDownPanel.prototype.OnMovingEnd = function()
{
    this.MovingFlag = false;
    this.ShiftX = this.ShiftXdest;
    this.ShiftY = this.ShiftYdest;
    this.updateElements();

    this.Threads.removeThread(this,this.updateMove);
    if(this.MoveFunc!=null) this.MoveFunc.call(this);
};


//#################################
//顶部区域的按钮
CMainPanel = function (papa,threads,group) {

    CPanel.call(this,papa,threads,group);

    this.ButtPauseFrames = ['pauseB.png','pauseB.png','pauseB.png','pauseB.png'];
    this.ButtCoinsFrames = ['plusButton.png','plusButton.png','plusButton.png','plusButton.png'];
};

CMainPanel.prototype = Object.create(CPanel.prototype);
CMainPanel.prototype.constructor = CMainPanel;

CMainPanel.prototype.create = function() {

    //  CPanel.prototype.create.call(Base.Xc,Base.Yc - Base.HeightGame/2);
    this.Xc = Base.Width/2;//Base.Xc;
    this.Yc = Base.Yc - Base.HeightGame/2;

    this.BgImg = this.addImg(0,0,'atlas','mainTopPanel.png',0);
    this.BgImg.img.anchor.set(0.5,0);
    console.log(this.BgImg)
    this.PauseButton = this.addButton(-270,54+globleData.statusBarH - 30,'atlas',this.ButtPauseFrames,this.OnPauseButton,this,1);

    this.addImg(-120,54+globleData.statusBarH - 30,'atlas','scoreIcon.png',0);
    this.addImg(225,54+globleData.statusBarH - 30,'atlas','coinPanel.png',0);
    this.addImg(0,54+globleData.statusBarH - 30,'atlas','behindScore.png',0);

    this.CoinsButtonFlag = false;
    if(Base.VideoFlag &&  Base.RewardAdFlag!=false) {
        this.CoinsButton = this.addButton(225 + 70, 55 + globleData.statusBarH - 30, 'atlas', this.ButtCoinsFrames, this.OnCoinsButton, this, 1);
        this.CoinsButton.butt.scale.set(1.3,1.3)
        this.CoinsButtonFlag = true;
    }

    this.ScoreText =  this.addBitmapText(0,28+globleData.statusBarH - 30,'GoldFont',''+Base.Score,85,0);
    this.CoinsText =  this.addBitmapText(240,32+globleData.statusBarH - 30,'GoldFont',''+Base.Coins,70,0);
};

CMainPanel.prototype.setScore = function(score) {
    this.ScoreText.text.setText(''+score);
};

CMainPanel.prototype.setCoins = function(coins) {

    var scale = 1;
   // var coins = 2000;
    if(coins>=20000) scale = 0.75;
    if(coins>=200000) scale = 0.7;
    if(coins>=2000000) scale = 0.65;

    this.CoinsText.scaleCoeff = scale;
    this.updateText(this.CoinsText);

    this.CoinsText.text.setText(''+coins);
};

CMainPanel.prototype.PauseOn = function() {
    this.PauseButton.butt.input.enabled = false;
    if(this.CoinsButtonFlag)
       this.CoinsButton.butt.input.enabled = false;
};

CMainPanel.prototype.PauseOff = function() {
    this.PauseButton.butt.input.enabled = true;
    if(this.CoinsButtonFlag)
       this.CoinsButton.butt.input.enabled = true;
};

CMainPanel.prototype.OnCoinsButton = function() {
    // debugger
    //点击金币按钮
    // this.Papa.setResults();
    this.Papa.setCoinsWnd();
};

CMainPanel.prototype.OnPauseButton = function() {
   // this.Papa.setResults();
     this.Papa.setPause();
    // this.Papa.setChoice();
   // this.PauseButton.butt.input.enabled = false;
};

CMainPanel.prototype.OnResize = function() {
   // this.Xc = Base.Width/2;//Base.Xc;
   // this.Yc = Base.Yc - Base.HeightGame/2;
   // this.updateElements();
};

//#########################


