//app存储相关方法
var appBoot = {
  setLocalStorage : function(data){
    if (data) {
      globleData.appStorage = JSON.parse(data)
      localStorage[globleData.appData] = JSON.parse(data)
      if (globleData.appStorage.block) {
        let blockCon = globleData.appStorage.block;
        if (blockCon.gameDataCacheKey) localStorage['gameDataCacheKey'] = blockCon.gameDataCacheKey
        if (blockCon.soundState) localStorage['soundState'] = blockCon.soundState
        if (blockCon.record) localStorage['record'] = blockCon.record
        if (blockCon.musicState) localStorage['musicState'] = blockCon.musicState
        if (blockCon.guide) localStorage['guide'] = blockCon.guide
      }
    }else{
      if (localStorage[globleData.appData]) 
          globleData.appStorage = JSON.parse(localStorage[globleData.appData]);
    }
    // debugger
    if (!globleData.appStorage.block) {
      globleData.appStorage.block = {
        gameDataCacheKey:'',
        soundState:'',
        record:'',
        musicState:'',
        guide:''
      }// 游戏变量

    }
    //开始游戏
    appBoot.init();
  },
  //localStorage get set special data end
  saveDataToApp : function(){
    // debugger
    if(globleData.inAPP && dsBridge.hasNativeMethod('updateDBValue')){
      var obj={
        key: globleData.appData,
        value: JSON.stringify(globleData.appStorage),
        deleteflag: false
      };
      dsBridge.call('updateDBValue',obj,function(){})
    }else{
      localStorage[globleData.appData] = JSON.stringify(globleData.appStorage)
    }
  },
  removeToApp : function(key){  
    if(globleData.inAPP && dsBridge.hasNativeMethod('updateDBValue')){
      globleData.appStorage.block[key] = ''
      var obj={
        key: globleData.appData,
        value: JSON.stringify(globleData.appStorage),
        deleteflag: false
      };
      dsBridge.call('updateDBValue',obj,function(){})
    }else{
      // debugger
      globleData.appStorage.block[key] = '';
      console.log(globleData.appStorage)
      localStorage[globleData.appData] = JSON.stringify(globleData.appStorage)
    }
  },
  getFromApp : function(key){
    if(globleData.inAPP && dsBridge.hasNativeMethod('getDBValueWithKey')){
      var str = dsBridge.call('getDBValueWithKey',key);
      return str;
    }else{
      return '';
    }
  },
  getFromAppLocalStorage : function(){
    
    if(globleData.inAPP){
      // alert('getDBValueWithKey');
      dsBridge.call('getDBValueWithKey',globleData.appData,function(data){
        appBoot.setLocalStorage(data);
      })
    }else{
      appBoot.setLocalStorage('');
    }
  },
  setStorageValue : function(key,value,type) {
    if (type) { //存储游戏特殊
      globleData.appStorage[type][key] = value
    }else{
      globleData.appStorage[key] = value
    }
    appBoot.saveDataToApp();
  },
  fetchProfile : function(callback){//获取个人信息
    html.fetch({
      url:"/red/userinfo",
      data:"uid="+globleData.uid+"&os="+globleData.OSTYPE+"&version="+globleData.appStorage.appVersion+"&web_ver=20200220",
      success : function (resData){
        if (resData.success) {
          globleData.profile = resData.result;
          if (callback) {
            callback()
          }
        }
      },
    })
  },
  fetchRandom : function(){//获取随机数设置
    html.fetch({
      url:"/red/fetch_limit",
      data:"uid="+globleData.uid+"&gtype="+globleData.GTYPE,
      success : function (resData){
        if (resData.success) {
          globleData.randomData = resData.result;
        }
      },
    })
  },
  fetchBonus : function(callback){//获取分红六角
    html.fetch({
      url:"/multigames/bonus_amt",
      data:"uid="+globleData.uid+"&gtype="+globleData.GTYPE,
      success : function (resData){
        if (resData.success) {
          globleData.bonus_amt = resData.result;
          if (callback) callback()
        }
      },
    })
  },
  fetchNotice : function(callback){//获取世界通知
    html.fetch({
      url:"/multigames/fetch_notify",
      data:"uid="+globleData.uid+"&gtype="+globleData.GTYPE+"&start=0&count=100",
      success : function (resData){
        if (resData.success) {
          callback(resData.result)
        }
      },
    })
  },
  dsAdResult(){ //广告回调接收
    if(globleData.isAdResult){
        return;
    }
    // alert("dsAdResult g_dsPos="+g_dsPos);
    dsBridge.register('adresult', function(data, responseCallback) { //全屏广告跳过app回的是失败 noad=true        
        var state = globleData.dsState;
        var pos = globleData.dsPos;
        var callback = globleData.dsCallback;
        
        if(typeof data == 'string'){
            data = JSON.parse(data);
        }
        // alert(JSON.stringify(data))
        globleData.isAdResult = 1;
        if (data.name == pos) {
          if(data.display == undefined){
              // alert("广告播放失败");
              callback(false);
          }else{
            if (data.display) {
              // alert("广告播放成功");
              callback(true);
            }else{
              // alert("广告播放失败");
              callback(false);
            }
          }
        }
    })
  },
  showAdBase : function(pos, callback){//获取游戏广告

    html.fetch({
      url:"/multigames/sys_config",
      data:"uid="+globleData.uid+"&os="+globleData.OSTYPE+"&gtype="+globleData.GTYPE+"&pos="+pos,
      success : function (resData){
        // alert(JSON.stringify(resData))
        if (resData.success) {
          var result = resData.result;
          var state = resData.result.position;
          if(state[pos].show_rate > 0){
            
            if (globleData.inAPP) {
              // alert('开始播放广告')
              dsBridge.call('displayAD',state[pos],function(){})
              globleData.dsState = state[pos];
              globleData.dsPos = pos;
              globleData.dsCallback = callback;
            }else{
              callback(true);
              // appBoot.showToast(4)
            }
          }else{
            if(typeof callback == "function"){
              callback(false);
              // appBoot.showToast(5)
            }
          }
        }else{
          if(typeof callback == "function"){
            // appBoot.showToast(6)
            callback(false);
          }      
        }
      },
      error : callback
    })
  },
  fetchRedPacket: function(callback){//看广告获取随机红包金额
    if(navigator.onLine == false){
      callback(false, "offline")
      return;
    }
    if(!globleData.inAPP){
      if(typeof callback == "function"){
        var str = {type: "amount", number: "0.12", balance_info: "89.34", red_count: null};
        callback(true, str);
        if(globleData.appStorage.firstOpen){
          appBoot.setStorageValue('firstOpen',false);
        }
      }
      return;
    }
    var tmNow = (new Date()).getTime();
    var hash = "";
    // alert('before calcHash')
    dsBridge.call('calcHash', globleData.uid+tmNow ,function(data, response){
      hash = data;
      html.fetch({
        url:"/red/red_packet",
        data:"uid="+globleData.uid+"&hash="+hash+"&ver="+globleData.appStorage.appVersion+"&tm="+tmNow,
        success : function (resData){
          if (resData.success) {
            var resultData = resData.result;
              // alert('calcHash成功')
              // alert(JSON.stringify(resultData))
              if(resultData.type == 'amount'){
                callback(true, resultData)
              }else{
                callback(false)
              }
          }
        },
        error : callback
      })  
    })
  },
  openRedpacket: function(success){
    if (!success) {
      appBoot.showToast()
      globleData.btnClicked = false;
      return;
    }
    appBoot.fetchRedPacket(function(flag,data) {
      if (flag) { //开红包成功才改变状态
        appBoot.setStorageValue('hasRed',false)
        globleData.rabValue = data.number
        globleData.profile.amount = data.balance_info
        if (globleData.gameCallback) {
          // alert('开红包回调成功')
          globleData.gameCallback(true) //开红包后，显示余额
        }
      }else{
        appBoot.showToast()
      }
      // body...
    })
  },
  showToast: function(text){
    html.getDom('.errorTips').innerHTML = text || '播放视频失败，请稍后再试';
    appBoot.showPop('.showToast');
    globleData.btnClicked = false;
    setTimeout(function(argument) {
      appBoot.closePop('.showToast');
    },3000)
  },
  closePop: function(name){ //show页面元素
    var nameArry = name.split(',')
    for (var i = 0; i < nameArry.length; i++) {
      html.getDom(nameArry[i]).style.display = 'none'
    }
  },
  showPop: function(name){ //hide页面元素
    var nameArry = name.split(',')
    for (var i = 0; i < nameArry.length; i++) {
      html.getDom(nameArry[i]).style.display = 'block'
    }
  },
  exitApp: function() {
    dsBridge.call('exitApp', function(data, response){})
  },
  
  startGameLoadPre: function(){

    /***获取页面基本数据***/ 
    globleData.uid = html.getQueryValue("uid");
    globleData.token = unescape(html.getQueryValue("token"));
    // globleData.channel = html.getQueryValue("appchannel") || '';
    globleData.OSTYPE = html.browser.versions.ios ? 'ios' : 'android';
    // debugger
    globleData.inAPP = html.browser.versions.app;
    globleData.statusBarH = Number(html.getQueryValue("statusBarH"));
    globleData.bottomBarH = Number(html.getQueryValue("bottomBarH"));
    globleData.bottomBarHOld = Number(html.getQueryValue("bottomBarH"));
    globleData.bottomBarH = 0;
    globleData.statusBarHOld = Number(html.getQueryValue("statusBarH"));
    if(globleData.statusBarH < 44 && globleData.statusBarH > 0){
      globleData.statusBarH = 44;
    }
    
    if(!globleData.uid){ 
      dsBridge.call('exitApp', function(data, response){})
    }
    appBoot.dsAdResult();
    appBoot.fetchProfile();
    appBoot.fetchRandom(); //获取随机数控制
    
    appBoot.getFromAppLocalStorage();

  },
  init: function(){
    // debugger
    //新开始游戏
    new GameMain();
    // startGame();
  },
};
appBoot.startGameLoadPre();









